
module MenhirBasics = struct
  
  exception Error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | YIELDS
    | WHILE
    | VARLPAR of (
# 31 "lang/parser.mly"
       (string)
# 17 "lang/parser.ml"
  )
    | VARLBRA of (
# 32 "lang/parser.mly"
       (string)
# 22 "lang/parser.ml"
  )
    | VAR of (
# 30 "lang/parser.mly"
       (string)
# 27 "lang/parser.ml"
  )
    | UNDERSCORE
    | UMINUS
    | TRY
    | TO
    | TIMES
    | TIME of (
# 40 "lang/parser.mly"
       (int option list)
# 37 "lang/parser.ml"
  )
    | TILD
    | THEN
    | STRING of (
# 35 "lang/parser.mly"
       (string )
# 44 "lang/parser.ml"
  )
    | SLASH
    | SET
    | SEQSEQ
    | SEQ
    | RPAR
    | REPLACES
    | REGEXP of (
# 36 "lang/parser.mly"
       (string * char list )
# 55 "lang/parser.ml"
  )
    | RCUR
    | RBRA
    | QUESTION
    | PP_STRING of (
# 33 "lang/parser.mly"
       (string * Pos.t)
# 63 "lang/parser.ml"
  )
    | PP_REGEXP of (
# 34 "lang/parser.mly"
       (string * char list * Pos.t)
# 68 "lang/parser.ml"
  )
    | PP_INT_DOT_LCUR of (
# 37 "lang/parser.mly"
       (int)
# 73 "lang/parser.ml"
  )
    | PP_INCLUDE of (
# 75 "lang/parser.mly"
       (string)
# 78 "lang/parser.ml"
  )
    | PP_IFVERSION of (
# 70 "lang/parser.mly"
       ([ `Eq | `Geq | `Leq | `Gt | `Lt] * string)
# 83 "lang/parser.ml"
  )
    | PP_IFNENCODER
    | PP_IFNDEF of (
# 69 "lang/parser.mly"
       (string)
# 89 "lang/parser.ml"
  )
    | PP_IFENCODER
    | PP_IFDEF of (
# 69 "lang/parser.mly"
       (string)
# 95 "lang/parser.ml"
  )
    | PP_ENDL
    | PP_ENDIF
    | PP_ELSE
    | PP_DEFINE
    | PP_DEF of (
# 73 "lang/parser.mly"
       (Parser_helper.lexer_let_decoration)
# 104 "lang/parser.ml"
  )
    | PP_COMMENT of (
# 76 "lang/parser.mly"
       (string list)
# 109 "lang/parser.ml"
  )
    | OPEN
    | NOT
    | MINUS
    | LPAR
    | LETLBRA of (
# 45 "lang/parser.mly"
       (Parser_helper.lexer_let_decoration)
# 118 "lang/parser.ml"
  )
    | LET of (
# 44 "lang/parser.mly"
       (Parser_helper.lexer_let_decoration)
# 123 "lang/parser.ml"
  )
    | LCUR
    | LBRA
    | INTERVAL of (
# 41 "lang/parser.mly"
       (int option list * int option list)
# 130 "lang/parser.ml"
  )
    | INT of (
# 37 "lang/parser.mly"
       (int)
# 135 "lang/parser.ml"
  )
    | IF
    | GETS
    | GET
    | FUN
    | FOR
    | FLOAT of (
# 38 "lang/parser.mly"
       (float)
# 145 "lang/parser.ml"
  )
    | EOF
    | END
    | ENCODER of (
# 42 "lang/parser.mly"
       (string)
# 152 "lang/parser.ml"
  )
    | ELSIF
    | ELSE
    | DOTVAR of (
# 56 "lang/parser.mly"
       (string)
# 159 "lang/parser.ml"
  )
    | DOTDOTDOT
    | DOT
    | DO
    | DEF of (
# 48 "lang/parser.mly"
       ((Doc.item * (string*string) list * (string*string) list)*Parser_helper.let_decoration)
# 167 "lang/parser.ml"
  )
    | COMMA
    | COLONCOLON
    | COLON
    | COALESCE
    | CATCH
    | BOOL of (
# 39 "lang/parser.mly"
       (bool)
# 177 "lang/parser.ml"
  )
    | BINB of (
# 60 "lang/parser.mly"
       (string)
# 182 "lang/parser.ml"
  )
    | BIN3 of (
# 63 "lang/parser.mly"
       (string)
# 187 "lang/parser.ml"
  )
    | BIN2 of (
# 62 "lang/parser.mly"
       (string)
# 192 "lang/parser.ml"
  )
    | BIN1 of (
# 61 "lang/parser.mly"
       (string)
# 197 "lang/parser.ml"
  )
    | BEGIN
    | ARGS_OF
  
end

include MenhirBasics

# 23 "lang/parser.mly"
  
open Term
open Term.Ground
(* All auxiliary functions for parser are there *)
open Parser_helper

# 213 "lang/parser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState000 : ('s, _menhir_box_annotate) _menhir_state
    (** State 000.
        Stack shape : .
        Start symbol: annotate. *)

  | MenhirState003 : (('s, _menhir_box_annotate) _menhir_cell1_annotate_metadata_entry, _menhir_box_annotate) _menhir_state
    (** State 003.
        Stack shape : annotate_metadata_entry.
        Start symbol: annotate. *)

  | MenhirState006 : (('s, _menhir_box_annotate) _menhir_cell1_annotate_key, _menhir_box_annotate) _menhir_state
    (** State 006.
        Stack shape : annotate_key.
        Start symbol: annotate. *)

  | MenhirState017 : ('s, _menhir_box_annotate_metadata_entry) _menhir_state
    (** State 017.
        Stack shape : .
        Start symbol: annotate_metadata_entry. *)

  | MenhirState020 : (('s, _menhir_box_annotate_metadata_entry) _menhir_cell1_annotate_key, _menhir_box_annotate_metadata_entry) _menhir_state
    (** State 020.
        Stack shape : annotate_key.
        Start symbol: annotate_metadata_entry. *)

  | MenhirState023 : ('s, _menhir_box_interactive) _menhir_state
    (** State 023.
        Stack shape : .
        Start symbol: interactive. *)

  | MenhirState025 : (('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_state
    (** State 025.
        Stack shape : WHILE.
        Start symbol: <undetermined>. *)

  | MenhirState026 : (('s, 'r) _menhir_cell1_VARLPAR, 'r) _menhir_state
    (** State 026.
        Stack shape : VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState027 : (('s, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_state
    (** State 027.
        Stack shape : VARLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState030 : (('s, 'r) _menhir_cell1_UMINUS _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 030.
        Stack shape : UMINUS LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState031 : (('s, 'r) _menhir_cell1_TRY, 'r) _menhir_state
    (** State 031.
        Stack shape : TRY.
        Start symbol: <undetermined>. *)

  | MenhirState037 : (('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_state
    (** State 037.
        Stack shape : OPEN.
        Start symbol: <undetermined>. *)

  | MenhirState038 : (('s, 'r) _menhir_cell1_NOT, 'r) _menhir_state
    (** State 038.
        Stack shape : NOT.
        Start symbol: <undetermined>. *)

  | MenhirState039 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 039.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState041 : (('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 041.
        Stack shape : LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState043 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 043.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState044 : (('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_state
    (** State 044.
        Stack shape : LBRA.
        Start symbol: <undetermined>. *)

  | MenhirState047 : (('s, 'r) _menhir_cell1_IF, 'r) _menhir_state
    (** State 047.
        Stack shape : IF.
        Start symbol: <undetermined>. *)

  | MenhirState048 : (('s, 'r) _menhir_cell1_LETLBRA, 'r) _menhir_state
    (** State 048.
        Stack shape : LETLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState050 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 050.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState051 : (('s, 'r) _menhir_cell1_GET, 'r) _menhir_state
    (** State 051.
        Stack shape : GET.
        Start symbol: <undetermined>. *)

  | MenhirState053 : (('s, 'r) _menhir_cell1_FUN _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 053.
        Stack shape : FUN LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState056 : (('s, 'r) _menhir_cell1_TILD _menhir_cell0_VAR, 'r) _menhir_state
    (** State 056.
        Stack shape : TILD VAR.
        Start symbol: <undetermined>. *)

  | MenhirState057 : ((('s, 'r) _menhir_cell1_TILD _menhir_cell0_VAR, 'r) _menhir_cell1_GETS, 'r) _menhir_state
    (** State 057.
        Stack shape : TILD VAR GETS.
        Start symbol: <undetermined>. *)

  | MenhirState058 : (((('s, 'r) _menhir_cell1_TILD _menhir_cell0_VAR, 'r) _menhir_cell1_GETS, 'r) _menhir_cell1_UNDERSCORE, 'r) _menhir_state
    (** State 058.
        Stack shape : TILD VAR GETS UNDERSCORE.
        Start symbol: <undetermined>. *)

  | MenhirState059 : (('s, 'r) _menhir_cell1_GETS, 'r) _menhir_state
    (** State 059.
        Stack shape : GETS.
        Start symbol: <undetermined>. *)

  | MenhirState060 : (('s, 'r) _menhir_cell1_FOR, 'r) _menhir_state
    (** State 060.
        Stack shape : FOR.
        Start symbol: <undetermined>. *)

  | MenhirState062 : ((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 062.
        Stack shape : FOR optvar.
        Start symbol: <undetermined>. *)

  | MenhirState064 : (('s, 'r) _menhir_cell1_ENCODER, 'r) _menhir_state
    (** State 064.
        Stack shape : ENCODER.
        Start symbol: <undetermined>. *)

  | MenhirState065 : ((('s, 'r) _menhir_cell1_ENCODER, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 065.
        Stack shape : ENCODER LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState067 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 067.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState069 : (('s, 'r) _menhir_cell1_BEGIN, 'r) _menhir_state
    (** State 069.
        Stack shape : BEGIN.
        Start symbol: <undetermined>. *)

  | MenhirState071 : (('s, 'r) _menhir_cell1_DEF, 'r) _menhir_state
    (** State 071.
        Stack shape : DEF.
        Start symbol: <undetermined>. *)

  | MenhirState074 : ((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 074.
        Stack shape : DEF VAR.
        Start symbol: <undetermined>. *)

  | MenhirState076 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 076.
        Stack shape : VAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState079 : (('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 079.
        Stack shape : LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState081 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 081.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState083 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 083.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState086 : (('s, 'r) _menhir_cell1_UNDERSCORE, 'r) _menhir_state
    (** State 086.
        Stack shape : UNDERSCORE.
        Start symbol: <undetermined>. *)

  | MenhirState088 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 088.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState089 : (('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_state
    (** State 089.
        Stack shape : LBRA.
        Start symbol: <undetermined>. *)

  | MenhirState090 : (('s, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_state
    (** State 090.
        Stack shape : DOTDOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState094 : (('s, 'r) _menhir_cell1_tuple_pattern, 'r) _menhir_state
    (** State 094.
        Stack shape : tuple_pattern.
        Start symbol: <undetermined>. *)

  | MenhirState097 : ((('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_cell1_spread, 'r) _menhir_state
    (** State 097.
        Stack shape : LBRA spread.
        Start symbol: <undetermined>. *)

  | MenhirState100 : (('s, 'r) _menhir_cell1_pattern_list, 'r) _menhir_state
    (** State 100.
        Stack shape : pattern_list.
        Start symbol: <undetermined>. *)

  | MenhirState105 : (('s, 'r) _menhir_cell1_list_pattern, 'r) _menhir_state
    (** State 105.
        Stack shape : list_pattern.
        Start symbol: <undetermined>. *)

  | MenhirState111 : ((('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_cell1_pattern_list, 'r) _menhir_state
    (** State 111.
        Stack shape : LBRA pattern_list.
        Start symbol: <undetermined>. *)

  | MenhirState113 : (((('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_cell1_pattern_list, 'r) _menhir_cell1_spread, 'r) _menhir_state
    (** State 113.
        Stack shape : LBRA pattern_list spread.
        Start symbol: <undetermined>. *)

  | MenhirState121 : (('s, 'r) _menhir_cell1_meth_pattern_el, 'r) _menhir_state
    (** State 121.
        Stack shape : meth_pattern_el.
        Start symbol: <undetermined>. *)

  | MenhirState124 : ((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 124.
        Stack shape : DEF LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState126 : (((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_state
    (** State 126.
        Stack shape : DEF LPAR pattern.
        Start symbol: <undetermined>. *)

  | MenhirState127 : (('s, 'r) _menhir_cell1_VARLPAR, 'r) _menhir_state
    (** State 127.
        Stack shape : VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState130 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_VARLPAR, 'r) _menhir_state
    (** State 130.
        Stack shape : VAR VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState140 : (('s, 'r) _menhir_cell1_ty_content_arg, 'r) _menhir_state
    (** State 140.
        Stack shape : ty_content_arg.
        Start symbol: <undetermined>. *)

  | MenhirState144 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_VAR _menhir_cell0_VARLPAR, 'r) _menhir_state
    (** State 144.
        Stack shape : VAR VAR VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState149 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_VAR _menhir_cell0_VAR _menhir_cell0_VARLPAR, 'r) _menhir_state
    (** State 149.
        Stack shape : VAR VAR VAR VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState154 : (('s, 'r) _menhir_cell1_VAR _menhir_cell0_ty_content, 'r) _menhir_state
    (** State 154.
        Stack shape : VAR ty_content.
        Start symbol: <undetermined>. *)

  | MenhirState161 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 161.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState163 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 163.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState164 : (('s, 'r) _menhir_cell1_LCUR, 'r) _menhir_state
    (** State 164.
        Stack shape : LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState166 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 166.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState167 : (('s, 'r) _menhir_cell1_LBRA, 'r) _menhir_state
    (** State 167.
        Stack shape : LBRA.
        Start symbol: <undetermined>. *)

  | MenhirState177 : (('s, 'r) _menhir_cell1_ty _menhir_cell0_LCUR, 'r) _menhir_state
    (** State 177.
        Stack shape : ty LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState181 : (('s, 'r) _menhir_cell1_STRING _menhir_cell0_VAR _menhir_cell0_VAR, 'r) _menhir_state
    (** State 181.
        Stack shape : STRING VAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState186 : (('s, 'r) _menhir_cell1_meth_ty, 'r) _menhir_state
    (** State 186.
        Stack shape : meth_ty.
        Start symbol: <undetermined>. *)

  | MenhirState194 : (('s, 'r) _menhir_cell1_QUESTION _menhir_cell0_VAR, 'r) _menhir_state
    (** State 194.
        Stack shape : QUESTION VAR.
        Start symbol: <undetermined>. *)

  | MenhirState199 : (('s, 'r) _menhir_cell1_ty _menhir_cell0_TIMES, 'r) _menhir_state
    (** State 199.
        Stack shape : ty TIMES.
        Start symbol: <undetermined>. *)

  | MenhirState203 : (('s, 'r) _menhir_cell1_argty, 'r) _menhir_state
    (** State 203.
        Stack shape : argty.
        Start symbol: <undetermined>. *)

  | MenhirState208 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_argsty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 208.
        Stack shape : LPAR argsty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState211 : ((((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 211.
        Stack shape : DEF LPAR pattern ty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState213 : (((((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_cell1_g, 'r) _menhir_state
    (** State 213.
        Stack shape : DEF LPAR pattern ty RPAR g.
        Start symbol: <undetermined>. *)

  | MenhirState217 : (('s, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 217.
        Stack shape : optvar.
        Start symbol: <undetermined>. *)

  | MenhirState218 : ((('s, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 218.
        Stack shape : optvar expr.
        Start symbol: <undetermined>. *)

  | MenhirState219 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TO, 'r) _menhir_state
    (** State 219.
        Stack shape : expr TO.
        Start symbol: <undetermined>. *)

  | MenhirState220 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TO, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 220.
        Stack shape : expr TO expr.
        Start symbol: <undetermined>. *)

  | MenhirState221 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TIMES, 'r) _menhir_state
    (** State 221.
        Stack shape : expr TIMES.
        Start symbol: <undetermined>. *)

  | MenhirState222 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_TIMES, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 222.
        Stack shape : expr TIMES expr.
        Start symbol: <undetermined>. *)

  | MenhirState224 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT _menhir_cell0_VARLPAR, 'r) _menhir_state
    (** State 224.
        Stack shape : expr DOT VARLPAR.
        Start symbol: <undetermined>. *)

  | MenhirState226 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 226.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState227 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 227.
        Stack shape : VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState228 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_SET, 'r) _menhir_state
    (** State 228.
        Stack shape : expr SET.
        Start symbol: <undetermined>. *)

  | MenhirState229 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_SET, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 229.
        Stack shape : expr SET expr.
        Start symbol: <undetermined>. *)

  | MenhirState230 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_state
    (** State 230.
        Stack shape : expr QUESTION.
        Start symbol: <undetermined>. *)

  | MenhirState231 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 231.
        Stack shape : expr QUESTION expr.
        Start symbol: <undetermined>. *)

  | MenhirState232 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_MINUS, 'r) _menhir_state
    (** State 232.
        Stack shape : expr MINUS.
        Start symbol: <undetermined>. *)

  | MenhirState233 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_MINUS, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 233.
        Stack shape : expr MINUS expr.
        Start symbol: <undetermined>. *)

  | MenhirState234 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COLONCOLON, 'r) _menhir_state
    (** State 234.
        Stack shape : expr COLONCOLON.
        Start symbol: <undetermined>. *)

  | MenhirState235 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COLONCOLON, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 235.
        Stack shape : expr COLONCOLON expr.
        Start symbol: <undetermined>. *)

  | MenhirState236 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN3, 'r) _menhir_state
    (** State 236.
        Stack shape : expr BIN3.
        Start symbol: <undetermined>. *)

  | MenhirState237 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN3, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 237.
        Stack shape : expr BIN3 expr.
        Start symbol: <undetermined>. *)

  | MenhirState238 : ((((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COLON, 'r) _menhir_state
    (** State 238.
        Stack shape : expr QUESTION expr COLON.
        Start symbol: <undetermined>. *)

  | MenhirState240 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COALESCE, 'r) _menhir_state
    (** State 240.
        Stack shape : expr COALESCE.
        Start symbol: <undetermined>. *)

  | MenhirState241 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COALESCE, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 241.
        Stack shape : expr COALESCE expr.
        Start symbol: <undetermined>. *)

  | MenhirState242 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BINB, 'r) _menhir_state
    (** State 242.
        Stack shape : expr BINB.
        Start symbol: <undetermined>. *)

  | MenhirState243 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BINB, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 243.
        Stack shape : expr BINB expr.
        Start symbol: <undetermined>. *)

  | MenhirState244 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN2, 'r) _menhir_state
    (** State 244.
        Stack shape : expr BIN2.
        Start symbol: <undetermined>. *)

  | MenhirState245 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN2, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 245.
        Stack shape : expr BIN2 expr.
        Start symbol: <undetermined>. *)

  | MenhirState246 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN1, 'r) _menhir_state
    (** State 246.
        Stack shape : expr BIN1.
        Start symbol: <undetermined>. *)

  | MenhirState247 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_BIN1, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 247.
        Stack shape : expr BIN1 expr.
        Start symbol: <undetermined>. *)

  | MenhirState249 : (('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 249.
        Stack shape : ARGS_OF LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState250 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_state
    (** State 250.
        Stack shape : ARGS_OF LPAR VARLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState252 : (('s, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 252.
        Stack shape : VAR.
        Start symbol: <undetermined>. *)

  | MenhirState255 : (('s, 'r) _menhir_cell1_GET _menhir_cell0_VAR, 'r) _menhir_state
    (** State 255.
        Stack shape : GET VAR.
        Start symbol: <undetermined>. *)

  | MenhirState263 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 263.
        Stack shape : ARGS_OF LPAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState266 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 266.
        Stack shape : VAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState269 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_subfield_lbra, 'r) _menhir_state
    (** State 269.
        Stack shape : ARGS_OF LPAR subfield_lbra.
        Start symbol: <undetermined>. *)

  | MenhirState275 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 275.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState277 : (('s, 'r) _menhir_cell1_app_list_elem, 'r) _menhir_state
    (** State 277.
        Stack shape : app_list_elem.
        Start symbol: <undetermined>. *)

  | MenhirState281 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT _menhir_cell0_VARLBRA, 'r) _menhir_state
    (** State 281.
        Stack shape : expr DOT VARLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState282 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT _menhir_cell0_VARLBRA, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 282.
        Stack shape : expr DOT VARLBRA expr.
        Start symbol: <undetermined>. *)

  | MenhirState285 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DOT _menhir_cell0_LCUR, 'r) _menhir_state
    (** State 285.
        Stack shape : expr DOT LCUR.
        Start symbol: <undetermined>. *)

  | MenhirState291 : (('s, 'r) _menhir_cell1_record _menhir_cell0_VAR, 'r) _menhir_state
    (** State 291.
        Stack shape : record VAR.
        Start symbol: <undetermined>. *)

  | MenhirState292 : ((('s, 'r) _menhir_cell1_record _menhir_cell0_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 292.
        Stack shape : record VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState295 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 295.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState297 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 297.
        Stack shape : expr s.
        Start symbol: <undetermined>. *)

  | MenhirState299 : (('s, 'r) _menhir_cell1_binding, 'r) _menhir_state
    (** State 299.
        Stack shape : binding.
        Start symbol: <undetermined>. *)

  | MenhirState300 : ((('s, 'r) _menhir_cell1_binding, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 300.
        Stack shape : binding s.
        Start symbol: <undetermined>. *)

  | MenhirState302 : (('s, 'r) _menhir_cell1__let, 'r) _menhir_state
    (** State 302.
        Stack shape : _let.
        Start symbol: <undetermined>. *)

  | MenhirState304 : ((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 304.
        Stack shape : _let VAR.
        Start symbol: <undetermined>. *)

  | MenhirState306 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_VAR, 'r) _menhir_state
    (** State 306.
        Stack shape : VAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState307 : ((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 307.
        Stack shape : _let LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState309 : (((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_state
    (** State 309.
        Stack shape : _let LPAR pattern.
        Start symbol: <undetermined>. *)

  | MenhirState312 : ((((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 312.
        Stack shape : _let LPAR pattern ty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState313 : (((((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 313.
        Stack shape : _let LPAR pattern ty RPAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState315 : ((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_subfield, 'r) _menhir_state
    (** State 315.
        Stack shape : _let subfield.
        Start symbol: <undetermined>. *)

  | MenhirState316 : (((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_subfield, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 316.
        Stack shape : _let subfield expr.
        Start symbol: <undetermined>. *)

  | MenhirState318 : ((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_pattern, 'r) _menhir_state
    (** State 318.
        Stack shape : _let pattern.
        Start symbol: <undetermined>. *)

  | MenhirState319 : (((('s, 'r) _menhir_cell1__let, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 319.
        Stack shape : _let pattern expr.
        Start symbol: <undetermined>. *)

  | MenhirState320 : ((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_varlpar, 'r) _menhir_state
    (** State 320.
        Stack shape : DEF varlpar.
        Start symbol: <undetermined>. *)

  | MenhirState321 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 321.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState323 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 323.
        Stack shape : LPAR optvar.
        Start symbol: <undetermined>. *)

  | MenhirState325 : (((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 325.
        Stack shape : LPAR optvar ty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState328 : (('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 328.
        Stack shape : ARGS_OF LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState329 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_state
    (** State 329.
        Stack shape : ARGS_OF LPAR VARLBRA.
        Start symbol: <undetermined>. *)

  | MenhirState335 : ((('s, 'r) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, 'r) _menhir_cell1_subfield_lbra, 'r) _menhir_state
    (** State 335.
        Stack shape : ARGS_OF LPAR subfield_lbra.
        Start symbol: <undetermined>. *)

  | MenhirState341 : (('s, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 341.
        Stack shape : optvar.
        Start symbol: <undetermined>. *)

  | MenhirState344 : (((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_varlpar, 'r) _menhir_cell1_arglist _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 344.
        Stack shape : DEF varlpar arglist RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState345 : ((((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_varlpar, 'r) _menhir_cell1_arglist _menhir_cell0_RPAR, 'r) _menhir_cell1_g, 'r) _menhir_state
    (** State 345.
        Stack shape : DEF varlpar arglist RPAR g.
        Start symbol: <undetermined>. *)

  | MenhirState349 : (('s, 'r) _menhir_cell1_arg, 'r) _menhir_state
    (** State 349.
        Stack shape : arg.
        Start symbol: <undetermined>. *)

  | MenhirState351 : ((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_subfield, 'r) _menhir_state
    (** State 351.
        Stack shape : DEF subfield.
        Start symbol: <undetermined>. *)

  | MenhirState352 : (((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_subfield, 'r) _menhir_cell1_g, 'r) _menhir_state
    (** State 352.
        Stack shape : DEF subfield g.
        Start symbol: <undetermined>. *)

  | MenhirState355 : ((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_pattern, 'r) _menhir_state
    (** State 355.
        Stack shape : DEF pattern.
        Start symbol: <undetermined>. *)

  | MenhirState356 : (((('s, 'r) _menhir_cell1_DEF, 'r) _menhir_cell1_pattern, 'r) _menhir_cell1_g, 'r) _menhir_state
    (** State 356.
        Stack shape : DEF pattern g.
        Start symbol: <undetermined>. *)

  | MenhirState361 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 361.
        Stack shape : VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState363 : (('s, 'r) _menhir_cell1_STRING, 'r) _menhir_state
    (** State 363.
        Stack shape : STRING.
        Start symbol: <undetermined>. *)

  | MenhirState364 : ((('s, 'r) _menhir_cell1_STRING, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 364.
        Stack shape : STRING expr.
        Start symbol: <undetermined>. *)

  | MenhirState365 : (('s, 'r) _menhir_cell1_ENCODER, 'r) _menhir_state
    (** State 365.
        Stack shape : ENCODER.
        Start symbol: <undetermined>. *)

  | MenhirState370 : (('s, 'r) _menhir_cell1_encoder_param, 'r) _menhir_state
    (** State 370.
        Stack shape : encoder_param.
        Start symbol: <undetermined>. *)

  | MenhirState373 : (((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 373.
        Stack shape : FOR optvar expr.
        Start symbol: <undetermined>. *)

  | MenhirState374 : ((((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DO, 'r) _menhir_state
    (** State 374.
        Stack shape : FOR optvar expr DO.
        Start symbol: <undetermined>. *)

  | MenhirState377 : ((('s, 'r) _menhir_cell1_GETS, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 377.
        Stack shape : GETS expr.
        Start symbol: <undetermined>. *)

  | MenhirState382 : (('s, 'r) _menhir_cell1_TILD _menhir_cell0_LPAR _menhir_cell0_VAR, 'r) _menhir_state
    (** State 382.
        Stack shape : TILD LPAR VAR.
        Start symbol: <undetermined>. *)

  | MenhirState384 : ((('s, 'r) _menhir_cell1_TILD _menhir_cell0_LPAR _menhir_cell0_VAR, 'r) _menhir_cell1_ty _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 384.
        Stack shape : TILD LPAR VAR ty RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState388 : ((('s, 'r) _menhir_cell1_FUN _menhir_cell0_LPAR, 'r) _menhir_cell1_arglist _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 388.
        Stack shape : FUN LPAR arglist RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState389 : (((('s, 'r) _menhir_cell1_FUN _menhir_cell0_LPAR, 'r) _menhir_cell1_arglist _menhir_cell0_RPAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 389.
        Stack shape : FUN LPAR arglist RPAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState390 : ((('s, 'r) _menhir_cell1_GET, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 390.
        Stack shape : GET expr.
        Start symbol: <undetermined>. *)

  | MenhirState391 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 391.
        Stack shape : VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState393 : (('s, 'r) _menhir_cell1_let_opt_el, 'r) _menhir_state
    (** State 393.
        Stack shape : let_opt_el.
        Start symbol: <undetermined>. *)

  | MenhirState398 : ((('s, 'r) _menhir_cell1_IF, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_state
    (** State 398.
        Stack shape : IF exprs THEN.
        Start symbol: <undetermined>. *)

  | MenhirState399 : (((('s, 'r) _menhir_cell1_IF, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 399.
        Stack shape : IF exprs THEN exprs.
        Start symbol: <undetermined>. *)

  | MenhirState400 : (((('s, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_ELSIF, 'r) _menhir_state
    (** State 400.
        Stack shape : exprs THEN exprs ELSIF.
        Start symbol: <undetermined>. *)

  | MenhirState402 : ((((('s, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_ELSIF, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_state
    (** State 402.
        Stack shape : exprs THEN exprs ELSIF exprs THEN.
        Start symbol: <undetermined>. *)

  | MenhirState403 : (((((('s, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_ELSIF, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 403.
        Stack shape : exprs THEN exprs ELSIF exprs THEN exprs.
        Start symbol: <undetermined>. *)

  | MenhirState404 : (((('s, 'r) _menhir_cell1_exprs _menhir_cell0_THEN, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_ELSE, 'r) _menhir_state
    (** State 404.
        Stack shape : exprs THEN exprs ELSE.
        Start symbol: <undetermined>. *)

  | MenhirState409 : (('s, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_state
    (** State 409.
        Stack shape : DOTDOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState410 : ((('s, 'r) _menhir_cell1_DOTDOTDOT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 410.
        Stack shape : DOTDOTDOT expr.
        Start symbol: <undetermined>. *)

  | MenhirState412 : (('s, 'r) _menhir_cell1_inner_list_item, 'r) _menhir_state
    (** State 412.
        Stack shape : inner_list_item.
        Start symbol: <undetermined>. *)

  | MenhirState414 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 414.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState417 : ((('s, 'r) _menhir_cell1_VAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 417.
        Stack shape : VAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState423 : (('s, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 423.
        Stack shape : expr.
        Start symbol: <undetermined>. *)

  | MenhirState424 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_SEQ, 'r) _menhir_state
    (** State 424.
        Stack shape : expr SEQ.
        Start symbol: <undetermined>. *)

  | MenhirState428 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 428.
        Stack shape : LPAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState430 : ((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COMMA, 'r) _menhir_state
    (** State 430.
        Stack shape : expr COMMA.
        Start symbol: <undetermined>. *)

  | MenhirState432 : (((('s, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COMMA, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 432.
        Stack shape : expr COMMA expr.
        Start symbol: <undetermined>. *)

  | MenhirState433 : (((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_COLON, 'r) _menhir_state
    (** State 433.
        Stack shape : LPAR expr COLON.
        Start symbol: <undetermined>. *)

  | MenhirState436 : ((('s, 'r) _menhir_cell1_NOT, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 436.
        Stack shape : NOT expr.
        Start symbol: <undetermined>. *)

  | MenhirState437 : ((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 437.
        Stack shape : OPEN expr.
        Start symbol: <undetermined>. *)

  | MenhirState438 : (((('s, 'r) _menhir_cell1_OPEN, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_s, 'r) _menhir_state
    (** State 438.
        Stack shape : OPEN expr s.
        Start symbol: <undetermined>. *)

  | MenhirState441 : ((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_state
    (** State 441.
        Stack shape : TRY exprs.
        Start symbol: <undetermined>. *)

  | MenhirState443 : (((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 443.
        Stack shape : TRY exprs optvar.
        Start symbol: <undetermined>. *)

  | MenhirState446 : (((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_optvar, 'r) _menhir_state
    (** State 446.
        Stack shape : TRY exprs optvar.
        Start symbol: <undetermined>. *)

  | MenhirState448 : ((((('s, 'r) _menhir_cell1_TRY, 'r) _menhir_cell1_exprs, 'r) _menhir_cell1_optvar, 'r) _menhir_cell1_varlist, 'r) _menhir_state
    (** State 448.
        Stack shape : TRY exprs optvar varlist.
        Start symbol: <undetermined>. *)

  | MenhirState451 : ((('s, 'r) _menhir_cell1_UMINUS _menhir_cell0_LPAR, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 451.
        Stack shape : UMINUS LPAR expr.
        Start symbol: <undetermined>. *)

  | MenhirState455 : ((('s, 'r) _menhir_cell1_VARLBRA, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 455.
        Stack shape : VARLBRA expr.
        Start symbol: <undetermined>. *)

  | MenhirState459 : ((('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_cell1_expr, 'r) _menhir_state
    (** State 459.
        Stack shape : WHILE expr.
        Start symbol: <undetermined>. *)

  | MenhirState460 : (((('s, 'r) _menhir_cell1_WHILE, 'r) _menhir_cell1_expr, 'r) _menhir_cell1_DO, 'r) _menhir_state
    (** State 460.
        Stack shape : WHILE expr DO.
        Start symbol: <undetermined>. *)

  | MenhirState467 : ('s, _menhir_box_program) _menhir_state
    (** State 467.
        Stack shape : .
        Start symbol: program. *)

  | MenhirState473 : ('s, _menhir_box_time_predicate) _menhir_state
    (** State 473.
        Stack shape : .
        Start symbol: time_predicate. *)


and ('s, 'r) _menhir_cell1__let = 
  | MenhirCell1__let of 's * ('s, 'r) _menhir_state * (
# 114 "lang/parser.mly"
      (Parser_helper.let_decoration)
# 1161 "lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_annotate_key = 
  | MenhirCell1_annotate_key of 's * ('s, 'r) _menhir_state * (
# 115 "lang/parser.mly"
      (string)
# 1168 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_annotate_metadata_entry = 
  | MenhirCell1_annotate_metadata_entry of 's * ('s, 'r) _menhir_state * (
# 109 "lang/parser.mly"
      (string * string)
# 1175 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_app_list_elem = 
  | MenhirCell1_app_list_elem of 's * ('s, 'r) _menhir_state * (
# 119 "lang/parser.mly"
      (Parser_helper.app_list_elem)
# 1182 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_arg = 
  | MenhirCell1_arg of 's * ('s, 'r) _menhir_state * (
# 120 "lang/parser.mly"
      (Parser_helper.arglist)
# 1189 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_arglist = 
  | MenhirCell1_arglist of 's * ('s, 'r) _menhir_state * (
# 121 "lang/parser.mly"
      (Parser_helper.arglist)
# 1196 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_argsty = 
  | MenhirCell1_argsty of 's * ('s, 'r) _menhir_state * (
# 123 "lang/parser.mly"
      ((bool * string * Type.t) list)
# 1203 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_argty = 
  | MenhirCell1_argty of 's * ('s, 'r) _menhir_state * (
# 124 "lang/parser.mly"
      (bool * string * Type.t)
# 1210 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_binding = 
  | MenhirCell1_binding of 's * ('s, 'r) _menhir_state * (
# 125 "lang/parser.mly"
      (Parser_helper.binding)
# 1217 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_encoder_param = 
  | MenhirCell1_encoder_param of 's * ('s, 'r) _menhir_state * (
# 127 "lang/parser.mly"
      (Parser_helper.encoder_param)
# 1224 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_expr = 
  | MenhirCell1_expr of 's * ('s, 'r) _menhir_state * (
# 129 "lang/parser.mly"
      (Term.t)
# 1231 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_exprs = 
  | MenhirCell1_exprs of 's * ('s, 'r) _menhir_state * (
# 130 "lang/parser.mly"
      (Term.t)
# 1238 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_g = 
  | MenhirCell1_g of 's * ('s, 'r) _menhir_state * (
# 132 "lang/parser.mly"
      (unit)
# 1245 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_inner_list_item = 
  | MenhirCell1_inner_list_item of 's * ('s, 'r) _menhir_state * (
# 137 "lang/parser.mly"
      (Parser_helper.inner_list_item)
# 1252 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_let_opt_el = 
  | MenhirCell1_let_opt_el of 's * ('s, 'r) _menhir_state * (
# 140 "lang/parser.mly"
      (Parser_helper.let_opt_el)
# 1259 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_list_pattern = 
  | MenhirCell1_list_pattern of 's * ('s, 'r) _menhir_state * (
# 141 "lang/parser.mly"
      (Term.pattern)
# 1266 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_meth_pattern_el = 
  | MenhirCell1_meth_pattern_el of 's * ('s, 'r) _menhir_state * (
# 143 "lang/parser.mly"
      (Parser_helper.meth_pattern_el)
# 1273 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_meth_ty = 
  | MenhirCell1_meth_ty of 's * ('s, 'r) _menhir_state * (
# 145 "lang/parser.mly"
      (string * Type.t * string option)
# 1280 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_optvar = 
  | MenhirCell1_optvar of 's * ('s, 'r) _menhir_state * (
# 147 "lang/parser.mly"
      (string)
# 1287 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_pattern = 
  | MenhirCell1_pattern of 's * ('s, 'r) _menhir_state * (
# 148 "lang/parser.mly"
      (Term.pattern)
# 1294 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_pattern_list = 
  | MenhirCell1_pattern_list of 's * ('s, 'r) _menhir_state * (
# 149 "lang/parser.mly"
      (Term.pattern list)
# 1301 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_record = 
  | MenhirCell1_record of 's * ('s, 'r) _menhir_state * (
# 151 "lang/parser.mly"
      (Parser_helper.record)
# 1308 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_s = 
  | MenhirCell1_s of 's * ('s, 'r) _menhir_state * (
# 154 "lang/parser.mly"
      (unit)
# 1315 "lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_spread = 
  | MenhirCell1_spread of 's * ('s, 'r) _menhir_state * (
# 155 "lang/parser.mly"
      (string)
# 1322 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_subfield = 
  | MenhirCell1_subfield of 's * ('s, 'r) _menhir_state * (
# 156 "lang/parser.mly"
      (string list)
# 1329 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_subfield_lbra = 
  | MenhirCell1_subfield_lbra of 's * ('s, 'r) _menhir_state * (
# 157 "lang/parser.mly"
      (string list)
# 1336 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_tuple_pattern = 
  | MenhirCell1_tuple_pattern of 's * ('s, 'r) _menhir_state * (
# 158 "lang/parser.mly"
      (Term.pattern)
# 1343 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_ty = 
  | MenhirCell1_ty of 's * ('s, 'r) _menhir_state * (
# 159 "lang/parser.mly"
      (Type.t)
# 1350 "lang/parser.ml"
) * Lexing.position * Lexing.position

and 's _menhir_cell0_ty_content = 
  | MenhirCell0_ty_content of 's * (
# 160 "lang/parser.mly"
      (Parser_helper.ty_content)
# 1357 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_ty_content_arg = 
  | MenhirCell1_ty_content_arg of 's * ('s, 'r) _menhir_state * (
# 161 "lang/parser.mly"
      (Parser_helper.ty_content_arg)
# 1364 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_varlist = 
  | MenhirCell1_varlist of 's * ('s, 'r) _menhir_state * (
# 167 "lang/parser.mly"
      (Parser_helper.varlist)
# 1371 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_varlpar = 
  | MenhirCell1_varlpar of 's * ('s, 'r) _menhir_state * (
# 168 "lang/parser.mly"
      (string list)
# 1378 "lang/parser.ml"
)

and ('s, 'r) _menhir_cell1_ARGS_OF = 
  | MenhirCell1_ARGS_OF of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_BEGIN = 
  | MenhirCell1_BEGIN of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_BIN1 = 
  | MenhirCell1_BIN1 of 's * ('s, 'r) _menhir_state * (
# 61 "lang/parser.mly"
       (string)
# 1391 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_BIN2 = 
  | MenhirCell1_BIN2 of 's * ('s, 'r) _menhir_state * (
# 62 "lang/parser.mly"
       (string)
# 1398 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_BIN3 = 
  | MenhirCell1_BIN3 of 's * ('s, 'r) _menhir_state * (
# 63 "lang/parser.mly"
       (string)
# 1405 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_BINB = 
  | MenhirCell1_BINB of 's * ('s, 'r) _menhir_state * (
# 60 "lang/parser.mly"
       (string)
# 1412 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_COALESCE = 
  | MenhirCell1_COALESCE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_COLON = 
  | MenhirCell1_COLON of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_COLONCOLON = 
  | MenhirCell1_COLONCOLON of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_COMMA = 
  | MenhirCell1_COMMA of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DEF = 
  | MenhirCell1_DEF of 's * ('s, 'r) _menhir_state * (
# 48 "lang/parser.mly"
       ((Doc.item * (string*string) list * (string*string) list)*Parser_helper.let_decoration)
# 1431 "lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_DO = 
  | MenhirCell1_DO of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DOT = 
  | MenhirCell1_DOT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_DOTDOTDOT = 
  | MenhirCell1_DOTDOTDOT of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_ELSE = 
  | MenhirCell1_ELSE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ELSIF = 
  | MenhirCell1_ELSIF of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ENCODER = 
  | MenhirCell1_ENCODER of 's * ('s, 'r) _menhir_state * (
# 42 "lang/parser.mly"
       (string)
# 1453 "lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_FOR = 
  | MenhirCell1_FOR of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_FUN = 
  | MenhirCell1_FUN of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_GET = 
  | MenhirCell1_GET of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_GETS = 
  | MenhirCell1_GETS of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_IF = 
  | MenhirCell1_IF of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_LBRA = 
  | MenhirCell1_LBRA of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_LCUR = 
  | MenhirCell1_LCUR of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_LCUR = 
  | MenhirCell0_LCUR of 's * Lexing.position

and ('s, 'r) _menhir_cell1_LETLBRA = 
  | MenhirCell1_LETLBRA of 's * ('s, 'r) _menhir_state * (
# 45 "lang/parser.mly"
       (Parser_helper.lexer_let_decoration)
# 1484 "lang/parser.ml"
) * Lexing.position

and ('s, 'r) _menhir_cell1_LPAR = 
  | MenhirCell1_LPAR of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_LPAR = 
  | MenhirCell0_LPAR of 's * Lexing.position

and ('s, 'r) _menhir_cell1_MINUS = 
  | MenhirCell1_MINUS of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_NOT = 
  | MenhirCell1_NOT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_OPEN = 
  | MenhirCell1_OPEN of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_QUESTION = 
  | MenhirCell1_QUESTION of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_RPAR = 
  | MenhirCell0_RPAR of 's * Lexing.position

and ('s, 'r) _menhir_cell1_SEQ = 
  | MenhirCell1_SEQ of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_SET = 
  | MenhirCell1_SET of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_STRING = 
  | MenhirCell1_STRING of 's * ('s, 'r) _menhir_state * (
# 35 "lang/parser.mly"
       (string )
# 1518 "lang/parser.ml"
) * Lexing.position * Lexing.position

and 's _menhir_cell0_THEN = 
  | MenhirCell0_THEN of 's * Lexing.position

and ('s, 'r) _menhir_cell1_TILD = 
  | MenhirCell1_TILD of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_TIMES = 
  | MenhirCell1_TIMES of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and 's _menhir_cell0_TIMES = 
  | MenhirCell0_TIMES of 's * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_TO = 
  | MenhirCell1_TO of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_TRY = 
  | MenhirCell1_TRY of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_UMINUS = 
  | MenhirCell1_UMINUS of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_UNDERSCORE = 
  | MenhirCell1_UNDERSCORE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_VAR = 
  | MenhirCell1_VAR of 's * ('s, 'r) _menhir_state * (
# 30 "lang/parser.mly"
       (string)
# 1549 "lang/parser.ml"
) * Lexing.position * Lexing.position

and 's _menhir_cell0_VAR = 
  | MenhirCell0_VAR of 's * (
# 30 "lang/parser.mly"
       (string)
# 1556 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_VARLBRA = 
  | MenhirCell1_VARLBRA of 's * ('s, 'r) _menhir_state * (
# 32 "lang/parser.mly"
       (string)
# 1563 "lang/parser.ml"
) * Lexing.position * Lexing.position

and 's _menhir_cell0_VARLBRA = 
  | MenhirCell0_VARLBRA of 's * (
# 32 "lang/parser.mly"
       (string)
# 1570 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_VARLPAR = 
  | MenhirCell1_VARLPAR of 's * ('s, 'r) _menhir_state * (
# 31 "lang/parser.mly"
       (string)
# 1577 "lang/parser.ml"
) * Lexing.position * Lexing.position

and 's _menhir_cell0_VARLPAR = 
  | MenhirCell0_VARLPAR of 's * (
# 31 "lang/parser.mly"
       (string)
# 1584 "lang/parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_WHILE = 
  | MenhirCell1_WHILE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and _menhir_box_time_predicate = 
  | MenhirBox_time_predicate of (
# 112 "lang/parser.mly"
      (Term.t)
# 1594 "lang/parser.ml"
) [@@unboxed]

and _menhir_box_program = 
  | MenhirBox_program of (
# 100 "lang/parser.mly"
      (Term.t)
# 1601 "lang/parser.ml"
) [@@unboxed]

and _menhir_box_interactive = 
  | MenhirBox_interactive of (
# 103 "lang/parser.mly"
      (Term.t)
# 1608 "lang/parser.ml"
) [@@unboxed]

and _menhir_box_annotate_metadata_entry = 
  | MenhirBox_annotate_metadata_entry of (
# 109 "lang/parser.mly"
      (string * string)
# 1615 "lang/parser.ml"
) [@@unboxed]

and _menhir_box_annotate = 
  | MenhirBox_annotate of (
# 106 "lang/parser.mly"
      ((string * string) list)
# 1622 "lang/parser.ml"
) [@@unboxed]

let _menhir_action_005 =
  fun _1 ->
    (
# 453 "lang/parser.mly"
        ( Parser_helper.let_decoration_of_lexer_let_decoration _1 )
# 1630 "lang/parser.ml"
     : (
# 114 "lang/parser.mly"
      (Parser_helper.let_decoration)
# 1634 "lang/parser.ml"
    ))

let _menhir_action_006 =
  fun _1 _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 454 "lang/parser.mly"
                         (
      match _1 with
        | `Json_parse     -> `Json_parse (Parser_helper.args_of_json_parse ~pos:_loc _2)
        | `Json_stringify -> `Json_stringify (Parser_helper.args_of_json_stringify ~pos:_loc _2)
        | _ -> raise (Parse_error (_loc, "Invalid let constructor")) )
# 1649 "lang/parser.ml"
     : (
# 114 "lang/parser.mly"
      (Parser_helper.let_decoration)
# 1653 "lang/parser.ml"
    ))

let _menhir_action_007 =
  fun _1 ->
    (
# 537 "lang/parser.mly"
                            ( _1 )
# 1661 "lang/parser.ml"
     : (
# 106 "lang/parser.mly"
      ((string * string) list)
# 1665 "lang/parser.ml"
    ))

let _menhir_action_008 =
  fun _1 ->
    (
# 547 "lang/parser.mly"
        ( _1 )
# 1673 "lang/parser.ml"
     : (
# 115 "lang/parser.mly"
      (string)
# 1677 "lang/parser.ml"
    ))

let _menhir_action_009 =
  fun _1 ->
    (
# 548 "lang/parser.mly"
           ( _1 )
# 1685 "lang/parser.ml"
     : (
# 115 "lang/parser.mly"
      (string)
# 1689 "lang/parser.ml"
    ))

let _menhir_action_010 =
  fun _1 _2 ->
    (
# 540 "lang/parser.mly"
                                              ( _1::_2 )
# 1697 "lang/parser.ml"
     : (
# 116 "lang/parser.mly"
      ((string * string) list)
# 1701 "lang/parser.ml"
    ))

let _menhir_action_011 =
  fun _1 _3 ->
    (
# 541 "lang/parser.mly"
                                     ( [_1, _3] )
# 1709 "lang/parser.ml"
     : (
# 116 "lang/parser.mly"
      ((string * string) list)
# 1713 "lang/parser.ml"
    ))

let _menhir_action_012 =
  fun _1 _3 ->
    (
# 544 "lang/parser.mly"
                                           ( _1, _3 )
# 1721 "lang/parser.ml"
     : (
# 109 "lang/parser.mly"
      (string * string)
# 1725 "lang/parser.ml"
    ))

let _menhir_action_013 =
  fun _1 ->
    (
# 551 "lang/parser.mly"
        ( string_of_int _1 )
# 1733 "lang/parser.ml"
     : (
# 117 "lang/parser.mly"
      (string)
# 1737 "lang/parser.ml"
    ))

let _menhir_action_014 =
  fun _1 ->
    (
# 552 "lang/parser.mly"
          ( string_of_float _1 )
# 1745 "lang/parser.ml"
     : (
# 117 "lang/parser.mly"
      (string)
# 1749 "lang/parser.ml"
    ))

let _menhir_action_015 =
  fun _1 ->
    (
# 553 "lang/parser.mly"
         ( string_of_bool _1 )
# 1757 "lang/parser.ml"
     : (
# 117 "lang/parser.mly"
      (string)
# 1761 "lang/parser.ml"
    ))

let _menhir_action_016 =
  fun _1 ->
    (
# 554 "lang/parser.mly"
        ( _1 )
# 1769 "lang/parser.ml"
     : (
# 117 "lang/parser.mly"
      (string)
# 1773 "lang/parser.ml"
    ))

let _menhir_action_017 =
  fun _1 ->
    (
# 555 "lang/parser.mly"
           ( _1 )
# 1781 "lang/parser.ml"
     : (
# 117 "lang/parser.mly"
      (string)
# 1785 "lang/parser.ml"
    ))

let _menhir_action_018 =
  fun () ->
    (
# 379 "lang/parser.mly"
                                 ( [] )
# 1793 "lang/parser.ml"
     : (
# 118 "lang/parser.mly"
      (Parser_helper.app_list_elem)
# 1797 "lang/parser.ml"
    ))

let _menhir_action_019 =
  fun _1 ->
    (
# 380 "lang/parser.mly"
                                 ( _1 )
# 1805 "lang/parser.ml"
     : (
# 118 "lang/parser.mly"
      (Parser_helper.app_list_elem)
# 1809 "lang/parser.ml"
    ))

let _menhir_action_020 =
  fun _1 _3 ->
    (
# 381 "lang/parser.mly"
                                 ( _1@_3 )
# 1817 "lang/parser.ml"
     : (
# 118 "lang/parser.mly"
      (Parser_helper.app_list_elem)
# 1821 "lang/parser.ml"
    ))

let _menhir_action_021 =
  fun _1 _3 ->
    (
# 370 "lang/parser.mly"
                  ( [_1,_3] )
# 1829 "lang/parser.ml"
     : (
# 119 "lang/parser.mly"
      (Parser_helper.app_list_elem)
# 1833 "lang/parser.ml"
    ))

let _menhir_action_022 =
  fun _1 ->
    (
# 371 "lang/parser.mly"
                  ( ["",_1] )
# 1841 "lang/parser.ml"
     : (
# 119 "lang/parser.mly"
      (Parser_helper.app_list_elem)
# 1845 "lang/parser.ml"
    ))

let _menhir_action_023 =
  fun _3 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 372 "lang/parser.mly"
                                 ( app_of ~only:[] ~except:[] ~pos:_loc _3 )
# 1856 "lang/parser.ml"
     : (
# 119 "lang/parser.mly"
      (Parser_helper.app_list_elem)
# 1860 "lang/parser.ml"
    ))

let _menhir_action_024 =
  fun _3 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 374 "lang/parser.mly"
                                 ( app_of ~only:[] ~except:[] ~pos:_loc (String.concat "." _3) )
# 1871 "lang/parser.ml"
     : (
# 119 "lang/parser.mly"
      (Parser_helper.app_list_elem)
# 1875 "lang/parser.ml"
    ))

let _menhir_action_025 =
  fun _3 _4 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 375 "lang/parser.mly"
                                                  ( app_of ~pos:_loc ~only:(fst _4) ~except:(snd _4) _3 )
# 1886 "lang/parser.ml"
     : (
# 119 "lang/parser.mly"
      (Parser_helper.app_list_elem)
# 1890 "lang/parser.ml"
    ))

let _menhir_action_026 =
  fun _3 _4 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 377 "lang/parser.mly"
                                 ( app_of ~pos:_loc (String.concat "." _3) ~only:(fst _4) ~except:(snd _4) )
# 1901 "lang/parser.ml"
     : (
# 119 "lang/parser.mly"
      (Parser_helper.app_list_elem)
# 1905 "lang/parser.ml"
    ))

let _menhir_action_027 =
  fun _2 _3 _endpos__2_ _startpos__2_ ->
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 482 "lang/parser.mly"
                 ( [_2, _2, Type.var ~pos:_loc__2_ (), _3] )
# 1914 "lang/parser.ml"
     : (
# 120 "lang/parser.mly"
      (Parser_helper.arglist)
# 1918 "lang/parser.ml"
    ))

let _menhir_action_028 =
  fun _3 _5 _7 ->
    (
# 483 "lang/parser.mly"
                                    ( [_3, _3, _5, _7 ] )
# 1926 "lang/parser.ml"
     : (
# 120 "lang/parser.mly"
      (Parser_helper.arglist)
# 1930 "lang/parser.ml"
    ))

let _menhir_action_029 =
  fun _2 _5 _endpos__2_ _startpos__2_ ->
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 484 "lang/parser.mly"
                                 ( [_2, "_", Type.var ~pos:_loc__2_ (), _5] )
# 1939 "lang/parser.ml"
     : (
# 120 "lang/parser.mly"
      (Parser_helper.arglist)
# 1943 "lang/parser.ml"
    ))

let _menhir_action_030 =
  fun _1 _2 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 485 "lang/parser.mly"
                ( ["", _1, Type.var ~pos:_loc__1_ (), _2] )
# 1952 "lang/parser.ml"
     : (
# 120 "lang/parser.mly"
      (Parser_helper.arglist)
# 1956 "lang/parser.ml"
    ))

let _menhir_action_031 =
  fun _2 _4 _6 ->
    (
# 486 "lang/parser.mly"
                                  ( ["", _2, _4, _6] )
# 1964 "lang/parser.ml"
     : (
# 120 "lang/parser.mly"
      (Parser_helper.arglist)
# 1968 "lang/parser.ml"
    ))

let _menhir_action_032 =
  fun _3 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 487 "lang/parser.mly"
                          ( args_of ~only:[] ~except:[] ~pos:_loc _3 )
# 1979 "lang/parser.ml"
     : (
# 120 "lang/parser.mly"
      (Parser_helper.arglist)
# 1983 "lang/parser.ml"
    ))

let _menhir_action_033 =
  fun _3 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 489 "lang/parser.mly"
                          ( args_of ~only:[] ~except:[] ~pos:_loc (String.concat "." _3) )
# 1994 "lang/parser.ml"
     : (
# 120 "lang/parser.mly"
      (Parser_helper.arglist)
# 1998 "lang/parser.ml"
    ))

let _menhir_action_034 =
  fun _3 _4 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 490 "lang/parser.mly"
                                                  ( args_of ~pos:_loc ~only:(fst _4) ~except:(snd _4) _3 )
# 2009 "lang/parser.ml"
     : (
# 120 "lang/parser.mly"
      (Parser_helper.arglist)
# 2013 "lang/parser.ml"
    ))

let _menhir_action_035 =
  fun _3 _4 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 492 "lang/parser.mly"
                          ( args_of ~pos:_loc (String.concat "." _3) ~only:(fst _4) ~except:(snd _4) )
# 2024 "lang/parser.ml"
     : (
# 120 "lang/parser.mly"
      (Parser_helper.arglist)
# 2028 "lang/parser.ml"
    ))

let _menhir_action_036 =
  fun () ->
    (
# 478 "lang/parser.mly"
                          ( [] )
# 2036 "lang/parser.ml"
     : (
# 121 "lang/parser.mly"
      (Parser_helper.arglist)
# 2040 "lang/parser.ml"
    ))

let _menhir_action_037 =
  fun _1 ->
    (
# 479 "lang/parser.mly"
                          ( _1 )
# 2048 "lang/parser.ml"
     : (
# 121 "lang/parser.mly"
      (Parser_helper.arglist)
# 2052 "lang/parser.ml"
    ))

let _menhir_action_038 =
  fun _1 _3 ->
    (
# 480 "lang/parser.mly"
                          ( _1@_3 )
# 2060 "lang/parser.ml"
     : (
# 121 "lang/parser.mly"
      (Parser_helper.arglist)
# 2064 "lang/parser.ml"
    ))

let _menhir_action_039 =
  fun _1 ->
    (
# 497 "lang/parser.mly"
                                 ( [_1], [] )
# 2072 "lang/parser.ml"
     : (
# 122 "lang/parser.mly"
      (string list * string list)
# 2076 "lang/parser.ml"
    ))

let _menhir_action_040 =
  fun _2 ->
    (
# 498 "lang/parser.mly"
                                 ( [], [_2] )
# 2084 "lang/parser.ml"
     : (
# 122 "lang/parser.mly"
      (string list * string list)
# 2088 "lang/parser.ml"
    ))

let _menhir_action_041 =
  fun _1 _3 ->
    (
# 499 "lang/parser.mly"
                                 ( _1::(fst _3), (snd _3) )
# 2096 "lang/parser.ml"
     : (
# 122 "lang/parser.mly"
      (string list * string list)
# 2100 "lang/parser.ml"
    ))

let _menhir_action_042 =
  fun _2 _4 ->
    (
# 500 "lang/parser.mly"
                                 ( (fst _4), _2::(snd _4) )
# 2108 "lang/parser.ml"
     : (
# 122 "lang/parser.mly"
      (string list * string list)
# 2112 "lang/parser.ml"
    ))

let _menhir_action_043 =
  fun () ->
    (
# 349 "lang/parser.mly"
                       ( [] )
# 2120 "lang/parser.ml"
     : (
# 123 "lang/parser.mly"
      ((bool * string * Type.t) list)
# 2124 "lang/parser.ml"
    ))

let _menhir_action_044 =
  fun _1 ->
    (
# 350 "lang/parser.mly"
                       ( [_1] )
# 2132 "lang/parser.ml"
     : (
# 123 "lang/parser.mly"
      ((bool * string * Type.t) list)
# 2136 "lang/parser.ml"
    ))

let _menhir_action_045 =
  fun _1 _3 ->
    (
# 351 "lang/parser.mly"
                       ( _1::_3 )
# 2144 "lang/parser.ml"
     : (
# 123 "lang/parser.mly"
      ((bool * string * Type.t) list)
# 2148 "lang/parser.ml"
    ))

let _menhir_action_046 =
  fun _1 ->
    (
# 344 "lang/parser.mly"
                          ( false,"",_1 )
# 2156 "lang/parser.ml"
     : (
# 124 "lang/parser.mly"
      (bool * string * Type.t)
# 2160 "lang/parser.ml"
    ))

let _menhir_action_047 =
  fun _1 _3 ->
    (
# 345 "lang/parser.mly"
                          ( false,_1,_3 )
# 2168 "lang/parser.ml"
     : (
# 124 "lang/parser.mly"
      (bool * string * Type.t)
# 2172 "lang/parser.ml"
    ))

let _menhir_action_048 =
  fun _2 _4 ->
    (
# 346 "lang/parser.mly"
                          ( true,_2,_4 )
# 2180 "lang/parser.ml"
     : (
# 124 "lang/parser.mly"
      (bool * string * Type.t)
# 2184 "lang/parser.ml"
    ))

let _menhir_action_049 =
  fun _1 _3 ->
    (
# 461 "lang/parser.mly"
                             ( (Doc.none (),[],[]), `None,  PVar [_1], None,    _3, None )
# 2192 "lang/parser.ml"
     : (
# 125 "lang/parser.mly"
      (Parser_helper.binding)
# 2196 "lang/parser.ml"
    ))

let _menhir_action_050 =
  fun _1 _2 _4 ->
    (
# 462 "lang/parser.mly"
                             ( (Doc.none (),[],[]), _1,     _2,        None,    _4, None )
# 2204 "lang/parser.ml"
     : (
# 125 "lang/parser.mly"
      (Parser_helper.binding)
# 2208 "lang/parser.ml"
    ))

let _menhir_action_051 =
  fun _1 _3 _5 _8 ->
    (
# 464 "lang/parser.mly"
                             ( (Doc.none (),[],[]), _1,     _3,        None,    _8, Some _5 )
# 2216 "lang/parser.ml"
     : (
# 125 "lang/parser.mly"
      (Parser_helper.binding)
# 2220 "lang/parser.ml"
    ))

let _menhir_action_052 =
  fun _1 _2 _4 ->
    (
# 465 "lang/parser.mly"
                             ( (Doc.none (),[],[]), _1,     PVar _2,   None,    _4, None )
# 2228 "lang/parser.ml"
     : (
# 125 "lang/parser.mly"
      (Parser_helper.binding)
# 2232 "lang/parser.ml"
    ))

let _menhir_action_053 =
  fun _1 _2 _4 ->
    (
# 466 "lang/parser.mly"
                             ( fst _1,              snd _1, _2,        None,    _4, None )
# 2240 "lang/parser.ml"
     : (
# 125 "lang/parser.mly"
      (Parser_helper.binding)
# 2244 "lang/parser.ml"
    ))

let _menhir_action_054 =
  fun _1 _3 _5 _8 ->
    (
# 468 "lang/parser.mly"
                             ( fst _1,              snd _1, _3,        None,    _8, Some _5 )
# 2252 "lang/parser.ml"
     : (
# 125 "lang/parser.mly"
      (Parser_helper.binding)
# 2256 "lang/parser.ml"
    ))

let _menhir_action_055 =
  fun _1 _2 _4 ->
    (
# 469 "lang/parser.mly"
                             ( fst _1,              snd _1, PVar _2,   None,    _4, None )
# 2264 "lang/parser.ml"
     : (
# 125 "lang/parser.mly"
      (Parser_helper.binding)
# 2268 "lang/parser.ml"
    ))

let _menhir_action_056 =
  fun _1 _2 _3 _6 ->
    (
# 471 "lang/parser.mly"
                             ( fst _1,              snd _1, PVar _2, Some _3,   _6, None )
# 2276 "lang/parser.ml"
     : (
# 125 "lang/parser.mly"
      (Parser_helper.binding)
# 2280 "lang/parser.ml"
    ))

let _menhir_action_057 =
  fun () ->
    (
# 517 "lang/parser.mly"
                 ( [] )
# 2288 "lang/parser.ml"
     : (
# 126 "lang/parser.mly"
      (Parser_helper.encoder_opt)
# 2292 "lang/parser.ml"
    ))

let _menhir_action_058 =
  fun _2 ->
    (
# 518 "lang/parser.mly"
                             ( _2 )
# 2300 "lang/parser.ml"
     : (
# 126 "lang/parser.mly"
      (Parser_helper.encoder_opt)
# 2304 "lang/parser.ml"
    ))

let _menhir_action_059 =
  fun _1 _3 ->
    (
# 521 "lang/parser.mly"
                        ( _1, `Term _3 )
# 2312 "lang/parser.ml"
     : (
# 127 "lang/parser.mly"
      (Parser_helper.encoder_param)
# 2316 "lang/parser.ml"
    ))

let _menhir_action_060 =
  fun _1 _3 ->
    (
# 522 "lang/parser.mly"
                        ( _1, `Term _3 )
# 2324 "lang/parser.ml"
     : (
# 127 "lang/parser.mly"
      (Parser_helper.encoder_param)
# 2328 "lang/parser.ml"
    ))

let _menhir_action_061 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 523 "lang/parser.mly"
                        ( "", `Term (mk ~pos:_loc (Ground (String _1))) )
# 2339 "lang/parser.ml"
     : (
# 127 "lang/parser.mly"
      (Parser_helper.encoder_param)
# 2343 "lang/parser.ml"
    ))

let _menhir_action_062 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 524 "lang/parser.mly"
                        ( "", `Term (mk ~pos:_loc (Ground (String _1))) )
# 2354 "lang/parser.ml"
     : (
# 127 "lang/parser.mly"
      (Parser_helper.encoder_param)
# 2358 "lang/parser.ml"
    ))

let _menhir_action_063 =
  fun _1 _2 ->
    (
# 525 "lang/parser.mly"
                        ( "", `Encoder (_1, _2) )
# 2366 "lang/parser.ml"
     : (
# 127 "lang/parser.mly"
      (Parser_helper.encoder_param)
# 2370 "lang/parser.ml"
    ))

let _menhir_action_064 =
  fun () ->
    (
# 528 "lang/parser.mly"
                                       ( [] )
# 2378 "lang/parser.ml"
     : (
# 128 "lang/parser.mly"
      (Parser_helper.encoder_param list)
# 2382 "lang/parser.ml"
    ))

let _menhir_action_065 =
  fun _1 ->
    (
# 529 "lang/parser.mly"
                                       ( [_1] )
# 2390 "lang/parser.ml"
     : (
# 128 "lang/parser.mly"
      (Parser_helper.encoder_param list)
# 2394 "lang/parser.ml"
    ))

let _menhir_action_066 =
  fun _1 _3 ->
    (
# 530 "lang/parser.mly"
                                       ( _1::_3 )
# 2402 "lang/parser.ml"
     : (
# 128 "lang/parser.mly"
      (Parser_helper.encoder_param list)
# 2406 "lang/parser.ml"
    ))

let _menhir_action_067 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 198 "lang/parser.mly"
                                     ( mk ~pos:_loc (Cast (_2, _4)) )
# 2417 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2421 "lang/parser.ml"
    ))

let _menhir_action_068 =
  fun _2 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 199 "lang/parser.mly"
                                     ( mk ~pos:_loc (Ground (Float (-. _2))) )
# 2432 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2436 "lang/parser.ml"
    ))

let _menhir_action_069 =
  fun _2 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 200 "lang/parser.mly"
                                     ( mk ~pos:_loc (Ground (Int (- _2))) )
# 2447 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2451 "lang/parser.ml"
    ))

let _menhir_action_070 =
  fun _3 _endpos__1_ _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 201 "lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__1_ (Var "~-"), ["", _3])) )
# 2463 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2467 "lang/parser.ml"
    ))

let _menhir_action_071 =
  fun _2 ->
    (
# 202 "lang/parser.mly"
                                     ( _2 )
# 2475 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2479 "lang/parser.ml"
    ))

let _menhir_action_072 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 203 "lang/parser.mly"
                                     ( mk ~pos:_loc (Ground (Int _1)) )
# 2490 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2494 "lang/parser.ml"
    ))

let _menhir_action_073 =
  fun _2 _endpos__1_ _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 204 "lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__1_ (Var "not"), ["", _2])) )
# 2506 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2510 "lang/parser.ml"
    ))

let _menhir_action_074 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 205 "lang/parser.mly"
                                     ( mk ~pos:_loc (Ground (Bool _1)) )
# 2521 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2525 "lang/parser.ml"
    ))

let _menhir_action_075 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 206 "lang/parser.mly"
                                     ( mk ~pos:_loc (Ground (Float  _1)) )
# 2536 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2540 "lang/parser.ml"
    ))

let _menhir_action_076 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 207 "lang/parser.mly"
                                     ( mk ~pos:_loc (Ground (String _1)) )
# 2551 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2555 "lang/parser.ml"
    ))

let _menhir_action_077 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 208 "lang/parser.mly"
                                     ( mk ~pos:_loc (Var _1) )
# 2566 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2570 "lang/parser.ml"
    ))

let _menhir_action_078 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 209 "lang/parser.mly"
                                     ( mk_list ~pos:_loc _1 )
# 2581 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2585 "lang/parser.ml"
    ))

let _menhir_action_079 =
  fun _2 _endpos__1_ _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 210 "lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__1_ (Invoke (mk ~pos:_loc__1_ (Var "ref"), "get")), ["", _2])) )
# 2597 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2601 "lang/parser.ml"
    ))

let _menhir_action_080 =
  fun _1 _3 _endpos__1_ _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 211 "lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Invoke (mk ~pos:_loc__1_ (Var "ref"), "set")), ["", _1; "", _3])) )
# 2614 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2618 "lang/parser.ml"
    ))

let _menhir_action_081 =
  fun _1 _2 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 212 "lang/parser.mly"
                                     ( mk_encoder ~pos:_loc _1 _2 )
# 2629 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2633 "lang/parser.ml"
    ))

let _menhir_action_082 =
  fun _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 213 "lang/parser.mly"
                                     ( mk ~pos:_loc (Tuple []) )
# 2644 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2648 "lang/parser.ml"
    ))

let _menhir_action_083 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 214 "lang/parser.mly"
                                     ( mk ~pos:_loc (Tuple _2) )
# 2659 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2663 "lang/parser.ml"
    ))

let _menhir_action_084 =
  fun _1 _4 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 215 "lang/parser.mly"
                                     ( _4 ~pos:_loc _1 )
# 2674 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2678 "lang/parser.ml"
    ))

let _menhir_action_085 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 216 "lang/parser.mly"
                                     ( _2 ~pos:_loc (mk ~pos:_loc (Tuple [])) )
# 2689 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2693 "lang/parser.ml"
    ))

let _menhir_action_086 =
  fun _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 217 "lang/parser.mly"
                                     ( mk ~pos:_loc (Tuple []) )
# 2704 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2708 "lang/parser.ml"
    ))

let _menhir_action_087 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 218 "lang/parser.mly"
                                     ( mk ~pos:_loc (Invoke (_1, _3)) )
# 2719 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2723 "lang/parser.ml"
    ))

let _menhir_action_088 =
  fun _1 _3 _4 _endpos__3_ _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 219 "lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:(_startpos__1_,_endpos__3_) (Invoke (_1, _3)), _4)) )
# 2734 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2738 "lang/parser.ml"
    ))

let _menhir_action_089 =
  fun _1 _2 _endpos__1_ _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 220 "lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__1_ (Var _1), _2)) )
# 2750 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2754 "lang/parser.ml"
    ))

let _menhir_action_090 =
  fun _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 221 "lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var "_::_"), ["", _1; "", _3])) )
# 2766 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2770 "lang/parser.ml"
    ))

let _menhir_action_091 =
  fun _1 _2 _endpos__1_ _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 222 "lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc (Var "_[_]"), ["", mk ~pos:_loc__1_ (Var _1); "", _2])) )
# 2782 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2786 "lang/parser.ml"
    ))

let _menhir_action_092 =
  fun _1 _3 _4 _endpos__3_ _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 223 "lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc (Var "_[_]"), ["", mk ~pos:(_startpos__1_,_endpos__3_) (Invoke (_1, _3)); "", _4])) )
# 2797 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2801 "lang/parser.ml"
    ))

let _menhir_action_093 =
  fun _2 ->
    (
# 224 "lang/parser.mly"
                                     ( _2 )
# 2809 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2813 "lang/parser.ml"
    ))

let _menhir_action_094 =
  fun _3 _6 _endpos__6_ _startpos__1_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 225 "lang/parser.mly"
                                     ( mk_fun ~pos:_loc _3 _6 )
# 2824 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2828 "lang/parser.ml"
    ))

let _menhir_action_095 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 226 "lang/parser.mly"
                                     ( mk_fun ~pos:_loc [] _2 )
# 2839 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2843 "lang/parser.ml"
    ))

let _menhir_action_096 =
  fun _2 _4 _endpos__1_ _endpos__2_ _endpos__4_ _endpos__5_ _startpos__1_ _startpos__2_ _startpos__4_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc__4_ = (_startpos__4_, _endpos__4_) in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 227 "lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__1_ (Var "while"), ["", mk_fun ~pos:_loc__2_ [] _2; "", mk_fun ~pos:_loc__4_ [] _4])) )
# 2857 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2861 "lang/parser.ml"
    ))

let _menhir_action_097 =
  fun _2 _4 _6 _endpos__1_ _endpos__2_ _endpos__6_ _endpos__7_ _startpos__1_ _startpos__2_ _startpos__6_ ->
    let _endpos = _endpos__7_ in
    let _startpos = _startpos__1_ in
    let _loc__6_ = (_startpos__6_, _endpos__6_) in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 229 "lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__1_ (Var "for"), ["", _4; "", mk_fun ~pos:_loc__6_ ["", _2, Type.var ~pos:_loc__2_ (), None] _6])) )
# 2875 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2879 "lang/parser.ml"
    ))

let _menhir_action_098 =
  fun _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 230 "lang/parser.mly"
                                     ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Invoke (mk ~pos:_loc__2_ (Var "iterator"), "int")), ["", _1; "", _3])) )
# 2891 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2895 "lang/parser.ml"
    ))

let _menhir_action_099 =
  fun _1 _3 _endpos__1_ _endpos__3_ _startpos__1_ _startpos__3_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 231 "lang/parser.mly"
                                     ( let null = mk ~pos:_loc__1_ (Var "null") in
                                       let op =  mk ~pos:_loc__1_ (Invoke (null, "default")) in
                                       let handler = mk_fun ~pos:_loc__3_ [] _3 in
                                       mk ~pos:_loc (App (op, ["",_1;"",handler])) )
# 2911 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2915 "lang/parser.ml"
    ))

let _menhir_action_100 =
  fun _2 _4 _6 _8 _endpos__1_ _endpos__2_ _endpos__4_ _endpos__8_ _endpos__9_ _startpos__1_ _startpos__2_ _startpos__4_ _startpos__8_ ->
    let _endpos = _endpos__9_ in
    let _startpos = _startpos__1_ in
    let _loc__8_ = (_startpos__8_, _endpos__8_) in
    let _loc__4_ = (_startpos__4_, _endpos__4_) in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 236 "lang/parser.mly"
                                     ( let fn = mk_fun ~pos:_loc__2_ [] _2 in
                                       let err_arg = ["", _4, Type.var ~pos:_loc__4_ (), None] in
                                       let errors = mk_list ~pos:_loc _6 in
                                       let handler =  mk_fun ~pos:_loc__8_ err_arg _8 in
                                       let error_module = mk ~pos:_loc__1_ (Var "error") in
                                       let op = mk ~pos:_loc__1_ (Invoke (error_module, "catch")) in
                                       mk ~pos:_loc (App (op, ["errors", errors; "", fn; "", handler])) )
# 2936 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2940 "lang/parser.ml"
    ))

let _menhir_action_101 =
  fun _2 _4 _6 _endpos__1_ _endpos__2_ _endpos__4_ _endpos__6_ _endpos__7_ _startpos__1_ _startpos__2_ _startpos__4_ _startpos__6_ ->
    let _endpos = _endpos__7_ in
    let _startpos = _startpos__1_ in
    let _loc__6_ = (_startpos__6_, _endpos__6_) in
    let _loc__4_ = (_startpos__4_, _endpos__4_) in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 243 "lang/parser.mly"
                                        ( let fn = mk_fun ~pos:_loc__2_ [] _2 in
                                       let err_arg = ["", _4, Type.var ~pos:_loc__4_ (), None] in
                                       let handler = mk_fun ~pos:_loc__6_ err_arg _6 in
                                       let errors = mk ~pos:_loc Null in
                                       let error_module = mk ~pos:_loc__1_ (Var "error") in
                                       let op = mk ~pos:_loc__1_ (Invoke (error_module, "catch")) in
                                       mk ~pos:_loc (App (op, ["errors", errors; "", fn; "", handler])) )
# 2961 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2965 "lang/parser.ml"
    ))

let _menhir_action_102 =
  fun _2 _4 _5 _endpos__1_ _endpos__4_ _endpos__6_ _startpos__1_ _startpos__3_ ->
    let _endpos = _endpos__6_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 250 "lang/parser.mly"
                                     ( let cond = _2 in
                                       let then_b = mk_fun ~pos:(_startpos__3_,_endpos__4_) [] _4 in
                                       let else_b = _5 in
                                       let op = mk ~pos:_loc__1_ (Var "if") in
                                       mk ~pos:_loc (App (op, ["", cond; "then", then_b; "else", else_b])) )
# 2981 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 2985 "lang/parser.ml"
    ))

let _menhir_action_103 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 255 "lang/parser.mly"
                                    (  let regexp, flags = _1 in
                                       let regexp =  mk ~pos:_loc (Ground (String regexp)) in
                                       let flags = List.map Char.escaped flags in
                                       let flags = List.map (fun s -> mk ~pos:_loc (Ground (String s))) flags in
                                       let flags = mk ~pos:_loc (List flags) in
                                       let op = mk ~pos:_loc__1_ (Var "regexp") in
                                       mk ~pos:_loc (App (op, ["", regexp; "flags", flags])) )
# 3003 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 3007 "lang/parser.ml"
    ))

let _menhir_action_104 =
  fun _1 _3 _5 _endpos__1_ _endpos__3_ _endpos__5_ _startpos__1_ _startpos__3_ _startpos__5_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc__5_ = (_startpos__5_, _endpos__5_) in
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 262 "lang/parser.mly"
                                     ( let cond = _1 in
                                       let then_b = mk_fun ~pos:_loc__3_ [] _3 in
                                       let else_b = mk_fun ~pos:_loc__5_ [] _5 in
                                       let op = mk ~pos:_loc__1_ (Var "if") in
                                       mk ~pos:_loc (App (op, ["", cond; "then", then_b; "else", else_b])) )
# 3025 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 3029 "lang/parser.ml"
    ))

let _menhir_action_105 =
  fun _1 _2 _3 _endpos__1_ _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ _startpos__3_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 268 "lang/parser.mly"
                                   ( let left = mk_fun ~pos:_loc__1_ [] _1 in
                                     let right= mk_fun ~pos:_loc__3_ [] _3 in
                                     mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var _2), ["",left;"",right])) )
# 3045 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 3049 "lang/parser.ml"
    ))

let _menhir_action_106 =
  fun _1 _2 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 271 "lang/parser.mly"
                                   ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var _2), ["",_1;"",_3])) )
# 3061 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 3065 "lang/parser.ml"
    ))

let _menhir_action_107 =
  fun _1 _2 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 272 "lang/parser.mly"
                                   ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var _2), ["",_1;"",_3])) )
# 3077 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 3081 "lang/parser.ml"
    ))

let _menhir_action_108 =
  fun _1 _2 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 273 "lang/parser.mly"
                                   ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var _2), ["",_1;"",_3])) )
# 3093 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 3097 "lang/parser.ml"
    ))

let _menhir_action_109 =
  fun _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 274 "lang/parser.mly"
                                   ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var "*"), ["",_1;"",_3])) )
# 3109 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 3113 "lang/parser.ml"
    ))

let _menhir_action_110 =
  fun _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    let _loc = (_startpos, _endpos) in
    (
# 275 "lang/parser.mly"
                                   ( mk ~pos:_loc (App (mk ~pos:_loc__2_ (Var "-"), ["",_1;"",_3])) )
# 3125 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 3129 "lang/parser.ml"
    ))

let _menhir_action_111 =
  fun _1 ->
    (
# 276 "lang/parser.mly"
                                   ( _1 )
# 3137 "lang/parser.ml"
     : (
# 129 "lang/parser.mly"
      (Term.t)
# 3141 "lang/parser.ml"
    ))

let _menhir_action_112 =
  fun _2 _4 _endpos__4_ _startpos__1_ ->
    let _endpos = _endpos__4_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 185 "lang/parser.mly"
                             ( mk ~pos:_loc (Open (_2,_4)) )
# 3152 "lang/parser.ml"
     : (
# 130 "lang/parser.mly"
      (Term.t)
# 3156 "lang/parser.ml"
    ))

let _menhir_action_113 =
  fun _1 ->
    (
# 186 "lang/parser.mly"
                             ( _1 )
# 3164 "lang/parser.ml"
     : (
# 130 "lang/parser.mly"
      (Term.t)
# 3168 "lang/parser.ml"
    ))

let _menhir_action_114 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 187 "lang/parser.mly"
                             ( mk ~pos:_loc (Seq (_1,_3)) )
# 3179 "lang/parser.ml"
     : (
# 130 "lang/parser.mly"
      (Term.t)
# 3183 "lang/parser.ml"
    ))

let _menhir_action_115 =
  fun _1 _endpos__1_ _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 188 "lang/parser.mly"
                             ( mk_let ~pos:_loc__1_ _1 (mk ~pos:_loc unit) )
# 3195 "lang/parser.ml"
     : (
# 130 "lang/parser.mly"
      (Term.t)
# 3199 "lang/parser.ml"
    ))

let _menhir_action_116 =
  fun _1 _3 _endpos__1_ _startpos__1_ ->
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 189 "lang/parser.mly"
                             ( mk_let ~pos:_loc__1_ _1 _3 )
# 3208 "lang/parser.ml"
     : (
# 130 "lang/parser.mly"
      (Term.t)
# 3212 "lang/parser.ml"
    ))

let _menhir_action_117 =
  fun _1 ->
    (
# 193 "lang/parser.mly"
         ( _1 )
# 3220 "lang/parser.ml"
     : (
# 131 "lang/parser.mly"
      (Term.t)
# 3224 "lang/parser.ml"
    ))

let _menhir_action_118 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 194 "lang/parser.mly"
                    ( mk ~pos:_loc (Seq (_1,_3)) )
# 3235 "lang/parser.ml"
     : (
# 131 "lang/parser.mly"
      (Term.t)
# 3239 "lang/parser.ml"
    ))

let _menhir_action_119 =
  fun () ->
    (
# 182 "lang/parser.mly"
     ()
# 3247 "lang/parser.ml"
     : (
# 132 "lang/parser.mly"
      (unit)
# 3251 "lang/parser.ml"
    ))

let _menhir_action_120 =
  fun () ->
    (
# 182 "lang/parser.mly"
               ()
# 3259 "lang/parser.ml"
     : (
# 132 "lang/parser.mly"
      (unit)
# 3263 "lang/parser.ml"
    ))

let _menhir_action_121 =
  fun _2 _4 _5 _endpos__1_ _endpos__4_ _endpos__5_ _startpos__1_ _startpos__3_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    let _loc = (_startpos, _endpos) in
    (
# 508 "lang/parser.mly"
                                    ( let cond = _2 in
                                      let then_b = mk_fun ~pos:(_startpos__3_, _endpos__4_) [] _4 in
                                      let else_b = _5 in
                                      let op = mk ~pos:_loc__1_ (Var "if") in
                                      mk_fun ~pos:_loc [] (mk ~pos:_loc (App (op,["",cond; "then",then_b; "else",else_b]))) )
# 3279 "lang/parser.ml"
     : (
# 133 "lang/parser.mly"
      (Term.t)
# 3283 "lang/parser.ml"
    ))

let _menhir_action_122 =
  fun _2 _endpos__2_ _startpos__2_ ->
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 513 "lang/parser.mly"
                                    ( mk_fun ~pos:_loc__2_ [] _2 )
# 3292 "lang/parser.ml"
     : (
# 133 "lang/parser.mly"
      (Term.t)
# 3296 "lang/parser.ml"
    ))

let _menhir_action_123 =
  fun _endpos__0_ ->
    let _endpos = _endpos__0_ in
    let _startpos = _endpos__0_ in
    let _loc = (_startpos, _endpos) in
    (
# 514 "lang/parser.mly"
                                    ( mk_fun ~pos:_loc [] (mk ~pos:_loc unit) )
# 3307 "lang/parser.ml"
     : (
# 133 "lang/parser.mly"
      (Term.t)
# 3311 "lang/parser.ml"
    ))

let _menhir_action_124 =
  fun _1 ->
    (
# 441 "lang/parser.mly"
                        ( [_1] )
# 3319 "lang/parser.ml"
     : (
# 134 "lang/parser.mly"
      (string list)
# 3323 "lang/parser.ml"
    ))

let _menhir_action_125 =
  fun _1 _3 ->
    (
# 442 "lang/parser.mly"
                        ( _1::_3 )
# 3331 "lang/parser.ml"
     : (
# 134 "lang/parser.mly"
      (string list)
# 3335 "lang/parser.ml"
    ))

let _menhir_action_126 =
  fun _1 ->
    (
# 504 "lang/parser.mly"
            ( [_1] )
# 3343 "lang/parser.ml"
     : (
# 135 "lang/parser.mly"
      (string list)
# 3347 "lang/parser.ml"
    ))

let _menhir_action_127 =
  fun _1 _3 ->
    (
# 505 "lang/parser.mly"
                             ( _1::_3 )
# 3355 "lang/parser.ml"
     : (
# 135 "lang/parser.mly"
      (string list)
# 3359 "lang/parser.ml"
    ))

let _menhir_action_128 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 357 "lang/parser.mly"
                          ( append_list ~pos:_loc _1 _3 )
# 3370 "lang/parser.ml"
     : (
# 136 "lang/parser.mly"
      (Parser_helper.inner_list)
# 3374 "lang/parser.ml"
    ))

let _menhir_action_129 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 358 "lang/parser.mly"
                          ( append_list ~pos:_loc _1 (`List []) )
# 3385 "lang/parser.ml"
     : (
# 136 "lang/parser.mly"
      (Parser_helper.inner_list)
# 3389 "lang/parser.ml"
    ))

let _menhir_action_130 =
  fun () ->
    (
# 359 "lang/parser.mly"
                          ( `List [] )
# 3397 "lang/parser.ml"
     : (
# 136 "lang/parser.mly"
      (Parser_helper.inner_list)
# 3401 "lang/parser.ml"
    ))

let _menhir_action_131 =
  fun _2 ->
    (
# 362 "lang/parser.mly"
                   ( `Ellipsis _2 )
# 3409 "lang/parser.ml"
     : (
# 137 "lang/parser.mly"
      (Parser_helper.inner_list_item)
# 3413 "lang/parser.ml"
    ))

let _menhir_action_132 =
  fun _1 ->
    (
# 363 "lang/parser.mly"
                   ( `Expr _1 )
# 3421 "lang/parser.ml"
     : (
# 137 "lang/parser.mly"
      (Parser_helper.inner_list_item)
# 3425 "lang/parser.ml"
    ))

let _menhir_action_133 =
  fun _1 _3 ->
    (
# 366 "lang/parser.mly"
                    ( [_1;_3] )
# 3433 "lang/parser.ml"
     : (
# 138 "lang/parser.mly"
      (Term.t list)
# 3437 "lang/parser.ml"
    ))

let _menhir_action_134 =
  fun _1 _3 ->
    (
# 367 "lang/parser.mly"
                           ( _1::_3 )
# 3445 "lang/parser.ml"
     : (
# 138 "lang/parser.mly"
      (Term.t list)
# 3449 "lang/parser.ml"
    ))

let _menhir_action_135 =
  fun _endpos__1_ _startpos__1_ ->
    let _ = let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 177 "lang/parser.mly"
          ( raise (Parse_error (_loc, "Syntax error!")) )
# 3460 "lang/parser.ml"
     : (
# 103 "lang/parser.mly"
      (Term.t)
# 3464 "lang/parser.ml"
    )) in
    prerr_string "Menhir: misuse: the semantic action associated with the production\ninteractive -> error\nis expected to abort the parser, but does not do so.\n";
    assert false

let _menhir_action_136 =
  fun _1 ->
    (
# 178 "lang/parser.mly"
                 ( _1 )
# 3474 "lang/parser.ml"
     : (
# 103 "lang/parser.mly"
      (Term.t)
# 3478 "lang/parser.ml"
    ))

let _menhir_action_137 =
  fun () ->
    (
# 179 "lang/parser.mly"
        ( raise End_of_file )
# 3486 "lang/parser.ml"
     : (
# 103 "lang/parser.mly"
      (Term.t)
# 3490 "lang/parser.ml"
    ))

let _menhir_action_138 =
  fun _1 ->
    (
# 449 "lang/parser.mly"
                             ( [_1] )
# 3498 "lang/parser.ml"
     : (
# 139 "lang/parser.mly"
      (Parser_helper.let_opt_el list)
# 3502 "lang/parser.ml"
    ))

let _menhir_action_139 =
  fun _1 _3 ->
    (
# 450 "lang/parser.mly"
                             ( _1::_3 )
# 3510 "lang/parser.ml"
     : (
# 139 "lang/parser.mly"
      (Parser_helper.let_opt_el list)
# 3514 "lang/parser.ml"
    ))

let _menhir_action_140 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 445 "lang/parser.mly"
                  ( _1, mk ~pos:_loc (Var _1) )
# 3525 "lang/parser.ml"
     : (
# 140 "lang/parser.mly"
      (Parser_helper.let_opt_el)
# 3529 "lang/parser.ml"
    ))

let _menhir_action_141 =
  fun _1 _3 ->
    (
# 446 "lang/parser.mly"
                  ( _1, _3 )
# 3537 "lang/parser.ml"
     : (
# 140 "lang/parser.mly"
      (Parser_helper.let_opt_el)
# 3541 "lang/parser.ml"
    ))

let _menhir_action_142 =
  fun _2 ->
    (
# 407 "lang/parser.mly"
                                       ( PList _2 )
# 3549 "lang/parser.ml"
     : (
# 141 "lang/parser.mly"
      (Term.pattern)
# 3553 "lang/parser.ml"
    ))

let _menhir_action_143 =
  fun _1 ->
    (
# 422 "lang/parser.mly"
                                     ( PMeth (None,              _1) )
# 3561 "lang/parser.ml"
     : (
# 142 "lang/parser.mly"
      (Term.pattern)
# 3565 "lang/parser.ml"
    ))

let _menhir_action_144 =
  fun _1 _3 ->
    (
# 423 "lang/parser.mly"
                                     ( PMeth (Some (PVar [_1]),  _3) )
# 3573 "lang/parser.ml"
     : (
# 142 "lang/parser.mly"
      (Term.pattern)
# 3577 "lang/parser.ml"
    ))

let _menhir_action_145 =
  fun _3 ->
    (
# 424 "lang/parser.mly"
                                     ( PMeth (Some (PVar ["_"]), _3) )
# 3585 "lang/parser.ml"
     : (
# 142 "lang/parser.mly"
      (Term.pattern)
# 3589 "lang/parser.ml"
    ))

let _menhir_action_146 =
  fun _1 _3 ->
    (
# 425 "lang/parser.mly"
                                     ( PMeth (Some _1,           _3) )
# 3597 "lang/parser.ml"
     : (
# 142 "lang/parser.mly"
      (Term.pattern)
# 3601 "lang/parser.ml"
    ))

let _menhir_action_147 =
  fun _1 _3 ->
    (
# 426 "lang/parser.mly"
                                     ( PMeth (Some _1,           _3) )
# 3609 "lang/parser.ml"
     : (
# 142 "lang/parser.mly"
      (Term.pattern)
# 3613 "lang/parser.ml"
    ))

let _menhir_action_148 =
  fun _1 ->
    (
# 410 "lang/parser.mly"
                     ( _1, None )
# 3621 "lang/parser.ml"
     : (
# 143 "lang/parser.mly"
      (Parser_helper.meth_pattern_el)
# 3625 "lang/parser.ml"
    ))

let _menhir_action_149 =
  fun _1 _3 ->
    (
# 411 "lang/parser.mly"
                     ( _1, Some _3 )
# 3633 "lang/parser.ml"
     : (
# 143 "lang/parser.mly"
      (Parser_helper.meth_pattern_el)
# 3637 "lang/parser.ml"
    ))

let _menhir_action_150 =
  fun () ->
    (
# 414 "lang/parser.mly"
                                            ( [] )
# 3645 "lang/parser.ml"
     : (
# 144 "lang/parser.mly"
      (Parser_helper.meth_pattern_el list)
# 3649 "lang/parser.ml"
    ))

let _menhir_action_151 =
  fun _1 ->
    (
# 415 "lang/parser.mly"
                                            ( [_1] )
# 3657 "lang/parser.ml"
     : (
# 144 "lang/parser.mly"
      (Parser_helper.meth_pattern_el list)
# 3661 "lang/parser.ml"
    ))

let _menhir_action_152 =
  fun _1 _3 ->
    (
# 416 "lang/parser.mly"
                                            ( _1::_3 )
# 3669 "lang/parser.ml"
     : (
# 144 "lang/parser.mly"
      (Parser_helper.meth_pattern_el list)
# 3673 "lang/parser.ml"
    ))

let _menhir_action_153 =
  fun _1 _3 ->
    (
# 302 "lang/parser.mly"
                            ( _1, _3, None )
# 3681 "lang/parser.ml"
     : (
# 145 "lang/parser.mly"
      (string * Type.t * string option)
# 3685 "lang/parser.ml"
    ))

let _menhir_action_154 =
  fun _1 _2 _3 _5 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 303 "lang/parser.mly"
                            (
       match _2 with
         |"as" ->             _3, _5, Some _1
         | _ -> raise (Parse_error (_loc, "Invalid type constructor")) )
# 3699 "lang/parser.ml"
     : (
# 145 "lang/parser.mly"
      (string * Type.t * string option)
# 3703 "lang/parser.ml"
    ))

let _menhir_action_155 =
  fun _2 ->
    (
# 494 "lang/parser.mly"
              ( Some _2 )
# 3711 "lang/parser.ml"
     : (
# 146 "lang/parser.mly"
      (Term.t option)
# 3715 "lang/parser.ml"
    ))

let _menhir_action_156 =
  fun () ->
    (
# 495 "lang/parser.mly"
              ( None )
# 3723 "lang/parser.ml"
     : (
# 146 "lang/parser.mly"
      (Term.t option)
# 3727 "lang/parser.ml"
    ))

let _menhir_action_157 =
  fun _1 ->
    (
# 384 "lang/parser.mly"
               ( _1 )
# 3735 "lang/parser.ml"
     : (
# 147 "lang/parser.mly"
      (string)
# 3739 "lang/parser.ml"
    ))

let _menhir_action_158 =
  fun () ->
    (
# 385 "lang/parser.mly"
               ( "_" )
# 3747 "lang/parser.ml"
     : (
# 147 "lang/parser.mly"
      (string)
# 3751 "lang/parser.ml"
    ))

let _menhir_action_159 =
  fun _1 ->
    (
# 432 "lang/parser.mly"
                  ( _1 )
# 3759 "lang/parser.ml"
     : (
# 148 "lang/parser.mly"
      (Term.pattern)
# 3763 "lang/parser.ml"
    ))

let _menhir_action_160 =
  fun _1 ->
    (
# 433 "lang/parser.mly"
                  ( _1 )
# 3771 "lang/parser.ml"
     : (
# 148 "lang/parser.mly"
      (Term.pattern)
# 3775 "lang/parser.ml"
    ))

let _menhir_action_161 =
  fun _1 ->
    (
# 434 "lang/parser.mly"
                  ( _1 )
# 3783 "lang/parser.ml"
     : (
# 148 "lang/parser.mly"
      (Term.pattern)
# 3787 "lang/parser.ml"
    ))

let _menhir_action_162 =
  fun _1 ->
    (
# 435 "lang/parser.mly"
                  ( _1 )
# 3795 "lang/parser.ml"
     : (
# 148 "lang/parser.mly"
      (Term.pattern)
# 3799 "lang/parser.ml"
    ))

let _menhir_action_163 =
  fun () ->
    (
# 388 "lang/parser.mly"
                               ( [] )
# 3807 "lang/parser.ml"
     : (
# 149 "lang/parser.mly"
      (Term.pattern list)
# 3811 "lang/parser.ml"
    ))

let _menhir_action_164 =
  fun _1 ->
    (
# 389 "lang/parser.mly"
                               ( [_1] )
# 3819 "lang/parser.ml"
     : (
# 149 "lang/parser.mly"
      (Term.pattern list)
# 3823 "lang/parser.ml"
    ))

let _menhir_action_165 =
  fun _1 _3 ->
    (
# 390 "lang/parser.mly"
                               ( _1@[_3] )
# 3831 "lang/parser.ml"
     : (
# 149 "lang/parser.mly"
      (Term.pattern list)
# 3835 "lang/parser.ml"
    ))

let _menhir_action_166 =
  fun _1 ->
    (
# 397 "lang/parser.mly"
                                                 ( [], Some _1, [] )
# 3843 "lang/parser.ml"
     : (
# 150 "lang/parser.mly"
      (Term.pattern list * string option * Term.pattern list)
# 3847 "lang/parser.ml"
    ))

let _menhir_action_167 =
  fun _1 ->
    (
# 398 "lang/parser.mly"
                                                 ( [], None,    _1 )
# 3855 "lang/parser.ml"
     : (
# 150 "lang/parser.mly"
      (Term.pattern list * string option * Term.pattern list)
# 3859 "lang/parser.ml"
    ))

let _menhir_action_168 =
  fun _1 _3 ->
    (
# 399 "lang/parser.mly"
                                                 ( [], Some _1, _3 )
# 3867 "lang/parser.ml"
     : (
# 150 "lang/parser.mly"
      (Term.pattern list * string option * Term.pattern list)
# 3871 "lang/parser.ml"
    ))

let _menhir_action_169 =
  fun _1 _3 ->
    (
# 400 "lang/parser.mly"
                                                 ( _1, Some _3, [] )
# 3879 "lang/parser.ml"
     : (
# 150 "lang/parser.mly"
      (Term.pattern list * string option * Term.pattern list)
# 3883 "lang/parser.ml"
    ))

let _menhir_action_170 =
  fun _1 _3 _5 ->
    (
# 401 "lang/parser.mly"
                                                 ( _1, Some _3, _5 )
# 3891 "lang/parser.ml"
     : (
# 150 "lang/parser.mly"
      (Term.pattern list * string option * Term.pattern list)
# 3895 "lang/parser.ml"
    ))

let _menhir_action_171 =
  fun _endpos__1_ _startpos__1_ ->
    let _ = let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 173 "lang/parser.mly"
          ( raise (Parse_error (_loc, "Syntax error!")) )
# 3906 "lang/parser.ml"
     : (
# 100 "lang/parser.mly"
      (Term.t)
# 3910 "lang/parser.ml"
    )) in
    prerr_string "Menhir: misuse: the semantic action associated with the production\nprogram -> error\nis expected to abort the parser, but does not do so.\n";
    assert false

let _menhir_action_172 =
  fun _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 174 "lang/parser.mly"
        ( mk ~pos:_loc unit )
# 3923 "lang/parser.ml"
     : (
# 100 "lang/parser.mly"
      (Term.t)
# 3927 "lang/parser.ml"
    ))

let _menhir_action_173 =
  fun _1 ->
    (
# 175 "lang/parser.mly"
              ( _1 )
# 3935 "lang/parser.ml"
     : (
# 100 "lang/parser.mly"
      (Term.t)
# 3939 "lang/parser.ml"
    ))

let _menhir_action_174 =
  fun _1 _3 ->
    (
# 533 "lang/parser.mly"
                  ( fun ~pos e -> mk ~pos (Meth (_1, _3, e)) )
# 3947 "lang/parser.ml"
     : (
# 151 "lang/parser.mly"
      (Parser_helper.record)
# 3951 "lang/parser.ml"
    ))

let _menhir_action_175 =
  fun _1 _3 _5 ->
    (
# 534 "lang/parser.mly"
                               ( fun ~pos e -> mk ~pos (Meth (_3, _5, _1 ~pos e)) )
# 3959 "lang/parser.ml"
     : (
# 151 "lang/parser.mly"
      (Parser_helper.record)
# 3963 "lang/parser.ml"
    ))

let _menhir_action_176 =
  fun _2 ->
    (
# 419 "lang/parser.mly"
                                ( _2 )
# 3971 "lang/parser.ml"
     : (
# 152 "lang/parser.mly"
      (Parser_helper.meth_pattern_el list)
# 3975 "lang/parser.ml"
    ))

let _menhir_action_177 =
  fun _endpos__0_ ->
    let _endpos = _endpos__0_ in
    let _startpos = _endpos__0_ in
    let _loc = (_startpos, _endpos) in
    (
# 295 "lang/parser.mly"
                            ( Type.make ~pos:_loc (Type.Tuple []) )
# 3986 "lang/parser.ml"
     : (
# 153 "lang/parser.mly"
      (Type.t)
# 3990 "lang/parser.ml"
    ))

let _menhir_action_178 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 296 "lang/parser.mly"
                            ( let name, ty, json_name = _1 in
                              Type.meth ~pos:_loc ?json_name name ([], ty) (Type.make ~pos:_loc (Type.Tuple [])) )
# 4002 "lang/parser.ml"
     : (
# 153 "lang/parser.mly"
      (Type.t)
# 4006 "lang/parser.ml"
    ))

let _menhir_action_179 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 298 "lang/parser.mly"
                            ( let name, ty, json_name = _1 in
                              Type.meth ~pos:_loc ?json_name name ([], ty) _3 )
# 4018 "lang/parser.ml"
     : (
# 153 "lang/parser.mly"
      (Type.t)
# 4022 "lang/parser.ml"
    ))

let _menhir_action_180 =
  fun () ->
    (
# 181 "lang/parser.mly"
     ()
# 4030 "lang/parser.ml"
     : (
# 154 "lang/parser.mly"
      (unit)
# 4034 "lang/parser.ml"
    ))

let _menhir_action_181 =
  fun () ->
    (
# 181 "lang/parser.mly"
               ()
# 4042 "lang/parser.ml"
     : (
# 154 "lang/parser.mly"
      (unit)
# 4046 "lang/parser.ml"
    ))

let _menhir_action_182 =
  fun () ->
    (
# 393 "lang/parser.mly"
                     ( "_" )
# 4054 "lang/parser.ml"
     : (
# 155 "lang/parser.mly"
      (string)
# 4058 "lang/parser.ml"
    ))

let _menhir_action_183 =
  fun _2 ->
    (
# 394 "lang/parser.mly"
                     ( _2 )
# 4066 "lang/parser.ml"
     : (
# 155 "lang/parser.mly"
      (string)
# 4070 "lang/parser.ml"
    ))

let _menhir_action_184 =
  fun _1 _3 ->
    (
# 438 "lang/parser.mly"
                        ( _1::_3 )
# 4078 "lang/parser.ml"
     : (
# 156 "lang/parser.mly"
      (string list)
# 4082 "lang/parser.ml"
    ))

let _menhir_action_185 =
  fun _1 _3 ->
    (
# 502 "lang/parser.mly"
                             ( _1::_3 )
# 4090 "lang/parser.ml"
     : (
# 157 "lang/parser.mly"
      (string list)
# 4094 "lang/parser.ml"
    ))

let _menhir_action_186 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 279 "lang/parser.mly"
             ( mk_time_pred ~pos:_loc (between ~pos:_loc (fst _1) (snd _1)) )
# 4105 "lang/parser.ml"
     : (
# 112 "lang/parser.mly"
      (Term.t)
# 4109 "lang/parser.ml"
    ))

let _menhir_action_187 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 280 "lang/parser.mly"
             ( mk_time_pred ~pos:_loc (during ~pos:_loc _1) )
# 4120 "lang/parser.ml"
     : (
# 112 "lang/parser.mly"
      (Term.t)
# 4124 "lang/parser.ml"
    ))

let _menhir_action_188 =
  fun _2 ->
    (
# 404 "lang/parser.mly"
                                       ( PTuple _2 )
# 4132 "lang/parser.ml"
     : (
# 158 "lang/parser.mly"
      (Term.pattern)
# 4136 "lang/parser.ml"
    ))

let _menhir_action_189 =
  fun _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 283 "lang/parser.mly"
                                 ( Type.var ~pos:_loc () )
# 4147 "lang/parser.ml"
     : (
# 159 "lang/parser.mly"
      (Type.t)
# 4151 "lang/parser.ml"
    ))

let _menhir_action_190 =
  fun _1 _endpos__1_ _startpos__1_ ->
    let _endpos = _endpos__1_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 284 "lang/parser.mly"
                                 ( mk_ty ~pos:_loc _1 )
# 4162 "lang/parser.ml"
     : (
# 159 "lang/parser.mly"
      (Type.t)
# 4166 "lang/parser.ml"
    ))

let _menhir_action_191 =
  fun _1 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 285 "lang/parser.mly"
                                 ( Type.make ~pos:_loc (Type.Nullable _1) )
# 4177 "lang/parser.ml"
     : (
# 159 "lang/parser.mly"
      (Type.t)
# 4181 "lang/parser.ml"
    ))

let _menhir_action_192 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 286 "lang/parser.mly"
                                 ( Type.make ~pos:_loc (Type.(List {t = _2; json_repr = `Tuple})) )
# 4192 "lang/parser.ml"
     : (
# 159 "lang/parser.mly"
      (Type.t)
# 4196 "lang/parser.ml"
    ))

let _menhir_action_193 =
  fun _2 _4 _5 _7 _endpos__7_ _startpos__1_ ->
    let _endpos = _endpos__7_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 287 "lang/parser.mly"
                                 ( mk_json_assoc_object_ty ~pos:_loc (_2,_4,_5,_7) )
# 4207 "lang/parser.ml"
     : (
# 159 "lang/parser.mly"
      (Type.t)
# 4211 "lang/parser.ml"
    ))

let _menhir_action_194 =
  fun _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 288 "lang/parser.mly"
                                 ( Type.make ~pos:_loc (Type.Tuple _2) )
# 4222 "lang/parser.ml"
     : (
# 159 "lang/parser.mly"
      (Type.t)
# 4226 "lang/parser.ml"
    ))

let _menhir_action_195 =
  fun _2 _5 _endpos__5_ _startpos__1_ ->
    let _endpos = _endpos__5_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 289 "lang/parser.mly"
                                 ( Type.make ~pos:_loc (Type.Arrow (_2,_5)) )
# 4237 "lang/parser.ml"
     : (
# 159 "lang/parser.mly"
      (Type.t)
# 4241 "lang/parser.ml"
    ))

let _menhir_action_196 =
  fun _2 ->
    (
# 290 "lang/parser.mly"
                                 ( _2 )
# 4249 "lang/parser.ml"
     : (
# 159 "lang/parser.mly"
      (Type.t)
# 4253 "lang/parser.ml"
    ))

let _menhir_action_197 =
  fun _1 _4 ->
    (
# 291 "lang/parser.mly"
                                 ( Type.remeth _4 _1 )
# 4261 "lang/parser.ml"
     : (
# 159 "lang/parser.mly"
      (Type.t)
# 4265 "lang/parser.ml"
    ))

let _menhir_action_198 =
  fun _1 ->
    (
# 292 "lang/parser.mly"
                                 ( _1 )
# 4273 "lang/parser.ml"
     : (
# 159 "lang/parser.mly"
      (Type.t)
# 4277 "lang/parser.ml"
    ))

let _menhir_action_199 =
  fun _1 ->
    (
# 317 "lang/parser.mly"
                                  ( _1, [] )
# 4285 "lang/parser.ml"
     : (
# 160 "lang/parser.mly"
      (Parser_helper.ty_content)
# 4289 "lang/parser.ml"
    ))

let _menhir_action_200 =
  fun _1 _3 ->
    (
# 318 "lang/parser.mly"
                                  ( _1 ^ "." ^ _3, [] )
# 4297 "lang/parser.ml"
     : (
# 160 "lang/parser.mly"
      (Parser_helper.ty_content)
# 4301 "lang/parser.ml"
    ))

let _menhir_action_201 =
  fun _1 _3 _5 ->
    (
# 319 "lang/parser.mly"
                                  ( _1 ^ "." ^ _3 ^ "." ^ _5, [] )
# 4309 "lang/parser.ml"
     : (
# 160 "lang/parser.mly"
      (Parser_helper.ty_content)
# 4313 "lang/parser.ml"
    ))

let _menhir_action_202 =
  fun _1 _2 ->
    (
# 320 "lang/parser.mly"
                                  ( _1, _2 )
# 4321 "lang/parser.ml"
     : (
# 160 "lang/parser.mly"
      (Parser_helper.ty_content)
# 4325 "lang/parser.ml"
    ))

let _menhir_action_203 =
  fun _1 _3 _4 ->
    (
# 322 "lang/parser.mly"
                                  ( _1 ^ "." ^ _3, _4 )
# 4333 "lang/parser.ml"
     : (
# 160 "lang/parser.mly"
      (Parser_helper.ty_content)
# 4337 "lang/parser.ml"
    ))

let _menhir_action_204 =
  fun _1 _3 _5 _6 ->
    (
# 324 "lang/parser.mly"
                                  ( _1 ^ "." ^ _3 ^ "." ^ _5, _6 )
# 4345 "lang/parser.ml"
     : (
# 160 "lang/parser.mly"
      (Parser_helper.ty_content)
# 4349 "lang/parser.ml"
    ))

let _menhir_action_205 =
  fun _1 ->
    (
# 333 "lang/parser.mly"
                         ( "",_1 )
# 4357 "lang/parser.ml"
     : (
# 161 "lang/parser.mly"
      (Parser_helper.ty_content_arg)
# 4361 "lang/parser.ml"
    ))

let _menhir_action_206 =
  fun _1 ->
    (
# 334 "lang/parser.mly"
                         ( "",_1 )
# 4369 "lang/parser.ml"
     : (
# 161 "lang/parser.mly"
      (Parser_helper.ty_content_arg)
# 4373 "lang/parser.ml"
    ))

let _menhir_action_207 =
  fun _1 _3 ->
    (
# 335 "lang/parser.mly"
                         ( _1,_3 )
# 4381 "lang/parser.ml"
     : (
# 161 "lang/parser.mly"
      (Parser_helper.ty_content_arg)
# 4385 "lang/parser.ml"
    ))

let _menhir_action_208 =
  fun _1 _3 ->
    (
# 336 "lang/parser.mly"
                         ( _1,_3)
# 4393 "lang/parser.ml"
     : (
# 161 "lang/parser.mly"
      (Parser_helper.ty_content_arg)
# 4397 "lang/parser.ml"
    ))

let _menhir_action_209 =
  fun _1 _3 ->
    (
# 337 "lang/parser.mly"
                         ( _1,string_of_int _3)
# 4405 "lang/parser.ml"
     : (
# 161 "lang/parser.mly"
      (Parser_helper.ty_content_arg)
# 4409 "lang/parser.ml"
    ))

let _menhir_action_210 =
  fun () ->
    (
# 328 "lang/parser.mly"
                                         ( [] )
# 4417 "lang/parser.ml"
     : (
# 162 "lang/parser.mly"
      (Parser_helper.ty_content_args)
# 4421 "lang/parser.ml"
    ))

let _menhir_action_211 =
  fun _1 ->
    (
# 329 "lang/parser.mly"
                                         ( [_1] )
# 4429 "lang/parser.ml"
     : (
# 162 "lang/parser.mly"
      (Parser_helper.ty_content_args)
# 4433 "lang/parser.ml"
    ))

let _menhir_action_212 =
  fun _1 _3 ->
    (
# 330 "lang/parser.mly"
                                         ( _1::_3 )
# 4441 "lang/parser.ml"
     : (
# 162 "lang/parser.mly"
      (Parser_helper.ty_content_args)
# 4445 "lang/parser.ml"
    ))

let _menhir_action_213 =
  fun _1 _endpos__2_ _startpos__1_ ->
    let _endpos = _endpos__2_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 309 "lang/parser.mly"
                                  ( mk_source_ty ~pos:_loc _1 [] )
# 4456 "lang/parser.ml"
     : (
# 163 "lang/parser.mly"
      (Type.t)
# 4460 "lang/parser.ml"
    ))

let _menhir_action_214 =
  fun _1 _2 _endpos__3_ _startpos__1_ ->
    let _endpos = _endpos__3_ in
    let _startpos = _startpos__1_ in
    let _loc = (_startpos, _endpos) in
    (
# 310 "lang/parser.mly"
                                  ( mk_source_ty ~pos:_loc _1 _2 )
# 4471 "lang/parser.ml"
     : (
# 163 "lang/parser.mly"
      (Type.t)
# 4475 "lang/parser.ml"
    ))

let _menhir_action_215 =
  fun _1 _3 ->
    (
# 313 "lang/parser.mly"
                        ( [_1,_3] )
# 4483 "lang/parser.ml"
     : (
# 164 "lang/parser.mly"
      ((string * Parser_helper.ty_content) list)
# 4487 "lang/parser.ml"
    ))

let _menhir_action_216 =
  fun _1 _3 _5 ->
    (
# 314 "lang/parser.mly"
                                               ( (_1,_3)::_5 )
# 4495 "lang/parser.ml"
     : (
# 164 "lang/parser.mly"
      ((string * Parser_helper.ty_content) list)
# 4499 "lang/parser.ml"
    ))

let _menhir_action_217 =
  fun _1 _3 ->
    (
# 340 "lang/parser.mly"
                ( [_1; _3] )
# 4507 "lang/parser.ml"
     : (
# 165 "lang/parser.mly"
      (Type.t list)
# 4511 "lang/parser.ml"
    ))

let _menhir_action_218 =
  fun _1 _3 ->
    (
# 341 "lang/parser.mly"
                      ( _1::_3 )
# 4519 "lang/parser.ml"
     : (
# 165 "lang/parser.mly"
      (Type.t list)
# 4523 "lang/parser.ml"
    ))

let _menhir_action_219 =
  fun _1 ->
    (
# 429 "lang/parser.mly"
           ( PVar [_1] )
# 4531 "lang/parser.ml"
     : (
# 166 "lang/parser.mly"
      (Term.pattern)
# 4535 "lang/parser.ml"
    ))

let _menhir_action_220 =
  fun _2 ->
    (
# 354 "lang/parser.mly"
                         ( _2 )
# 4543 "lang/parser.ml"
     : (
# 167 "lang/parser.mly"
      (Parser_helper.varlist)
# 4547 "lang/parser.ml"
    ))

let _menhir_action_221 =
  fun _1 ->
    (
# 474 "lang/parser.mly"
                    ( [_1] )
# 4555 "lang/parser.ml"
     : (
# 168 "lang/parser.mly"
      (string list)
# 4559 "lang/parser.ml"
    ))

let _menhir_action_222 =
  fun _1 _3 ->
    (
# 475 "lang/parser.mly"
                    ( _1::_3 )
# 4567 "lang/parser.ml"
     : (
# 168 "lang/parser.mly"
      (string list)
# 4571 "lang/parser.ml"
    ))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ARGS_OF ->
        "ARGS_OF"
    | BEGIN ->
        "BEGIN"
    | BIN1 _ ->
        "BIN1"
    | BIN2 _ ->
        "BIN2"
    | BIN3 _ ->
        "BIN3"
    | BINB _ ->
        "BINB"
    | BOOL _ ->
        "BOOL"
    | CATCH ->
        "CATCH"
    | COALESCE ->
        "COALESCE"
    | COLON ->
        "COLON"
    | COLONCOLON ->
        "COLONCOLON"
    | COMMA ->
        "COMMA"
    | DEF _ ->
        "DEF"
    | DO ->
        "DO"
    | DOT ->
        "DOT"
    | DOTDOTDOT ->
        "DOTDOTDOT"
    | DOTVAR _ ->
        "DOTVAR"
    | ELSE ->
        "ELSE"
    | ELSIF ->
        "ELSIF"
    | ENCODER _ ->
        "ENCODER"
    | END ->
        "END"
    | EOF ->
        "EOF"
    | FLOAT _ ->
        "FLOAT"
    | FOR ->
        "FOR"
    | FUN ->
        "FUN"
    | GET ->
        "GET"
    | GETS ->
        "GETS"
    | IF ->
        "IF"
    | INT _ ->
        "INT"
    | INTERVAL _ ->
        "INTERVAL"
    | LBRA ->
        "LBRA"
    | LCUR ->
        "LCUR"
    | LET _ ->
        "LET"
    | LETLBRA _ ->
        "LETLBRA"
    | LPAR ->
        "LPAR"
    | MINUS ->
        "MINUS"
    | NOT ->
        "NOT"
    | OPEN ->
        "OPEN"
    | PP_COMMENT _ ->
        "PP_COMMENT"
    | PP_DEF _ ->
        "PP_DEF"
    | PP_DEFINE ->
        "PP_DEFINE"
    | PP_ELSE ->
        "PP_ELSE"
    | PP_ENDIF ->
        "PP_ENDIF"
    | PP_ENDL ->
        "PP_ENDL"
    | PP_IFDEF _ ->
        "PP_IFDEF"
    | PP_IFENCODER ->
        "PP_IFENCODER"
    | PP_IFNDEF _ ->
        "PP_IFNDEF"
    | PP_IFNENCODER ->
        "PP_IFNENCODER"
    | PP_IFVERSION _ ->
        "PP_IFVERSION"
    | PP_INCLUDE _ ->
        "PP_INCLUDE"
    | PP_INT_DOT_LCUR _ ->
        "PP_INT_DOT_LCUR"
    | PP_REGEXP _ ->
        "PP_REGEXP"
    | PP_STRING _ ->
        "PP_STRING"
    | QUESTION ->
        "QUESTION"
    | RBRA ->
        "RBRA"
    | RCUR ->
        "RCUR"
    | REGEXP _ ->
        "REGEXP"
    | REPLACES ->
        "REPLACES"
    | RPAR ->
        "RPAR"
    | SEQ ->
        "SEQ"
    | SEQSEQ ->
        "SEQSEQ"
    | SET ->
        "SET"
    | SLASH ->
        "SLASH"
    | STRING _ ->
        "STRING"
    | THEN ->
        "THEN"
    | TILD ->
        "TILD"
    | TIME _ ->
        "TIME"
    | TIMES ->
        "TIMES"
    | TO ->
        "TO"
    | TRY ->
        "TRY"
    | UMINUS ->
        "UMINUS"
    | UNDERSCORE ->
        "UNDERSCORE"
    | VAR _ ->
        "VAR"
    | VARLBRA _ ->
        "VARLBRA"
    | VARLPAR _ ->
        "VARLPAR"
    | WHILE ->
        "WHILE"
    | YIELDS ->
        "YIELDS"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37-39"]
  
  let rec _menhir_run_018_spec_017 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_annotate_metadata_entry =
    fun _menhir_stack _v ->
      MenhirBox_annotate_metadata_entry _v
  
  let rec _menhir_run_014 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_annotate =
    fun _menhir_stack _v ->
      let _1 = _v in
      let _v = _menhir_action_007 _1 in
      MenhirBox_annotate _v
  
  let rec _menhir_goto_annotate_metadata : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_annotate) _menhir_state -> _menhir_box_annotate =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState000 ->
          _menhir_run_014 _menhir_stack _v
      | MenhirState003 ->
          _menhir_run_004 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_004 : type  ttv_stack. (ttv_stack, _menhir_box_annotate) _menhir_cell1_annotate_metadata_entry -> _ -> _menhir_box_annotate =
    fun _menhir_stack _v ->
      let MenhirCell1_annotate_metadata_entry (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_010 _1 _2 in
      _menhir_goto_annotate_metadata _menhir_stack _v _menhir_s
  
  let rec _menhir_run_005 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_annotate) _menhir_state -> _ -> _menhir_box_annotate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_0 in
              let _v = _menhir_action_016 _1 in
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | STRING _v_2 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_2 in
              let _v = _menhir_action_017 _1 in
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | INT _v_4 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_4 in
              let _v = _menhir_action_013 _1 in
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | FLOAT _v_6 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_6 in
              let _v = _menhir_action_014 _1 in
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | BOOL _v_8 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_8 in
              let _v = _menhir_action_015 _1 in
              _menhir_run_012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_012 : type  ttv_stack. (ttv_stack, _menhir_box_annotate) _menhir_cell1_annotate_key -> _ -> _ -> _ -> _ -> _menhir_box_annotate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_012 _1 _3 in
          _menhir_goto_annotate_metadata_entry _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | COLON ->
          let MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_011 _1 _3 in
          _menhir_goto_annotate_metadata _menhir_stack _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_annotate_metadata_entry : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState017 ->
          _menhir_run_018_spec_017 _menhir_stack _v
      | MenhirState003 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState000 ->
          _menhir_run_003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_003 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_annotate) _menhir_state -> _ -> _menhir_box_annotate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annotate_metadata_entry (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v_0 in
          let _v = _menhir_action_008 _1 in
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState003 _tok
      | STRING _v_2 ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v_2 in
          let _v = _menhir_action_009 _1 in
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState003 _tok
      | _ ->
          _eRR ()
  
  let rec _menhir_run_000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_annotate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_008 _1 in
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000 _tok
      | STRING _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_009 _1 in
          _menhir_run_005 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState000 _tok
      | _ ->
          _eRR ()
  
  let rec _menhir_run_021 : type  ttv_stack. (ttv_stack, _menhir_box_annotate_metadata_entry) _menhir_cell1_annotate_key -> _ -> _ -> _ -> _ -> _menhir_box_annotate_metadata_entry =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_012 _1 _3 in
          _menhir_goto_annotate_metadata_entry _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  let rec _menhir_run_019 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_annotate_metadata_entry) _menhir_state -> _ -> _menhir_box_annotate_metadata_entry =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_annotate_key (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_0 in
              let _v = _menhir_action_016 _1 in
              _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | STRING _v_2 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_2 in
              let _v = _menhir_action_017 _1 in
              _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | INT _v_4 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_4 in
              let _v = _menhir_action_013 _1 in
              _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | FLOAT _v_6 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_6 in
              let _v = _menhir_action_014 _1 in
              _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | BOOL _v_8 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_8 in
              let _v = _menhir_action_015 _1 in
              _menhir_run_021 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  let rec _menhir_run_017 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_annotate_metadata_entry =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_008 _1 in
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState017 _tok
      | STRING _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_009 _1 in
          _menhir_run_019 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState017 _tok
      | _ ->
          _eRR ()
  
  let rec _menhir_run_471 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_program =
    fun _menhir_stack _v _tok ->
      match (_tok : MenhirBasics.token) with
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_173 _1 in
          MenhirBox_program _v
      | _ ->
          _eRR ()
  
  let rec _menhir_run_465 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_interactive =
    fun _menhir_stack _v _tok ->
      match (_tok : MenhirBasics.token) with
      | SEQSEQ ->
          let _1 = _v in
          let _v = _menhir_action_136 _1 in
          MenhirBox_interactive _v
      | _ ->
          _eRR ()
  
  let rec _menhir_run_025 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_WHILE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState025
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState025
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState025
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_1, _startpos_0, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_459 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState025 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState025
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState025
      | TIME _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_025 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_459 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState025 _tok
      | REGEXP _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_459 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState025 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState025
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState025
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState025
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState025
      | INTERVAL _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_025 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_11, _startpos_10, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_459 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState025 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState025
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState025
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState025
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState025
      | FLOAT _v ->
          let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_459 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState025 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState025
      | BOOL _v ->
          let _startpos_14 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_15 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_15, _startpos_14, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_459 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState025 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState025
      | _ ->
          _eRR ()
  
  and _menhir_run_026 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState026
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState026
      | VAR _v_2 ->
          _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState026
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | TIME _v_3 ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v_3) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_026 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_7 ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v_7) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState026 _tok
      | REGEXP _v_11 ->
          let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v_11) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState026 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | INTERVAL _v_15 ->
          let _startpos_16 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_17, _startpos_16, _v_15) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_026 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_19 ->
          let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_21, _startpos_20, _v_19) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState026 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | FLOAT _v_23 ->
          let _startpos_24 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_25 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_25, _startpos_24, _v_23) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState026 _tok
      | ENCODER _v_27 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_27 MenhirState026
      | BOOL _v_28 ->
          let _startpos_29 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_30 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_30, _startpos_29, _v_28) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState026 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | ARGS_OF ->
          _menhir_run_248 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState026
      | RPAR ->
          let _v = _menhir_action_018 () in
          _menhir_run_457 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_027 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState027
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState027
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState027
      | VAR _v_2 ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState027 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState027
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState027
      | TIME _v_6 ->
          let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_027 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_10 ->
          let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState027 _tok
      | REGEXP _v_14 ->
          let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState027 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState027
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState027
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState027
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState027
      | INTERVAL _v_18 ->
          let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_027 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_22 ->
          let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState027 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState027
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState027
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState027
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState027
      | FLOAT _v_26 ->
          let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState027 _tok
      | ENCODER _v_30 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState027
      | BOOL _v_31 ->
          let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState027 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState027
      | _ ->
          _eRR ()
  
  and _menhir_run_455 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VARLBRA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | RBRA ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_091 _1 _2 _endpos__1_ _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState455
      | BINB _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState455
      | BIN3 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState455
      | BIN2 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState455
      | BIN1 _v_4 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState455
      | _ ->
          _eRR ()
  
  and _menhir_run_219 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_TO (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState219
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState219
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState219
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_1, _startpos_0, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState219 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState219
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState219
      | TIME _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_219 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState219 _tok
      | REGEXP _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState219 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState219
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState219
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState219
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState219
      | INTERVAL _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_219 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_11, _startpos_10, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState219 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState219
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState219
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState219
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState219
      | FLOAT _v ->
          let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState219 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState219
      | BOOL _v ->
          let _startpos_14 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_15 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_15, _startpos_14, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState219 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState219
      | _ ->
          _eRR ()
  
  and _menhir_run_220 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_TO as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState220
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState220
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState220
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState220
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState220
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState220
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState220
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState220
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState220
      | BEGIN | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_TO (_menhir_stack, _, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_098 _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_221 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_TIMES (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState221
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState221
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState221
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_1, _startpos_0, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState221 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState221
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState221
      | TIME _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_221 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState221 _tok
      | REGEXP _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState221 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState221
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState221
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState221
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState221
      | INTERVAL _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_221 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_11, _startpos_10, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState221 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState221
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState221
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState221
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState221
      | FLOAT _v ->
          let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState221 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState221
      | BOOL _v ->
          let _startpos_14 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_15 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_15, _startpos_14, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState221 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState221
      | _ ->
          _eRR ()
  
  and _menhir_run_222 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_TIMES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState222
      | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_TIMES (_menhir_stack, _, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_109 _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_223 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          let _menhir_stack = MenhirCell1_DOT (_menhir_stack, _menhir_s) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VARLPAR (_menhir_stack, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState224
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState224
          | VAR _v_2 ->
              _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState224
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | TIME _v_3 ->
              let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v_3) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_224 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_7 ->
              let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v_7) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState224 _tok
          | REGEXP _v_11 ->
              let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v_11) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState224 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | INTERVAL _v_15 ->
              let _startpos_16 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_17, _startpos_16, _v_15) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_224 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_19 ->
              let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_21, _startpos_20, _v_19) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState224 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | FLOAT _v_23 ->
              let _startpos_24 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_25 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_25, _startpos_24, _v_23) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState224 _tok
          | ENCODER _v_27 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_27 MenhirState224
          | BOOL _v_28 ->
              let _startpos_29 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_30 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_30, _startpos_29, _v_28) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState224 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | ARGS_OF ->
              _menhir_run_248 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState224
          | RPAR ->
              let _v = _menhir_action_018 () in
              _menhir_run_279 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | VARLBRA _v ->
          let _menhir_stack = MenhirCell1_DOT (_menhir_stack, _menhir_s) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VARLBRA (_menhir_stack, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState281
          | VARLPAR _v_33 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_33 MenhirState281
          | VARLBRA _v_34 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_34 MenhirState281
          | VAR _v_35 ->
              let _startpos_36 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_37 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_37, _startpos_36, _v_35) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState281 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState281
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState281
          | TIME _v_39 ->
              let _startpos_40 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_41 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_41, _startpos_40, _v_39) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_281 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_43 ->
              let _startpos_44 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_45 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_45, _startpos_44, _v_43) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState281 _tok
          | REGEXP _v_47 ->
              let _startpos_48 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_49 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_49, _startpos_48, _v_47) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState281 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState281
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState281
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState281
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState281
          | INTERVAL _v_51 ->
              let _startpos_52 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_53 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_53, _startpos_52, _v_51) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_281 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_55 ->
              let _startpos_56 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_57 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_57, _startpos_56, _v_55) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState281 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState281
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState281
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState281
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState281
          | FLOAT _v_59 ->
              let _startpos_60 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_61 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_61, _startpos_60, _v_59) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState281 _tok
          | ENCODER _v_63 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_63 MenhirState281
          | BOOL _v_64 ->
              let _startpos_65 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_66 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_66, _startpos_65, _v_64) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState281 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState281
          | _ ->
              _eRR ())
      | VAR _v ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_087 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | LCUR ->
          let _menhir_stack = MenhirCell1_DOT (_menhir_stack, _menhir_s) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LCUR (_menhir_stack, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              let _menhir_s = MenhirState285 in
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | GETS ->
                  _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_225 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState226
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState226
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState226
          | VAR _v_2 ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState226 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState226
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState226
          | TIME _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_226 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_10 ->
              let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState226 _tok
          | REGEXP _v_14 ->
              let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState226 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState226
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState226
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState226
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState226
          | INTERVAL _v_18 ->
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_226 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_22 ->
              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState226 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState226
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState226
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState226
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState226
          | FLOAT _v_26 ->
              let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState226 _tok
          | ENCODER _v_30 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState226
          | BOOL _v_31 ->
              let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState226 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState226
          | _ ->
              _eRR ())
      | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | COALESCE | COLONCOLON | COMMA | DOT | MINUS | QUESTION | RPAR | SET | TIMES | TO ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_227 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState227
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState227
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState227
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState227
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState227
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState227
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState227
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState227
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState227
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState227
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState227
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState227
      | COMMA | RPAR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_021 _1 _3 in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_228 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_SET (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState228
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState228
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_1, _startpos_0, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState228 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
      | TIME _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_228 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState228 _tok
      | REGEXP _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState228 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
      | INTERVAL _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_228 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_11, _startpos_10, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState228 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
      | FLOAT _v ->
          let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState228 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState228
      | BOOL _v ->
          let _startpos_14 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_15 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_15, _startpos_14, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState228 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState228
      | _ ->
          _eRR ()
  
  and _menhir_run_229 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_SET as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState229
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState229
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState229
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState229
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState229
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState229
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState229
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState229
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState229
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState229
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState229
      | BEGIN | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_SET (_menhir_stack, _, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_080 _1 _3 _endpos__1_ _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_230 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_QUESTION (_menhir_stack, _menhir_s, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState230
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState230
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_0, _startpos, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState230 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
      | TIME _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_1, _startpos, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_230 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_2, _startpos, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState230 _tok
      | REGEXP _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState230 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
      | INTERVAL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_230 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState230 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
      | FLOAT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_6, _startpos, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState230 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState230
      | BOOL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_7, _startpos, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState230 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState230
      | _ ->
          _eRR ()
  
  and _menhir_run_231 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_QUESTION as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState231
      | TIMES ->
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState231
      | SET ->
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState231
      | QUESTION ->
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState231
      | MINUS ->
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState231
      | DOT ->
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState231
      | COLONCOLON ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState231
      | COLON ->
          let _menhir_stack = MenhirCell1_COLON (_menhir_stack, MenhirState231) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState238
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState238
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState238
          | VAR _v_2 ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState238
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState238
          | TIME _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_238 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_10 ->
              let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | REGEXP _v_14 ->
              let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState238
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState238
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState238
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState238
          | INTERVAL _v_18 ->
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_238 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_22 ->
              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState238
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState238
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState238
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState238
          | FLOAT _v_26 ->
              let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | ENCODER _v_30 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState238
          | BOOL _v_31 ->
              let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState238
          | _ ->
              _eRR ())
      | COALESCE ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState231
      | BINB _v_35 ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_35 MenhirState231
      | BIN3 _v_36 ->
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_36 MenhirState231
      | BIN2 _v_37 ->
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_37 MenhirState231
      | BIN1 _v_38 ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_38 MenhirState231
      | _ ->
          _eRR ()
  
  and _menhir_run_232 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_MINUS (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState232
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState232
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_1, _startpos_0, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState232 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | TIME _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_232 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState232 _tok
      | REGEXP _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState232 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | INTERVAL _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_232 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_11, _startpos_10, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState232 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | FLOAT _v ->
          let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState232 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState232
      | BOOL _v ->
          let _startpos_14 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_15 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_15, _startpos_14, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState232 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState232
      | _ ->
          _eRR ()
  
  and _menhir_run_233 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_MINUS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState233
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState233
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState233
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState233
      | BEGIN | BIN1 _ | BIN2 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_MINUS (_menhir_stack, _, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_110 _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_234 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_COLONCOLON (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState234
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState234
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_1, _startpos_0, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState234 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
      | TIME _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState234 _tok
      | REGEXP _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState234 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
      | INTERVAL _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_11, _startpos_10, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState234 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
      | FLOAT _v ->
          let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState234 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState234
      | BOOL _v ->
          let _startpos_14 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_15 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_15, _startpos_14, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState234 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState234
      | _ ->
          _eRR ()
  
  and _menhir_run_235 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLONCOLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState235
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState235
      | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_COLONCOLON (_menhir_stack, _, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_090 _1 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_expr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState025 ->
          _menhir_run_459 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState027 ->
          _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState030 ->
          _menhir_run_451 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState037 ->
          _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState038 ->
          _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState430 ->
          _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState039 ->
          _menhir_run_428 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState424 ->
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState041 ->
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState043 ->
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState044 ->
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState412 ->
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState409 ->
          _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState050 ->
          _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState051 ->
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState388 ->
          _menhir_run_389 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState057 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState059 ->
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState062 ->
          _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState363 ->
          _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState067 ->
          _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState318 ->
          _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState315 ->
          _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState312 ->
          _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState467 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState460 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState031 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState448 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState443 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState438 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState047 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState398 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState400 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState402 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState404 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState374 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState069 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState356 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState352 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState345 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState300 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState297 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState213 ->
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState291 ->
          _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState281 ->
          _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState026 ->
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState277 ->
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState224 ->
          _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState246 ->
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState244 ->
          _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState242 ->
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState240 ->
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState238 ->
          _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState236 ->
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState234 ->
          _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState232 ->
          _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState230 ->
          _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState228 ->
          _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState226 ->
          _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState221 ->
          _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState219 ->
          _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState217 ->
          _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_459 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WHILE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState459
      | TIMES ->
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState459
      | SET ->
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState459
      | QUESTION ->
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState459
      | MINUS ->
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState459
      | DOT ->
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState459
      | DO ->
          let _menhir_stack = MenhirCell1_DO (_menhir_stack, MenhirState459) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState460
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState460
          | VAR _v_2 ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState460
          | UNDERSCORE ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_4, _startpos_3) in
              let _v = _menhir_action_158 () in
              _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState460 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | TIME _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_460 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_10 ->
              let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState460 _tok
          | REGEXP _v_14 ->
              let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState460 _tok
          | OPEN ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | LETLBRA _v_18 ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_18 MenhirState460
          | LET _v_19 ->
              let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_startpos__1_, _1) = (_startpos_20, _v_19) in
              let _v = _menhir_action_005 _1 in
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState460 _tok
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | INTERVAL _v_22 ->
              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_460 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_26 ->
              let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState460 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | FLOAT _v_30 ->
              let _startpos_31 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_32 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_32, _startpos_31, _v_30) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState460 _tok
          | ENCODER _v_34 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_34 MenhirState460
          | DEF _v_35 ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_35 MenhirState460
          | BOOL _v_36 ->
              let _startpos_37 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_38 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_38, _startpos_37, _v_36) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState460 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState460
          | _ ->
              _eRR ())
      | COLONCOLON ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState459
      | COALESCE ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState459
      | BINB _v_40 ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_40 MenhirState459
      | BIN3 _v_41 ->
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_41 MenhirState459
      | BIN2 _v_42 ->
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_42 MenhirState459
      | BIN1 _v_43 ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_43 MenhirState459
      | _ ->
          _eRR ()
  
  and _menhir_run_032 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLONCOLON | DEF _ | DOT | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | REGEXP _ | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | GETS ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_157 _1 in
          _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_optvar : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState441 ->
          _menhir_run_442 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState053 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState349 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState320 ->
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState321 ->
          _menhir_run_322 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState467 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState023 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState460 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState448 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState443 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState031 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState438 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState404 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState402 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState400 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState398 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState047 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState374 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState069 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState356 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState352 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState345 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState300 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState297 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState213 ->
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState071 ->
          _menhir_run_102_spec_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState124 ->
          _menhir_run_102_spec_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState302 ->
          _menhir_run_102_spec_302 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState307 ->
          _menhir_run_102_spec_307 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState081 ->
          _menhir_run_102_spec_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState088 ->
          _menhir_run_102_spec_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState089 ->
          _menhir_run_102_spec_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState111 ->
          _menhir_run_102_spec_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState113 ->
          _menhir_run_102_spec_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState097 ->
          _menhir_run_102_spec_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState100 ->
          _menhir_run_102_spec_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState090 ->
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState060 ->
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_442 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | DO ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState443
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState443
          | VAR _v_2 ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState443
          | UNDERSCORE ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_4, _startpos_3) in
              let _v = _menhir_action_158 () in
              _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState443 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | TIME _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_443 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_10 ->
              let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState443 _tok
          | REGEXP _v_14 ->
              let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState443 _tok
          | OPEN ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | LETLBRA _v_18 ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_18 MenhirState443
          | LET _v_19 ->
              let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_startpos__1_, _1) = (_startpos_20, _v_19) in
              let _v = _menhir_action_005 _1 in
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState443 _tok
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | INTERVAL _v_22 ->
              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_443 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_26 ->
              let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState443 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | FLOAT _v_30 ->
              let _startpos_31 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_32 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_32, _startpos_31, _v_30) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState443 _tok
          | ENCODER _v_34 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_34 MenhirState443
          | DEF _v_35 ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_35 MenhirState443
          | BOOL _v_36 ->
              let _startpos_37 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_38 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_38, _startpos_37, _v_36) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState443 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState443
          | _ ->
              _eRR ())
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState446
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_216 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState217
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState217
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState217
          | VAR _v_2 ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState217 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState217
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState217
          | TIME _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_217 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_10 ->
              let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState217 _tok
          | REGEXP _v_14 ->
              let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState217 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState217
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState217
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState217
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState217
          | INTERVAL _v_18 ->
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_217 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_22 ->
              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState217 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState217
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState217
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState217
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState217
          | FLOAT _v_26 ->
              let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState217 _tok
          | ENCODER _v_30 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState217
          | BOOL _v_31 ->
              let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState217 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState217
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_218 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState218
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState218
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState218
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState218
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState218
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState218
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState218
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState218
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState218
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState218
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState218
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState218
      | BEGIN | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_optvar (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_049 _1 _3 in
          _menhir_goto_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_240 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_COALESCE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState240
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState240
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState240
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState240 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState240
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState240
      | TIME _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_240 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState240 _tok
      | REGEXP _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState240 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState240
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState240
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState240
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState240
      | INTERVAL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_240 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState240 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState240
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState240
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState240
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState240
      | FLOAT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState240 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState240
      | BOOL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState240 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState240
      | _ ->
          _eRR ()
  
  and _menhir_run_241 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COALESCE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState241
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState241
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState241
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState241
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState241
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState241
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState241
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState241
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState241
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState241
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState241
      | BEGIN | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_COALESCE (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__3_, _startpos__3_, _3) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_099 _1 _3 _endpos__1_ _endpos__3_ _startpos__1_ _startpos__3_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_242 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_BINB (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState242
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState242
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState242
      | VAR _v_2 ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState242 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState242
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState242
      | TIME _v_6 ->
          let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_242 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_10 ->
          let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState242 _tok
      | REGEXP _v_14 ->
          let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState242 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState242
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState242
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState242
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState242
      | INTERVAL _v_18 ->
          let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_242 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_22 ->
          let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState242 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState242
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState242
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState242
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState242
      | FLOAT _v_26 ->
          let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState242 _tok
      | ENCODER _v_30 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState242
      | BOOL _v_31 ->
          let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState242 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState242
      | _ ->
          _eRR ()
  
  and _menhir_run_243 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BINB as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState243
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState243
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState243
      | BIN1 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState243
      | BEGIN | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_BINB (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__3_, _startpos__3_, _3) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_105 _1 _2 _3 _endpos__1_ _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ _startpos__3_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_236 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_BIN3 (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState236
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState236
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState236
      | VAR _v_2 ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState236 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState236
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState236
      | TIME _v_6 ->
          let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_236 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_10 ->
          let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState236 _tok
      | REGEXP _v_14 ->
          let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState236 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState236
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState236
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState236
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState236
      | INTERVAL _v_18 ->
          let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_236 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_22 ->
          let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState236 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState236
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState236
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState236
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState236
      | FLOAT _v_26 ->
          let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState236 _tok
      | ENCODER _v_30 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState236
      | BOOL _v_31 ->
          let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState236 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState236
      | _ ->
          _eRR ()
  
  and _menhir_run_237 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN3 as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState237
      | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_BIN3 (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_108 _1 _2 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_029 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_UMINUS (_menhir_stack, _menhir_s, _startpos, _endpos) in
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
          | VARLPAR _v ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState030
          | VARLBRA _v ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState030
          | VAR _v ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_2, _startpos_1, _v) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_451 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState030 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
          | TIME _v ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_030 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v ->
              let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_6, _startpos_5, _v) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_451 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState030 _tok
          | REGEXP _v ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_451 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState030 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
          | INTERVAL _v ->
              let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_10, _startpos_9, _v) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_030 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v ->
              let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_451 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState030 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
          | FLOAT _v ->
              let _startpos_13 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_14, _startpos_13, _v) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_451 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState030 _tok
          | ENCODER _v ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState030
          | BOOL _v ->
              let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_451 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState030 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState030
          | _ ->
              _eRR ())
      | INT _v ->
          let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _endpos__2_, _2) = (_startpos, _endpos_18, _v) in
          let _v = _menhir_action_069 _2 _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | FLOAT _v ->
          let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _endpos__2_, _2) = (_startpos, _endpos_20, _v) in
          let _v = _menhir_action_068 _2 _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_451 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UMINUS _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState451
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState451
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState451
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_UMINUS (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_3, _endpos__4_) = (_v, _endpos_0) in
          let _v = _menhir_action_070 _3 _endpos__1_ _endpos__4_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState451
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState451
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState451
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState451
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState451
      | BINB _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState451
      | BIN3 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState451
      | BIN2 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState451
      | BIN1 _v_4 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState451
      | _ ->
          _eRR ()
  
  and _menhir_run_244 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_BIN2 (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState244
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState244
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState244
      | VAR _v_2 ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState244 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState244
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState244
      | TIME _v_6 ->
          let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_244 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_10 ->
          let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState244 _tok
      | REGEXP _v_14 ->
          let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState244 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState244
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState244
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState244
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState244
      | INTERVAL _v_18 ->
          let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_244 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_22 ->
          let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState244 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState244
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState244
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState244
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState244
      | FLOAT _v_26 ->
          let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState244 _tok
      | ENCODER _v_30 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState244
      | BOOL _v_31 ->
          let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState244 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState244
      | _ ->
          _eRR ()
  
  and _menhir_run_245 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN2 as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState245
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState245
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState245
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState245
      | BEGIN | BIN1 _ | BIN2 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_BIN2 (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_107 _1 _2 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_031 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_TRY (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState031
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState031
      | VAR _v ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState031
      | UNDERSCORE ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_1, _startpos_0) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState031 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | TIME _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_031 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState031 _tok
      | REGEXP _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState031 _tok
      | OPEN ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | LETLBRA _v ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState031
      | LET _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos_8, _v) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState031 _tok
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | INTERVAL _v ->
          let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_10, _startpos_9, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_031 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState031 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | FLOAT _v ->
          let _startpos_13 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_14, _startpos_13, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState031 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState031
      | DEF _v ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState031
      | BOOL _v ->
          let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState031 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState031
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_031 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_TRY -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState031 _tok
  
  and _menhir_run_295 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState295
      | TIMES ->
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState295
      | SET ->
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState295
      | SEQ ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos_0 in
          let _v = _menhir_action_181 () in
          _menhir_run_297 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState295 _tok
      | QUESTION ->
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState295
      | MINUS ->
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState295
      | DOT ->
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState295
      | COLONCOLON ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState295
      | COALESCE ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState295
      | BINB _v_2 ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState295
      | BIN3 _v_3 ->
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState295
      | BIN2 _v_4 ->
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState295
      | BIN1 _v_5 ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState295
      | BEGIN | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v = _menhir_action_180 () in
          _menhir_run_297 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v MenhirState295 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_297 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | VARLPAR _v_0 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState297
      | VARLBRA _v_1 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState297
      | VAR _v_2 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState297
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_3, _startpos) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState297 _tok
      | UMINUS ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | TRY ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | TIME _v_5 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_6, _startpos, _v_5) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_297 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_8 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos, _v_8) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState297 _tok
      | REGEXP _v_11 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos, _v_11) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState297 _tok
      | OPEN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | NOT ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | LPAR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | LETLBRA _v_14 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState297
      | LET _v_15 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos, _v_15) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState297 _tok
      | LCUR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | LBRA ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | INTERVAL _v_17 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_18, _startpos, _v_17) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_297 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_20 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_21, _startpos, _v_20) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState297 _tok
      | IF ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | GET ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | FUN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | FOR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | FLOAT _v_23 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos, _v_23) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState297 _tok
      | ENCODER _v_26 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_26 MenhirState297
      | DEF _v_27 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_27 MenhirState297
      | BOOL _v_28 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_29 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_29, _startpos, _v_28) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState297 _tok
      | BEGIN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState297
      | CATCH | ELSE | ELSIF | END | EOF | SEQSEQ | THEN ->
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let _endpos__2_ = _endpos in
          let _v = _menhir_action_113 _1 in
          _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_297 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState297 _tok
  
  and _menhir_run_037 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState037
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState037
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_0, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState037 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | TIME _v ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_1, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_037 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState037 _tok
      | REGEXP _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState037 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | INTERVAL _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_037 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_5, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState037 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | FLOAT _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_6, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState037 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState037
      | BOOL _v ->
          let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_7, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState037 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState037
      | _ ->
          _eRR ()
  
  and _menhir_run_437 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OPEN as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | TIMES ->
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | SET ->
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | SEQ ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos_0 in
          let _v = _menhir_action_181 () in
          _menhir_run_438 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState437 _tok
      | QUESTION ->
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | MINUS ->
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | DOT ->
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | COLONCOLON ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | COALESCE ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState437
      | BINB _v_2 ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState437
      | BIN3 _v_3 ->
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState437
      | BIN2 _v_4 ->
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState437
      | BIN1 _v_5 ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState437
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v = _menhir_action_180 () in
          _menhir_run_438 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v MenhirState437 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_438 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState438
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState438
      | VAR _v_2 ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState438
      | UNDERSCORE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_3, _startpos) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState438 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | TIME _v_5 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_6, _startpos, _v_5) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_438 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_8 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos, _v_8) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState438 _tok
      | REGEXP _v_11 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos, _v_11) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState438 _tok
      | OPEN ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | LETLBRA _v_14 ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState438
      | LET _v_15 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos, _v_15) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState438 _tok
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | INTERVAL _v_17 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_18, _startpos, _v_17) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_438 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_20 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_21, _startpos, _v_20) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState438 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | FLOAT _v_23 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos, _v_23) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState438 _tok
      | ENCODER _v_26 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_26 MenhirState438
      | DEF _v_27 ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_27 MenhirState438
      | BOOL _v_28 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_29 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_29, _startpos, _v_28) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState438 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState438
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_438 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState438 _tok
  
  and _menhir_run_038 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_NOT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_1, _startpos_0, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState038 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | TIME _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_038 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState038 _tok
      | REGEXP _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState038 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | INTERVAL _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_038 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_11, _startpos_10, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState038 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | FLOAT _v ->
          let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState038 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState038
      | BOOL _v ->
          let _startpos_14 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_15 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_15, _startpos_14, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState038 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState038
      | _ ->
          _eRR ()
  
  and _menhir_run_436 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NOT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState436
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState436
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState436
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState436
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState436
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState436
      | BEGIN | BIN1 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_NOT (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_073 _2 _endpos__1_ _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_038 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NOT -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState038 _tok
  
  and _menhir_run_039 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | VARLPAR _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState039
      | VARLBRA _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState039
      | VAR _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_0, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_428 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState039 _tok
      | UMINUS ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | TRY ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | TIME _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_1, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_039 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_428 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState039 _tok
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _endpos__2_) = (_startpos, _endpos) in
          let _v = _menhir_action_082 _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | REGEXP _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_428 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState039 _tok
      | NOT ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | LPAR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | LCUR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | LBRA ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | INTERVAL _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_039 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_5, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_428 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState039 _tok
      | IF ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | GET ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | FUN ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | FOR ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | FLOAT _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_6, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_428 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState039 _tok
      | ENCODER _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState039
      | BOOL _v ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_7, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_428 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState039 _tok
      | BEGIN ->
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState039
      | _ ->
          _eRR ()
  
  and _menhir_run_428 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState428
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState428
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState428
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_071 _2 in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState428
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState428
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState428
      | COMMA ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState428
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState428
      | COLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _menhir_stack = MenhirCell1_COLON (_menhir_stack, MenhirState428) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_1 ->
              _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState433
          | VAR _v_2 ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
              let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_434 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState433 _tok
          | UNDERSCORE ->
              let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_7, _startpos_6) in
              let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
              _menhir_run_434 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState433 _tok
          | LPAR ->
              _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState433
          | LCUR ->
              _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState433
          | LBRA ->
              _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState433
          | _ ->
              _eRR ())
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState428
      | BINB _v_9 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState428
      | BIN3 _v_10 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState428
      | BIN2 _v_11 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState428
      | BIN1 _v_12 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState428
      | _ ->
          _eRR ()
  
  and _menhir_run_430 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_COMMA (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState430
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState430
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState430
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState430 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState430
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState430
      | TIME _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_430 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState430 _tok
      | REGEXP _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState430 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState430
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState430
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState430
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState430
      | INTERVAL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_430 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState430 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState430
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState430
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState430
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState430
      | FLOAT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState430 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState430
      | BOOL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState430 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState430
      | _ ->
          _eRR ()
  
  and _menhir_run_432 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COMMA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | COMMA ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState432
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState432
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState432
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState432
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState432
      | RPAR ->
          let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_133 _1 _3 in
          _menhir_goto_inner_tuple _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_246 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_BIN1 (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState246
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState246
      | VAR _v_2 ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState246 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | TIME _v_6 ->
          let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_246 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_10 ->
          let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState246 _tok
      | REGEXP _v_14 ->
          let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState246 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | INTERVAL _v_18 ->
          let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_246 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_22 ->
          let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState246 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | FLOAT _v_26 ->
          let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState246 _tok
      | ENCODER _v_30 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState246
      | BOOL _v_31 ->
          let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState246 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState246
      | _ ->
          _eRR ()
  
  and _menhir_run_247 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN1 as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState247
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState247
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState247
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState247
      | BIN3 _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState247
      | BIN2 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState247
      | BEGIN | BIN1 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_BIN1 (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_106 _1 _2 _3 _endpos__2_ _endpos__3_ _startpos__1_ _startpos__2_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_246 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN1 -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState246 _tok
  
  and _menhir_run_041 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState041
      | VARLPAR _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState041
      | VARLBRA _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState041
      | VAR _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState041, _v, _startpos_0, _endpos) in
              _menhir_run_043 _menhir_stack _menhir_lexbuf _menhir_lexer
          | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | COALESCE | COLONCOLON | DOT | MINUS | QUESTION | RCUR | SEQ | SET | TIMES | TO ->
              let _v =
                let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_0, _v) in
                _menhir_action_077 _1 _endpos__1_ _startpos__1_
              in
              _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos_0 _v MenhirState041 _tok
          | _ ->
              _eRR ())
      | UMINUS ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState041
      | TRY ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState041
      | TIME _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_1, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_041 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState041 _tok
      | REGEXP _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState041 _tok
      | RCUR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _endpos__2_) = (_startpos, _endpos) in
          let _v = _menhir_action_086 _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | NOT ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState041
      | LPAR ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState041
      | LCUR ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState041
      | LBRA ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState041
      | INTERVAL _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_041 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_5, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState041 _tok
      | IF ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState041
      | GET ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState041
      | FUN ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState041
      | FOR ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState041
      | FLOAT _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_6, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState041 _tok
      | ENCODER _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState041
      | BOOL _v ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_7, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState041 _tok
      | BEGIN ->
          let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState041
      | _ ->
          _eRR ()
  
  and _menhir_run_043 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState043 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | TIME _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_043 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState043 _tok
      | REGEXP _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState043 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | INTERVAL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_043 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState043 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | FLOAT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState043 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState043
      | BOOL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState043 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState043
      | _ ->
          _eRR ()
  
  and _menhir_run_417 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState417
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState417
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState417
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState417
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState417
      | COMMA | RCUR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_174 _1 _3 in
          _menhir_goto_record _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_record : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState041 ->
          _menhir_run_419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState285 ->
          _menhir_run_287 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_419 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LCUR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RCUR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_085 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | COMMA ->
          let _menhir_stack = MenhirCell1_record (_menhir_stack, _menhir_s, _v) in
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_289 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_record -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WHILE ->
                  _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | VARLPAR _v_0 ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState291
              | VARLBRA _v_1 ->
                  _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState291
              | VAR _v_2 ->
                  let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
                  let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState291 _tok
              | UMINUS ->
                  _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | TRY ->
                  _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | TIME _v_6 ->
                  let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
                  let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_215_spec_291 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
              | STRING _v_10 ->
                  let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
                  let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState291 _tok
              | REGEXP _v_14 ->
                  let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
                  let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState291 _tok
              | NOT ->
                  _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | LPAR ->
                  _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | LCUR ->
                  _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | LBRA ->
                  _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | INTERVAL _v_18 ->
                  let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
                  let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_215_spec_291 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
              | INT _v_22 ->
                  let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
                  let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState291 _tok
              | IF ->
                  _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | GET ->
                  _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | FUN ->
                  _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | FOR ->
                  _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | FLOAT _v_26 ->
                  let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
                  let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState291 _tok
              | ENCODER _v_30 ->
                  _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState291
              | BOOL _v_31 ->
                  let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
                  let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState291 _tok
              | BEGIN ->
                  _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState291
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_292 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_record _menhir_cell0_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState292
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState292
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState292
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState292
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState292
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState292
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState292
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState292
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState292
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState292
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState292
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState292
      | COMMA | RCUR ->
          let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
          let MenhirCell1_record (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_175 _1 _3 _5 in
          _menhir_goto_record _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_291 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_record _menhir_cell0_VAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState291 _tok
  
  and _menhir_run_044 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState044
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState044
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_0, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState044 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | TIME _v ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_1, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_044 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState044 _tok
      | REGEXP _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState044 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | INTERVAL _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_044 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_5, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState044 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | FLOAT _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_6, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState044 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState044
      | DOTDOTDOT ->
          _menhir_run_409 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | BOOL _v ->
          let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_7, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState044 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState044
      | RBRA ->
          let _v = _menhir_action_130 () in
          _menhir_run_415 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_414 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState414
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState414
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState414
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState414
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState414
      | COMMA | RBRA ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_132 _1 in
          _menhir_goto_inner_list_item _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_inner_list_item : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_inner_list_item (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | VARLPAR _v_1 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState412
          | VARLBRA _v_2 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState412
          | VAR _v_3 ->
              let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v_3) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState412 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | TIME _v_7 ->
              let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v_7) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_412 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_11 ->
              let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v_11) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState412 _tok
          | REGEXP _v_15 ->
              let _startpos_16 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_17, _startpos_16, _v_15) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState412 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | INTERVAL _v_19 ->
              let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_21, _startpos_20, _v_19) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_412 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_23 ->
              let _startpos_24 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_25 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_25, _startpos_24, _v_23) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState412 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | FLOAT _v_27 ->
              let _startpos_28 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_29 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_29, _startpos_28, _v_27) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState412 _tok
          | ENCODER _v_31 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_31 MenhirState412
          | DOTDOTDOT ->
              _menhir_run_409 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | BOOL _v_32 ->
              let _startpos_33 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_34 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_34, _startpos_33, _v_32) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState412 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState412
          | RBRA ->
              let _endpos = _endpos_0 in
              let _v = _menhir_action_130 () in
              _menhir_run_413 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v
          | _ ->
              _eRR ())
      | RBRA ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_129 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_inner_list _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_215_spec_412 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_inner_list_item -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState412 _tok
  
  and _menhir_run_047 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_IF (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState047
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState047
      | VAR _v ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState047
      | UNDERSCORE ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_1, _startpos_0) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState047 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | TIME _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_047 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState047 _tok
      | REGEXP _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState047 _tok
      | OPEN ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | LETLBRA _v ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState047
      | LET _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos_8, _v) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState047 _tok
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | INTERVAL _v ->
          let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_10, _startpos_9, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_047 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState047 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | FLOAT _v ->
          let _startpos_13 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_14, _startpos_13, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState047 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState047
      | DEF _v ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState047
      | BOOL _v ->
          let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState047 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState047
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_047 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_IF -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState047 _tok
  
  and _menhir_run_048 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LETLBRA (_menhir_stack, _menhir_s, _v, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState048
      | _ ->
          _eRR ()
  
  and _menhir_run_049 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState050
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState050
          | VAR _v_2 ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState050 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | TIME _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_050 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_10 ->
              let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState050 _tok
          | REGEXP _v_14 ->
              let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState050 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | INTERVAL _v_18 ->
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_050 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_22 ->
              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState050 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | FLOAT _v_26 ->
              let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState050 _tok
          | ENCODER _v_30 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState050
          | BOOL _v_31 ->
              let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState050 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState050
          | _ ->
              _eRR ())
      | COMMA | RBRA ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_140 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_let_opt_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_391 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState391
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState391
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState391
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState391
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState391
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState391
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState391
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState391
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState391
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState391
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState391
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState391
      | COMMA | RBRA ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_141 _1 _3 in
          _menhir_goto_let_opt_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_let_opt_el : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_let_opt_el (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_049 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState393
          | _ ->
              _eRR ())
      | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_138 _1 in
          _menhir_goto_let_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_goto_let_opt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState048 ->
          _menhir_run_395 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState393 ->
          _menhir_run_394 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_395 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LETLBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LETLBRA (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_006 _1 _2 _endpos__3_ _startpos__1_ in
      _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_302 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1__let (_menhir_stack, _menhir_s, _v, _startpos) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | DOT ->
              let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState302, _v_0, _startpos_1, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v ->
                  _menhir_run_305 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState304
              | LCUR ->
                  _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState304
              | _ ->
                  _eRR ())
          | GETS ->
              let _v_3 =
                let _1 = _v_0 in
                _menhir_action_157 _1
              in
              _menhir_run_102_spec_302 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 _tok
          | _ ->
              _eRR ())
      | UNDERSCORE ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | LPAR ->
          let _menhir_s = MenhirState302 in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState307
          | UNDERSCORE ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState307
          | LPAR ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState307
          | LCUR ->
              _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState307
          | LBRA ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState307
          | COMMA | RPAR ->
              let _v = _menhir_action_163 () in
              _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState307 _tok
          | _ ->
              _eRR ())
      | LCUR ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | LBRA ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState302
      | _ ->
          _eRR ()
  
  and _menhir_run_305 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_305 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState306
          | _ ->
              _eRR ())
      | GETS ->
          let _1 = _v in
          let _v = _menhir_action_124 _1 in
          _menhir_goto_in_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_in_subfield : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState304 ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState263 ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState074 ->
          _menhir_run_123 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState306 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState266 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState076 ->
          _menhir_run_078 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_123 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_184 _1 _3 in
      _menhir_goto_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_subfield : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState071 ->
          _menhir_run_351 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState328 ->
          _menhir_run_339 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState302 ->
          _menhir_run_314 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState249 ->
          _menhir_run_273 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_351 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DEF as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_120 () in
          _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState351 _tok
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v = _menhir_action_119 () in
          _menhir_run_352 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState351 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_352 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_subfield as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_g (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState352
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState352
      | VAR _v_2 ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState352
      | UNDERSCORE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState352 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | TIME _v_4 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_4) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_352 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_6 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_6) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState352 _tok
      | REGEXP _v_8 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_8) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState352 _tok
      | OPEN ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | LETLBRA _v_10 ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState352
      | LET _v_11 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos, _v_11) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState352 _tok
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | INTERVAL _v_13 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_13) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_352 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_15 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_15) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState352 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | FLOAT _v_17 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_17) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState352 _tok
      | ENCODER _v_19 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_19 MenhirState352
      | DEF _v_20 ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_20 MenhirState352
      | BOOL _v_21 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_21) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState352 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState352
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_352 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_subfield, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState352 _tok
  
  and _menhir_run_051 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_GET (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState051
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState051
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_1, _startpos_0, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState051 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | TIME _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_051 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState051 _tok
      | REGEXP _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState051 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | INTERVAL _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_051 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_11, _startpos_10, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState051 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | FLOAT _v ->
          let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState051 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState051
      | BOOL _v ->
          let _startpos_14 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_15 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_15, _startpos_14, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState051 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState051
      | _ ->
          _eRR ()
  
  and _menhir_run_390 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_GET as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState390
      | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COLONCOLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | MINUS | NOT | OPEN | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_GET (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_079 _2 _endpos__1_ _endpos__2_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_051 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_GET -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState051 _tok
  
  and _menhir_run_052 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_FUN (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_1, _v) in
              let _v = _menhir_action_157 _1 in
              _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState053 _tok
          | UNDERSCORE ->
              let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_2) in
              let _v = _menhir_action_158 () in
              _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState053 _tok
          | TILD ->
              _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
          | LPAR ->
              _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
          | ARGS_OF ->
              _menhir_run_327 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState053
          | RPAR ->
              let _v = _menhir_action_036 () in
              _menhir_run_386 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState053
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_341 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState341
      | COMMA | RPAR ->
          let _v = _menhir_action_156 () in
          _menhir_run_342 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_059 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_GETS (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState059
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState059
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState059 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | TIME _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_059 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState059 _tok
      | REGEXP _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState059 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | INTERVAL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_059 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState059 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | FLOAT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState059 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState059
      | BOOL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState059 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState059
      | _ ->
          _eRR ()
  
  and _menhir_run_377 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_GETS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState377
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState377
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState377
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState377
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState377
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState377
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState377
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState377
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState377
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState377
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState377
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState377
      | COMMA | RPAR ->
          let MenhirCell1_GETS (_menhir_stack, _menhir_s) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_155 _2 in
          _menhir_goto_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_opt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState384 ->
          _menhir_run_385 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState056 ->
          _menhir_run_379 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState058 ->
          _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState341 ->
          _menhir_run_342 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState325 ->
          _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_385 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_LPAR _menhir_cell0_VAR, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ty (_menhir_stack, _, _5, _, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
      let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_TILD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _7 = _v in
      let _v = _menhir_action_028 _3 _5 _7 in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_arg : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_arg (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_0) in
              let _v = _menhir_action_157 _1 in
              _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState349 _tok
          | UNDERSCORE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_158 () in
              _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState349 _tok
          | TILD ->
              _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState349
          | LPAR ->
              _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState349
          | ARGS_OF ->
              _menhir_run_327 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState349
          | RPAR ->
              let _v = _menhir_action_036 () in
              _menhir_run_350 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_037 _1 in
          _menhir_goto_arglist _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_055 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_TILD (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              let _menhir_stack = MenhirCell1_GETS (_menhir_stack, MenhirState056) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WHILE ->
                  _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
              | VARLPAR _v_0 ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState057
              | VARLBRA _v_1 ->
                  _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState057
              | VAR _v_2 ->
                  let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
                  let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState057 _tok
              | UNDERSCORE ->
                  let _menhir_s = MenhirState057 in
                  let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _menhir_stack = MenhirCell1_UNDERSCORE (_menhir_stack, _menhir_s, _startpos, _endpos) in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | GETS ->
                      _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState058
                  | COMMA | RPAR ->
                      let _v = _menhir_action_156 () in
                      _menhir_run_378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
                  | _ ->
                      _eRR ())
              | UMINUS ->
                  _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
              | TRY ->
                  _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
              | TIME _v_9 ->
                  let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_11, _startpos_10, _v_9) in
                  let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_215_spec_057 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
              | STRING _v_13 ->
                  let _startpos_14 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_15 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_15, _startpos_14, _v_13) in
                  let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState057 _tok
              | REGEXP _v_17 ->
                  let _startpos_18 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_19 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_19, _startpos_18, _v_17) in
                  let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState057 _tok
              | NOT ->
                  _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
              | LPAR ->
                  _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
              | LCUR ->
                  _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
              | LBRA ->
                  _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
              | INTERVAL _v_21 ->
                  let _startpos_22 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_23 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_23, _startpos_22, _v_21) in
                  let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_215_spec_057 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
              | INT _v_25 ->
                  let _startpos_26 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_27 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_27, _startpos_26, _v_25) in
                  let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState057 _tok
              | IF ->
                  _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
              | GET ->
                  _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
              | FUN ->
                  _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
              | FOR ->
                  _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
              | FLOAT _v_29 ->
                  let _startpos_30 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_31 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_31, _startpos_30, _v_29) in
                  let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState057 _tok
              | ENCODER _v_33 ->
                  _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_33 MenhirState057
              | BOOL _v_34 ->
                  let _startpos_35 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_36 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_36, _startpos_35, _v_34) in
                  let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState057 _tok
              | BEGIN ->
                  _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState057
              | _ ->
                  _eRR ())
          | COMMA | RPAR ->
              let _v = _menhir_action_156 () in
              _menhir_run_379 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              _eRR ())
      | LPAR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              let _startpos_39 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos_39, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | VARLPAR _v_40 ->
                      _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v_40 MenhirState382
                  | VAR _v_41 ->
                      let _startpos_42 = _menhir_lexbuf.Lexing.lex_start_p in
                      let _endpos_43 = _menhir_lexbuf.Lexing.lex_curr_p in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      let (_endpos__1_, _startpos__1_, _1) = (_endpos_43, _startpos_42, _v_41) in
                      let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
                      _menhir_run_383 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState382 _tok
                  | UNDERSCORE ->
                      let _startpos_45 = _menhir_lexbuf.Lexing.lex_start_p in
                      let _endpos_46 = _menhir_lexbuf.Lexing.lex_curr_p in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      let (_endpos__1_, _startpos__1_) = (_endpos_46, _startpos_45) in
                      let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
                      _menhir_run_383 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState382 _tok
                  | LPAR ->
                      _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState382
                  | LCUR ->
                      _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState382
                  | LBRA ->
                      _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState382
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_378 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_VAR, ttv_result) _menhir_cell1_GETS, ttv_result) _menhir_cell1_UNDERSCORE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_UNDERSCORE (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_GETS (_menhir_stack, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell1_TILD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _5 = _v in
      let _v = _menhir_action_029 _2 _5 _endpos__2_ _startpos__2_ in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_215_spec_057 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_VAR, ttv_result) _menhir_cell1_GETS -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState057 _tok
  
  and _menhir_run_060 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_FOR (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_1, _startpos_0, _v) in
          let _v = _menhir_action_157 _1 in
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState060 _tok
      | UNDERSCORE ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_3, _startpos_2) in
          let _v = _menhir_action_158 () in
          _menhir_run_061 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState060 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_061 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FOR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState062
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState062
          | VAR _v_2 ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState062 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | TIME _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_062 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_10 ->
              let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState062 _tok
          | REGEXP _v_14 ->
              let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState062 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | INTERVAL _v_18 ->
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_062 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_22 ->
              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState062 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | FLOAT _v_26 ->
              let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState062 _tok
          | ENCODER _v_30 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState062
          | BOOL _v_31 ->
              let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState062 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState062
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_373 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TO ->
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState373
      | TIMES ->
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState373
      | SET ->
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState373
      | QUESTION ->
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState373
      | MINUS ->
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState373
      | DOT ->
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState373
      | DO ->
          let _menhir_stack = MenhirCell1_DO (_menhir_stack, MenhirState373) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState374
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState374
          | VAR _v_2 ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState374
          | UNDERSCORE ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_4, _startpos_3) in
              let _v = _menhir_action_158 () in
              _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState374 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | TIME _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_374 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_10 ->
              let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState374 _tok
          | REGEXP _v_14 ->
              let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState374 _tok
          | OPEN ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | LETLBRA _v_18 ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_18 MenhirState374
          | LET _v_19 ->
              let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_startpos__1_, _1) = (_startpos_20, _v_19) in
              let _v = _menhir_action_005 _1 in
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState374 _tok
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | INTERVAL _v_22 ->
              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_374 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_26 ->
              let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState374 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | FLOAT _v_30 ->
              let _startpos_31 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_32 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_32, _startpos_31, _v_30) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState374 _tok
          | ENCODER _v_34 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_34 MenhirState374
          | DEF _v_35 ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_35 MenhirState374
          | BOOL _v_36 ->
              let _startpos_37 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_38 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_38, _startpos_37, _v_36) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState374 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState374
          | _ ->
              _eRR ())
      | COLONCOLON ->
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState373
      | COALESCE ->
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState373
      | BINB _v_40 ->
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_40 MenhirState373
      | BIN3 _v_41 ->
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_41 MenhirState373
      | BIN2 _v_42 ->
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_42 MenhirState373
      | BIN1 _v_43 ->
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_43 MenhirState373
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_374 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DO -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState374 _tok
  
  and _menhir_run_064 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ENCODER (_menhir_stack, _menhir_s, _v, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState064
      | BEGIN | BIN1 _ | BIN2 _ | BIN3 _ | BINB _ | BOOL _ | CATCH | COALESCE | COLON | COLONCOLON | COMMA | DEF _ | DO | DOT | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | MINUS | NOT | OPEN | QUESTION | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | SET | STRING _ | THEN | TIME _ | TIMES | TO | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v = _menhir_action_057 () in
          _menhir_run_372 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_065 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ENCODER as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState065
      | STRING _v ->
          _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState065
      | ENCODER _v ->
          _menhir_run_365 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState065
      | RPAR ->
          let _v = _menhir_action_064 () in
          _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_066 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState067
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState067
          | VAR _v_2 ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState067 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | TIME _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_067 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_10 ->
              let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState067 _tok
          | REGEXP _v_14 ->
              let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState067 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | INTERVAL _v_18 ->
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_067 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_22 ->
              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState067 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | FLOAT _v_26 ->
              let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState067 _tok
          | ENCODER _v_30 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState067
          | BOOL _v_31 ->
              let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState067 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState067
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_061 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_361 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState361
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState361
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState361
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState361
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState361
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState361
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState361
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState361
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState361
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState361
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState361
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState361
      | COMMA | RPAR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_059 _1 _3 in
          _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_encoder_param : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_encoder_param (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_066 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState370
          | STRING _v ->
              _menhir_run_362 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState370
          | ENCODER _v ->
              _menhir_run_365 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState370
          | RPAR ->
              let _v = _menhir_action_064 () in
              _menhir_run_371 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_065 _1 in
          _menhir_goto_encoder_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_362 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_STRING (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState363
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState363
          | VAR _v_2 ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState363 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | TIME _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_363 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_10 ->
              let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState363 _tok
          | REGEXP _v_14 ->
              let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState363 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | INTERVAL _v_18 ->
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_20, _startpos_19, _v_18) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_363 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_22 ->
              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState363 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | FLOAT _v_26 ->
              let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState363 _tok
          | ENCODER _v_30 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState363
          | BOOL _v_31 ->
              let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState363 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState363
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_062 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_364 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STRING as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState364
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState364
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState364
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState364
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState364
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState364
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState364
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState364
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState364
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState364
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState364
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState364
      | COMMA | RPAR ->
          let MenhirCell1_STRING (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_060 _1 _3 in
          _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_363 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_STRING -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState363 _tok
  
  and _menhir_run_069 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_BEGIN (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState069
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState069
      | VAR _v ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState069
      | UNDERSCORE ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState069 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | TIME _v ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_1, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_069 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState069 _tok
      | REGEXP _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState069 _tok
      | OPEN ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | LETLBRA _v ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState069
      | LET _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos_4, _v) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState069 _tok
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | INTERVAL _v ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_5, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_069 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_6, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState069 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | FLOAT _v ->
          let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_7, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState069 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState069
      | DEF _v ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState069
      | BOOL _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_8, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState069 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState069
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_069 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_BEGIN -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState069 _tok
  
  and _menhir_run_071 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_DEF (_menhir_stack, _menhir_s, _v, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v_0 ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v_0 in
          let _v = _menhir_action_221 _1 in
          _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState071 _tok
      | VAR _v_3 ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | DOT ->
              let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState071, _v_3, _startpos_4, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VARLPAR _v_5 ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let _1 = _v_5 in
                  let _v = _menhir_action_221 _1 in
                  _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
              | VAR _v_9 ->
                  _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState074
              | LCUR ->
                  _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState074
              | _ ->
                  _eRR ())
          | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | GETS | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
              let _v_10 =
                let _1 = _v_3 in
                _menhir_action_157 _1
              in
              _menhir_run_102_spec_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 _tok
          | _ ->
              _eRR ())
      | UNDERSCORE ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | LPAR ->
          let _menhir_s = MenhirState071 in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState124
          | UNDERSCORE ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
          | LPAR ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
          | LCUR ->
              _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
          | LBRA ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState124
          | COMMA | RPAR ->
              let _v = _menhir_action_163 () in
              _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState124 _tok
          | _ ->
              _eRR ())
      | LCUR ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | LBRA ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState071
      | _ ->
          _eRR ()
  
  and _menhir_run_320 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DEF as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_varlpar (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_0) in
          let _v = _menhir_action_157 _1 in
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState320 _tok
      | UNDERSCORE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_158 () in
          _menhir_run_341 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState320 _tok
      | TILD ->
          _menhir_run_055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState320
      | LPAR ->
          _menhir_run_321 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState320
      | ARGS_OF ->
          _menhir_run_327 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState320
      | RPAR ->
          let _v = _menhir_action_036 () in
          _menhir_run_343 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState320
      | _ ->
          _eRR ()
  
  and _menhir_run_321 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_0, _v) in
          let _v = _menhir_action_157 _1 in
          _menhir_run_322 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState321 _tok
      | UNDERSCORE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_158 () in
          _menhir_run_322 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState321 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_322 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_optvar (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState323
          | VAR _v_1 ->
              let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v_1) in
              let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState323 _tok
          | UNDERSCORE ->
              let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_6, _startpos_5) in
              let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
              _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState323 _tok
          | LPAR ->
              _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
          | LCUR ->
              _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
          | LBRA ->
              _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState323
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_127 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          let _menhir_stack = MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState127
      | RPAR ->
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1, _endpos__2_) = (_startpos, _v, _endpos_1) in
          let _v = _menhir_action_213 _1 _endpos__2_ _startpos__1_ in
          _menhir_goto_ty_source _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_128 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell0_VARLPAR (_menhir_stack, _v_0, _startpos_1, _endpos_2) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v_3 ->
                  _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState130
              | STRING _v_4 ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let _1 = _v_4 in
                  let _v = _menhir_action_206 _1 in
                  _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState130 _tok
              | RPAR ->
                  let _v = _menhir_action_210 () in
                  _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer _v
              | _ ->
                  _eRR ())
          | VAR _v_9 ->
              let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | DOT ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | VARLPAR _v_12 ->
                      let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v_9, _startpos_10, _endpos_11) in
                      let _startpos_13 = _menhir_lexbuf.Lexing.lex_start_p in
                      let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
                      let _menhir_stack = MenhirCell0_VARLPAR (_menhir_stack, _v_12, _startpos_13, _endpos_14) in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | VAR _v_15 ->
                          _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState144
                      | STRING _v_16 ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          let _1 = _v_16 in
                          let _v = _menhir_action_206 _1 in
                          _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState144 _tok
                      | RPAR ->
                          let _v = _menhir_action_210 () in
                          _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _v
                      | _ ->
                          _eRR ())
                  | VAR _v_21 ->
                      let _startpos_22 = _menhir_lexbuf.Lexing.lex_start_p in
                      let _endpos_23 = _menhir_lexbuf.Lexing.lex_curr_p in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | DOT ->
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          (match (_tok : MenhirBasics.token) with
                          | VARLPAR _v_24 ->
                              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v_9, _startpos_10, _endpos_11) in
                              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v_21, _startpos_22, _endpos_23) in
                              let _startpos_25 = _menhir_lexbuf.Lexing.lex_start_p in
                              let _endpos_26 = _menhir_lexbuf.Lexing.lex_curr_p in
                              let _menhir_stack = MenhirCell0_VARLPAR (_menhir_stack, _v_24, _startpos_25, _endpos_26) in
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              (match (_tok : MenhirBasics.token) with
                              | VAR _v_27 ->
                                  _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v_27 MenhirState149
                              | STRING _v_28 ->
                                  let _tok = _menhir_lexer _menhir_lexbuf in
                                  let _1 = _v_28 in
                                  let _v = _menhir_action_206 _1 in
                                  _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState149 _tok
                              | RPAR ->
                                  let _v = _menhir_action_210 () in
                                  _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer _v
                              | _ ->
                                  _eRR ())
                          | VAR _v_33 ->
                              let _tok = _menhir_lexer _menhir_lexbuf in
                              let (_1, _3, _5) = (_v_9, _v_21, _v_33) in
                              let _v = _menhir_action_201 _1 _3 _5 in
                              _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
                          | _ ->
                              _eRR ())
                      | COMMA | RPAR ->
                          let (_1, _3) = (_v_9, _v_21) in
                          let _v = _menhir_action_200 _1 _3 in
                          _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | COMMA | RPAR ->
                  let _1 = _v_9 in
                  let _v = _menhir_action_199 _1 in
                  _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_131 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _3) = (_v, _v_0) in
              let _v = _menhir_action_207 _1 _3 in
              _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | STRING _v_3 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _3) = (_v, _v_3) in
              let _v = _menhir_action_208 _1 _3 in
              _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | INT _v_6 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_1, _3) = (_v, _v_6) in
              let _v = _menhir_action_209 _1 _3 in
              _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_205 _1 in
          _menhir_goto_ty_content_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_ty_content_arg : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_139 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_ty_content_arg (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              _menhir_run_131 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState140
          | STRING _v_1 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_1 in
              let _v = _menhir_action_206 _1 in
              _menhir_run_139 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState140 _tok
          | RPAR ->
              let _v = _menhir_action_210 () in
              _menhir_run_141 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_211 _1 in
          _menhir_goto_ty_content_args _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_141 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty_content_arg -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_ty_content_arg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_212 _1 _3 in
      _menhir_goto_ty_content_args _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_ty_content_args : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState149 ->
          _menhir_run_150 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState144 ->
          _menhir_run_145 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState140 ->
          _menhir_run_141 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState130 ->
          _menhir_run_137 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_150 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_VAR _menhir_cell0_VAR _menhir_cell0_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_VARLPAR (_menhir_stack, _5, _, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _1, _, _) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_204 _1 _3 _5 _6 in
      _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_ty_content : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell0_ty_content (_menhir_stack, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_128 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState154
          | _ ->
              _eRR ())
      | RPAR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_215 _1 _3 in
          _menhir_goto_ty_source_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_ty_source_params : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState127 ->
          _menhir_run_157 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState154 ->
          _menhir_run_155 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_157 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_214 _1 _2 _endpos__3_ _startpos__1_ in
      _menhir_goto_ty_source _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_ty_source : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_198 _1 in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_ty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState433 ->
          _menhir_run_434 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState382 ->
          _menhir_run_383 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState323 ->
          _menhir_run_324 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState309 ->
          _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState126 ->
          _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState208 ->
          _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState203 ->
          _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState199 ->
          _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState161 ->
          _menhir_run_198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState194 ->
          _menhir_run_195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState163 ->
          _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState166 ->
          _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState181 ->
          _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState167 ->
          _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_434 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_COLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _2, _, _) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_067 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_175 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let _endpos__2_ = _endpos in
      let _v = _menhir_action_191 _1 _endpos__2_ _startpos__1_ in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_176 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LCUR ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_LCUR (_menhir_stack, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_165 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState177
          | STRING _v ->
              _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState177
          | RCUR ->
              let _endpos__0_ = _endpos in
              let _v = _menhir_action_177 _endpos__0_ in
              _menhir_run_183 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_165 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState166
          | VAR _v_1 ->
              let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v_1) in
              let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState166 _tok
          | UNDERSCORE ->
              let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_6, _startpos_5) in
              let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
              _menhir_run_188 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState166 _tok
          | LPAR ->
              _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
          | LCUR ->
              _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
          | LBRA ->
              _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState166
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_188 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RCUR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_153 _1 _3 in
          _menhir_goto_meth_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_meth_ty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_meth_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_165 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState186
          | STRING _v ->
              _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState186
          | RCUR ->
              let _endpos__0_ = _endpos in
              let _v = _menhir_action_177 _endpos__0_ in
              _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v
          | _ ->
              _eRR ())
      | RCUR ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_178 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_record_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_178 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_STRING (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v_0, _startpos_1, _endpos_2) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_3 ->
              let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v_3, _startpos_4, _endpos_5) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | VARLPAR _v_6 ->
                      _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState181
                  | VAR _v_7 ->
                      let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
                      let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v_7) in
                      let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
                      _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState181 _tok
                  | UNDERSCORE ->
                      let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
                      let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      let (_endpos__1_, _startpos__1_) = (_endpos_12, _startpos_11) in
                      let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
                      _menhir_run_182 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState181 _tok
                  | LPAR ->
                      _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState181
                  | LCUR ->
                      _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState181
                  | LBRA ->
                      _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState181
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_182 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STRING _menhir_cell0_VAR _menhir_cell0_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RCUR ->
          let MenhirCell0_VAR (_menhir_stack, _3, _, _) = _menhir_stack in
          let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
          let MenhirCell1_STRING (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_5, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_154 _1 _2 _3 _5 _endpos__5_ _startpos__1_ in
          _menhir_goto_meth_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_161 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState161
      | VAR _v ->
          _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState161
      | UNDERSCORE ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_0) in
          let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
          _menhir_run_198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState161 _tok
      | QUESTION ->
          _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState161
      | LPAR ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState161
      | LCUR ->
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState161
      | LBRA ->
          _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState161
      | RPAR ->
          let _v = _menhir_action_043 () in
          _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState161
      | _ ->
          _eRR ()
  
  and _menhir_run_162 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState163
          | VAR _v_1 ->
              let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v_1) in
              let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState163 _tok
          | UNDERSCORE ->
              let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_6, _startpos_5) in
              let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
              _menhir_run_191 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState163 _tok
          | LPAR ->
              _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState163
          | LCUR ->
              _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState163
          | LBRA ->
              _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState163
          | _ ->
              _eRR ())
      | COMMA | DOT | QUESTION | RPAR | TIMES ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_191 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RPAR ->
          let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_047 _1 _3 in
          _menhir_goto_argty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_argty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_argty (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState203
          | VAR _v_1 ->
              _menhir_run_162 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState203
          | UNDERSCORE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
              _menhir_run_204 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState203 _tok
          | QUESTION ->
              _menhir_run_192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState203
          | LPAR ->
              _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState203
          | LCUR ->
              _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState203
          | LBRA ->
              _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState203
          | RPAR ->
              let _v = _menhir_action_043 () in
              _menhir_run_205 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_044 _1 in
          _menhir_goto_argsty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_204 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_argty as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_046 _1 in
          _menhir_goto_argty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_192 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_QUESTION (_menhir_stack, _menhir_s, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COLON ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VARLPAR _v_1 ->
                  _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState194
              | VAR _v_2 ->
                  let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_4, _startpos_3, _v_2) in
                  let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState194 _tok
              | UNDERSCORE ->
                  let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_) = (_endpos_7, _startpos_6) in
                  let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
                  _menhir_run_195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState194 _tok
              | LPAR ->
                  _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState194
              | LCUR ->
                  _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState194
              | LBRA ->
                  _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState194
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_195 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_QUESTION _menhir_cell0_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RPAR ->
          let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
          let MenhirCell1_QUESTION (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_048 _2 _4 in
          _menhir_goto_argty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_164 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_165 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState164
      | STRING _v ->
          _menhir_run_178 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState164
      | RCUR ->
          let _endpos__0_ = _endpos in
          let _v = _menhir_action_177 _endpos__0_ in
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_189 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos_0) in
      let _v = _menhir_action_196 _2 in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_167 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState167
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_0, _v) in
          let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState167 _tok
      | UNDERSCORE ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos_1) in
          let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
          _menhir_run_169 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState167 _tok
      | LPAR ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState167
      | LCUR ->
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState167
      | LBRA ->
          _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState167
      | _ ->
          _eRR ()
  
  and _menhir_run_169 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RBRA ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_1 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v_4 ->
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (match (_tok : MenhirBasics.token) with
                  | DOT ->
                      let _tok = _menhir_lexer _menhir_lexbuf in
                      (match (_tok : MenhirBasics.token) with
                      | VAR _v_7 ->
                          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
                          let _tok = _menhir_lexer _menhir_lexbuf in
                          let MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
                          let (_2, _5, _4, _7, _endpos__7_) = (_v, _v_4, _v_1, _v_7, _endpos_9) in
                          let _v = _menhir_action_193 _2 _4 _5 _7 _endpos__7_ _startpos__1_ in
                          _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
                      | _ ->
                          _eRR ())
                  | _ ->
                      _eRR ())
              | _ ->
                  _eRR ())
          | COMMA | DOT | QUESTION | RBRA | RCUR | RPAR | TIMES ->
              let MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
              let (_2, _endpos__3_) = (_v, _endpos_0) in
              let _v = _menhir_action_192 _2 _endpos__3_ _startpos__1_ in
              _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
          | _ ->
              _eRR ())
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_205 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_argty -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_argty (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_045 _1 _3 in
      _menhir_goto_argsty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_argsty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState161 ->
          _menhir_run_206 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState203 ->
          _menhir_run_205 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_206 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_argsty (_menhir_stack, _menhir_s, _v) in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | YIELDS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState208
          | VAR _v_1 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_2, _startpos, _v_1) in
              let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState208 _tok
          | UNDERSCORE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_4, _startpos) in
              let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
              _menhir_run_209 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState208 _tok
          | LPAR ->
              _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | LCUR ->
              _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | LBRA ->
              _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState208
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_209 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_argsty _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RBRA | RCUR | RPAR | TIMES ->
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_argsty (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_5, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_195 _2 _5 _endpos__5_ _startpos__1_ in
          _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_198 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_199 _menhir_stack _menhir_lexbuf _menhir_lexer
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_046 _1 in
          _menhir_goto_argty _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_199 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_TIMES (_menhir_stack, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLPAR _v ->
          _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState199
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_1, _startpos_0, _v) in
          let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState199 _tok
      | UNDERSCORE ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_3, _startpos_2) in
          let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
          _menhir_run_201 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState199 _tok
      | LPAR ->
          _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState199
      | LCUR ->
          _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState199
      | LBRA ->
          _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState199
      | _ ->
          _eRR ()
  
  and _menhir_run_201 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ty _menhir_cell0_TIMES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TIMES ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_199 _menhir_stack _menhir_lexbuf _menhir_lexer
      | QUESTION ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          let MenhirCell0_TIMES (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_217 _1 _3 in
          _menhir_goto_ty_tuple _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_ty_tuple : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState199 ->
          _menhir_run_200 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState161 ->
          _menhir_run_196 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_200 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty _menhir_cell0_TIMES -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell0_TIMES (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_218 _1 _3 in
      _menhir_goto_ty_tuple _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_196 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_194 _2 _endpos__3_ _startpos__1_ in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_187 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_meth_ty -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v ->
      let MenhirCell1_meth_ty (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_179 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_record_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s
  
  and _menhir_goto_record_ty : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s ->
      match _menhir_s with
      | MenhirState164 ->
          _menhir_run_189 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState186 ->
          _menhir_run_187 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v
      | MenhirState177 ->
          _menhir_run_183 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_183 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ty _menhir_cell0_LCUR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LCUR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ty (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_4, _endpos__5_) = (_v, _endpos_0) in
      let _v = _menhir_action_197 _1 _4 in
      _menhir_goto_ty _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_383 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_LPAR _menhir_cell0_VAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState384
          | COMMA | RPAR ->
              let _v = _menhir_action_156 () in
              _menhir_run_385 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              _eRR ())
      | QUESTION ->
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_324 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              _menhir_run_059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState325
          | COMMA | RPAR ->
              let _v = _menhir_action_156 () in
              _menhir_run_326 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              _eRR ())
      | QUESTION ->
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_326 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ty (_menhir_stack, _, _4, _, _) = _menhir_stack in
      let MenhirCell1_optvar (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _6 = _v in
      let _v = _menhir_action_031 _2 _4 _6 in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_310 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WHILE ->
                  _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState312
              | VARLPAR _v_1 ->
                  _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState312
              | VARLBRA _v_2 ->
                  _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState312
              | VAR _v_3 ->
                  let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v_3) in
                  let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState312 _tok
              | UMINUS ->
                  _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState312
              | TRY ->
                  _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState312
              | TIME _v_7 ->
                  let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v_7) in
                  let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_215_spec_312 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
              | STRING _v_11 ->
                  let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v_11) in
                  let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState312 _tok
              | REGEXP _v_15 ->
                  let _startpos_16 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_17, _startpos_16, _v_15) in
                  let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState312 _tok
              | NOT ->
                  _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState312
              | LPAR ->
                  _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState312
              | LCUR ->
                  _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState312
              | LBRA ->
                  _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState312
              | INTERVAL _v_19 ->
                  let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_21, _startpos_20, _v_19) in
                  let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_215_spec_312 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
              | INT _v_23 ->
                  let _startpos_24 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_25 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_25, _startpos_24, _v_23) in
                  let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState312 _tok
              | IF ->
                  _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState312
              | GET ->
                  _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState312
              | FUN ->
                  _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState312
              | FOR ->
                  _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState312
              | FLOAT _v_27 ->
                  let _startpos_28 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_29 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_29, _startpos_28, _v_27) in
                  let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState312 _tok
              | ENCODER _v_31 ->
                  _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_31 MenhirState312
              | BOOL _v_32 ->
                  let _startpos_33 = _menhir_lexbuf.Lexing.lex_start_p in
                  let _endpos_34 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_endpos__1_, _startpos__1_, _1) = (_endpos_34, _startpos_33, _v_32) in
                  let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
                  _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState312 _tok
              | BEGIN ->
                  _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState312
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | QUESTION ->
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_313 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState313
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState313
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState313
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState313
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState313
      | BEGIN | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ty (_menhir_stack, _, _5, _, _) = _menhir_stack in
          let MenhirCell1_pattern (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1__let (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_endpos__8_, _8) = (_endpos, _v) in
          let _v = _menhir_action_051 _1 _3 _5 _8 in
          _menhir_goto_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__8_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_binding : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_binding (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEQ ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _endpos__1_ = _endpos_0 in
          let _v = _menhir_action_181 () in
          _menhir_run_300 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v MenhirState299 _tok
      | BEGIN | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v = _menhir_action_180 () in
          _menhir_run_300 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v MenhirState299 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_300 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_binding as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | VARLPAR _v_0 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState300
      | VARLBRA _v_1 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState300
      | VAR _v_2 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState300
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_3, _startpos) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState300 _tok
      | UMINUS ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | TRY ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | TIME _v_5 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_6, _startpos, _v_5) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_300 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_8 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos, _v_8) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState300 _tok
      | REGEXP _v_11 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos, _v_11) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState300 _tok
      | OPEN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | NOT ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | LPAR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | LETLBRA _v_14 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState300
      | LET _v_15 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos, _v_15) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState300 _tok
      | LCUR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | LBRA ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | INTERVAL _v_17 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_18, _startpos, _v_17) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_300 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_20 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_21, _startpos, _v_20) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState300 _tok
      | IF ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | GET ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | FUN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | FOR ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | FLOAT _v_23 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos, _v_23) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState300 _tok
      | ENCODER _v_26 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_26 MenhirState300
      | DEF _v_27 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_27 MenhirState300
      | BOOL _v_28 ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_29 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_29, _startpos, _v_28) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState300 _tok
      | BEGIN ->
          let _menhir_stack = MenhirCell1_s (_menhir_stack, _menhir_s, _v, _endpos) in
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState300
      | CATCH | ELSE | ELSIF | END | EOF | SEQSEQ | THEN ->
          let MenhirCell1_binding (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          let _endpos__2_ = _endpos in
          let _v = _menhir_action_115 _1 _endpos__1_ _endpos__2_ _startpos__1_ in
          _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_300 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_binding, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState300 _tok
  
  and _menhir_goto_exprs : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState467 ->
          _menhir_run_471 _menhir_stack _v _tok
      | MenhirState023 ->
          _menhir_run_465 _menhir_stack _v _tok
      | MenhirState460 ->
          _menhir_run_461 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState448 ->
          _menhir_run_449 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState443 ->
          _menhir_run_444 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState031 ->
          _menhir_run_440 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState438 ->
          _menhir_run_439 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState404 ->
          _menhir_run_405 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState402 ->
          _menhir_run_403 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState400 ->
          _menhir_run_401 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState398 ->
          _menhir_run_399 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState047 ->
          _menhir_run_397 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState374 ->
          _menhir_run_375 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState069 ->
          _menhir_run_359 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState356 ->
          _menhir_run_357 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState352 ->
          _menhir_run_353 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState345 ->
          _menhir_run_346 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState300 ->
          _menhir_run_301 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState297 ->
          _menhir_run_298 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState213 ->
          _menhir_run_293 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_461 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_WHILE, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DO -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_DO (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_WHILE (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__4_, _startpos__4_, _4, _endpos__5_) = (_endpos, _startpos, _v, _endpos_0) in
          let _v = _menhir_action_096 _2 _4 _endpos__1_ _endpos__2_ _endpos__4_ _endpos__5_ _startpos__1_ _startpos__2_ _startpos__4_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_449 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_varlist -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_varlist (_menhir_stack, _, _6, _, _) = _menhir_stack in
          let MenhirCell1_optvar (_menhir_stack, _, _4, _startpos__4_, _endpos__4_) = _menhir_stack in
          let MenhirCell1_exprs (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_TRY (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__8_, _startpos__8_, _8, _endpos__9_) = (_endpos, _startpos, _v, _endpos_0) in
          let _v = _menhir_action_100 _2 _4 _6 _8 _endpos__1_ _endpos__2_ _endpos__4_ _endpos__8_ _endpos__9_ _startpos__1_ _startpos__2_ _startpos__4_ _startpos__8_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__9_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_444 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_optvar (_menhir_stack, _, _4, _startpos__4_, _endpos__4_) = _menhir_stack in
          let MenhirCell1_exprs (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_TRY (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__6_, _startpos__6_, _6, _endpos__7_) = (_endpos, _startpos, _v, _endpos_0) in
          let _v = _menhir_action_101 _2 _4 _6 _endpos__1_ _endpos__2_ _endpos__4_ _endpos__6_ _endpos__7_ _startpos__1_ _startpos__2_ _startpos__4_ _startpos__6_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_440 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TRY as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | CATCH ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v_0 ->
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_2, _startpos_1, _v_0) in
              let _v = _menhir_action_157 _1 in
              _menhir_run_442 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState441 _tok
          | UNDERSCORE ->
              let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_5, _startpos_4) in
              let _v = _menhir_action_158 () in
              _menhir_run_442 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState441 _tok
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_439 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_OPEN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_112 _2 _4 _endpos__4_ _startpos__1_ in
      _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_405 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSE -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let MenhirCell1_ELSE (_menhir_stack, _menhir_s) = _menhir_stack in
      let (_endpos__2_, _startpos__2_, _2) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_122 _2 _endpos__2_ _startpos__2_ in
      _menhir_goto_if_elsif _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _v _menhir_s _tok
  
  and _menhir_goto_if_elsif : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState399 ->
          _menhir_run_407 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState403 ->
          _menhir_run_406 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_407 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_exprs (_menhir_stack, _, _4, _, _endpos__4_) = _menhir_stack in
          let MenhirCell0_THEN (_menhir_stack, _startpos__3_) = _menhir_stack in
          let MenhirCell1_exprs (_menhir_stack, _, _2, _, _) = _menhir_stack in
          let MenhirCell1_IF (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__6_, _5) = (_endpos_0, _v) in
          let _v = _menhir_action_102 _2 _4 _5 _endpos__1_ _endpos__4_ _endpos__6_ _startpos__1_ _startpos__3_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_406 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_exprs (_menhir_stack, _, _4, _, _endpos__4_) = _menhir_stack in
      let MenhirCell0_THEN (_menhir_stack, _startpos__3_) = _menhir_stack in
      let MenhirCell1_exprs (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_ELSIF (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_5, _endpos__5_) = (_v, _endpos) in
      let _v = _menhir_action_121 _2 _4 _5 _endpos__1_ _endpos__4_ _endpos__5_ _startpos__1_ _startpos__3_ in
      _menhir_goto_if_elsif _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _v _menhir_s _tok
  
  and _menhir_run_403 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | ELSIF ->
          _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState403
      | ELSE ->
          _menhir_run_404 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState403
      | END ->
          let _endpos__0_ = _endpos in
          let _v = _menhir_action_123 _endpos__0_ in
          _menhir_run_406 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_400 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ELSIF (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState400
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState400
      | VAR _v ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState400
      | UNDERSCORE ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos_1, _startpos_0) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState400 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | TIME _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos_2, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_400 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState400 _tok
      | REGEXP _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_7, _startpos_6, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState400 _tok
      | OPEN ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | LETLBRA _v ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState400
      | LET _v ->
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos_8, _v) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState400 _tok
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | INTERVAL _v ->
          let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_10, _startpos_9, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_400 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState400 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | FLOAT _v ->
          let _startpos_13 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_14, _startpos_13, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState400 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState400
      | DEF _v ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState400
      | BOOL _v ->
          let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState400 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState400
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_400 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState400 _tok
  
  and _menhir_run_404 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_ELSE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState404
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState404
      | VAR _v ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState404
      | UNDERSCORE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState404 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | TIME _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_404 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState404 _tok
      | REGEXP _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState404 _tok
      | OPEN ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | LETLBRA _v ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState404
      | LET _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos, _v) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState404 _tok
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | INTERVAL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_404 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState404 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | FLOAT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState404 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState404
      | DEF _v ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState404
      | BOOL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState404 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState404
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_404 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSE -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState404 _tok
  
  and _menhir_run_401 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | THEN ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_THEN (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | VARLPAR _v_1 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState402
          | VARLBRA _v_2 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState402
          | VAR _v_3 ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState402
          | UNDERSCORE ->
              let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_5, _startpos_4) in
              let _v = _menhir_action_158 () in
              _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState402 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | TIME _v_7 ->
              let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v_7) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_402 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_11 ->
              let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v_11) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState402 _tok
          | REGEXP _v_15 ->
              let _startpos_16 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_17, _startpos_16, _v_15) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState402 _tok
          | OPEN ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | LETLBRA _v_19 ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_19 MenhirState402
          | LET _v_20 ->
              let _startpos_21 = _menhir_lexbuf.Lexing.lex_start_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_startpos__1_, _1) = (_startpos_21, _v_20) in
              let _v = _menhir_action_005 _1 in
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState402 _tok
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | INTERVAL _v_23 ->
              let _startpos_24 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_25 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_25, _startpos_24, _v_23) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_402 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_27 ->
              let _startpos_28 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_29 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_29, _startpos_28, _v_27) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState402 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | FLOAT _v_31 ->
              let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState402 _tok
          | ENCODER _v_35 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_35 MenhirState402
          | DEF _v_36 ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_36 MenhirState402
          | BOOL _v_37 ->
              let _startpos_38 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_39 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_39, _startpos_38, _v_37) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState402 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState402
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_402 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState402 _tok
  
  and _menhir_run_399 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | ELSIF ->
          _menhir_run_400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState399
      | ELSE ->
          _menhir_run_404 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState399
      | END ->
          let _endpos__0_ = _endpos in
          let _v = _menhir_action_123 _endpos__0_ in
          _menhir_run_407 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_397 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_IF as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_exprs (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | THEN ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_THEN (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | VARLPAR _v_1 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState398
          | VARLBRA _v_2 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState398
          | VAR _v_3 ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState398
          | UNDERSCORE ->
              let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_5, _startpos_4) in
              let _v = _menhir_action_158 () in
              _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState398 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | TIME _v_7 ->
              let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v_7) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_398 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_11 ->
              let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v_11) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState398 _tok
          | REGEXP _v_15 ->
              let _startpos_16 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_17, _startpos_16, _v_15) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState398 _tok
          | OPEN ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | LETLBRA _v_19 ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_19 MenhirState398
          | LET _v_20 ->
              let _startpos_21 = _menhir_lexbuf.Lexing.lex_start_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_startpos__1_, _1) = (_startpos_21, _v_20) in
              let _v = _menhir_action_005 _1 in
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState398 _tok
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | INTERVAL _v_23 ->
              let _startpos_24 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_25 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_25, _startpos_24, _v_23) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_398 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_27 ->
              let _startpos_28 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_29 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_29, _startpos_28, _v_27) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState398 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | FLOAT _v_31 ->
              let _startpos_32 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_33 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_33, _startpos_32, _v_31) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState398 _tok
          | ENCODER _v_35 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_35 MenhirState398
          | DEF _v_36 ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_36 MenhirState398
          | BOOL _v_37 ->
              let _startpos_38 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_39 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_39, _startpos_38, _v_37) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState398 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState398
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_398 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState398 _tok
  
  and _menhir_run_375 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DO -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_DO (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _, _4, _, _) = _menhir_stack in
          let MenhirCell1_optvar (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_FOR (_menhir_stack, _menhir_s, _startpos__1_, _endpos__1_) = _menhir_stack in
          let (_endpos__6_, _startpos__6_, _6, _endpos__7_) = (_endpos, _startpos, _v, _endpos_0) in
          let _v = _menhir_action_097 _2 _4 _6 _endpos__1_ _endpos__2_ _endpos__6_ _endpos__7_ _startpos__1_ _startpos__2_ _startpos__6_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_359 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_BEGIN -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_BEGIN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_093 _2 in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_357 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_g (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_pattern (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_DEF (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_053 _1 _2 _4 in
          _menhir_goto_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_353 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_subfield, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_g (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_subfield (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_DEF (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_055 _1 _2 _4 in
          _menhir_goto_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_346 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_varlpar, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_g (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_arglist (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_varlpar (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_DEF (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_6, _endpos__7_) = (_v, _endpos_0) in
          let _v = _menhir_action_056 _1 _2 _3 _6 in
          _menhir_goto_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_301 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_binding, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_binding (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_116 _1 _3 _endpos__1_ _startpos__1_ in
      _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_298 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_s (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_114 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_exprs _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_293 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | END ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_g (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ty (_menhir_stack, _, _5, _, _) = _menhir_stack in
          let MenhirCell1_pattern (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_DEF (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_8, _endpos__9_) = (_v, _endpos_0) in
          let _v = _menhir_action_054 _1 _3 _5 _8 in
          _menhir_goto_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__9_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_312 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState312 _tok
  
  and _menhir_run_210 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_ty (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | GETS ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _v = _menhir_action_120 () in
              _menhir_run_213 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState211 _tok
          | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
              let _v = _menhir_action_119 () in
              _menhir_run_213 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState211 _tok
          | _ ->
              _eRR ())
      | QUESTION ->
          _menhir_run_175 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          _menhir_run_176 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_213 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_g (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState213
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState213
      | VAR _v_2 ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState213
      | UNDERSCORE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState213 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | TIME _v_4 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_4) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_213 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_6 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_6) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState213 _tok
      | REGEXP _v_8 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_8) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState213 _tok
      | OPEN ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | LETLBRA _v_10 ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState213
      | LET _v_11 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos, _v_11) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState213 _tok
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | INTERVAL _v_13 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_13) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_213 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_15 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_15) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState213 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | FLOAT _v_17 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_17) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState213 _tok
      | ENCODER _v_19 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_19 MenhirState213
      | DEF _v_20 ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_20 MenhirState213
      | BOOL _v_21 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_21) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState213 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState213
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_213 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState213 _tok
  
  and _menhir_run_155 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_ty_content -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell0_ty_content (_menhir_stack, _3) = _menhir_stack in
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _5 = _v in
      let _v = _menhir_action_216 _1 _3 _5 in
      _menhir_goto_ty_source_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_145 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_VAR _menhir_cell0_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_VARLPAR (_menhir_stack, _3, _, _) = _menhir_stack in
      let MenhirCell0_VAR (_menhir_stack, _1, _, _) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_203 _1 _3 _4 in
      _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_137 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR _menhir_cell0_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_VARLPAR (_menhir_stack, _1, _, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_202 _1 _2 in
      _menhir_goto_ty_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_327 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLBRA _v ->
              let _menhir_stack = MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos) in
              let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
              let _menhir_s = MenhirState328 in
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v ->
                  _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState329
              | GET ->
                  _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState329
              | _ ->
                  _eRR ())
          | VAR _v ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_startpos__1_, _3, _endpos__4_) = (_startpos, _v, _endpos_4) in
                  let _v = _menhir_action_032 _3 _endpos__4_ _startpos__1_ in
                  _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | DOT ->
                  let _menhir_stack = MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos) in
                  let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
                  let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState328, _v, _startpos_3, _endpos) in
                  _menhir_run_263 _menhir_stack _menhir_lexbuf _menhir_lexer
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_251 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState252
          | GET ->
              _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState252
          | _ ->
              _eRR ())
      | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_039 _1 in
          _menhir_goto_args_of_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_253 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_stack = MenhirCell1_GET (_menhir_stack, _menhir_s, _startpos, _endpos) in
              let _menhir_stack = MenhirCell0_VAR (_menhir_stack, _v, _startpos_0, _endpos_1) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v ->
                  _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState255
              | GET ->
                  _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState255
              | _ ->
                  _eRR ())
          | RBRA ->
              let _2 = _v in
              let _v = _menhir_action_040 _2 in
              _menhir_goto_args_of_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_goto_args_of_params : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState335 ->
          _menhir_run_336 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState329 ->
          _menhir_run_330 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState269 ->
          _menhir_run_270 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState250 ->
          _menhir_run_258 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState252 ->
          _menhir_run_257 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState255 ->
          _menhir_run_256 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_336 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_subfield_lbra -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_subfield_lbra (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _4) = (_endpos_0, _v) in
          let _v = _menhir_action_035 _3 _4 _endpos__6_ _startpos__1_ in
          _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_330 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_VARLBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLBRA (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _4) = (_endpos_0, _v) in
          let _v = _menhir_action_034 _3 _4 _endpos__6_ _startpos__1_ in
          _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_270 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_subfield_lbra -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_subfield_lbra (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _4) = (_endpos_0, _v) in
          let _v = _menhir_action_026 _3 _4 _endpos__6_ _startpos__1_ in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_app_list_elem : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_app_list_elem (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState277
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState277
          | VAR _v_2 ->
              _menhir_run_225 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState277
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | TIME _v_3 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_3) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_277 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_5 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_5) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState277 _tok
          | REGEXP _v_7 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_7) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState277 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | INTERVAL _v_9 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_9) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_277 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_11 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_11) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState277 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | FLOAT _v_13 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_13) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState277 _tok
          | ENCODER _v_15 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState277
          | BOOL _v_16 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_16) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState277 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | ARGS_OF ->
              _menhir_run_248 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState277
          | RPAR ->
              let _v = _menhir_action_018 () in
              _menhir_run_278 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_019 _1 in
          _menhir_goto_app_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_277 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_app_list_elem -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState277 _tok
  
  and _menhir_run_275 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState275
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState275
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState275
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState275
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState275
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_022 _1 in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_248 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLBRA _v ->
              let _menhir_stack = MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos) in
              let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
              let _menhir_s = MenhirState249 in
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell1_VARLBRA (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | VAR _v ->
                  _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState250
              | GET ->
                  _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState250
              | _ ->
                  _eRR ())
          | VAR _v ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | RPAR ->
                  let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  let (_startpos__1_, _3, _endpos__4_) = (_startpos, _v, _endpos_4) in
                  let _v = _menhir_action_023 _3 _endpos__4_ _startpos__1_ in
                  _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | DOT ->
                  let _menhir_stack = MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos) in
                  let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
                  let _menhir_stack = MenhirCell1_VAR (_menhir_stack, MenhirState249, _v, _startpos_3, _endpos) in
                  _menhir_run_263 _menhir_stack _menhir_lexbuf _menhir_lexer
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_263 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARLBRA _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_126 _1 in
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | VAR _v ->
          _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState263
      | _ ->
          _eRR ()
  
  and _menhir_run_268 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_185 _1 _3 in
      _menhir_goto_subfield_lbra _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_subfield_lbra : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState328 ->
          _menhir_run_335 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState249 ->
          _menhir_run_269 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_335 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield_lbra (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState335
      | GET ->
          _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState335
      | _ ->
          _eRR ()
  
  and _menhir_run_269 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield_lbra (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VAR _v_0 ->
          _menhir_run_251 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState269
      | GET ->
          _menhir_run_253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState269
      | _ ->
          _eRR ()
  
  and _menhir_run_265 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLBRA _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_0 in
              let _v = _menhir_action_126 _1 in
              _menhir_run_267 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | VAR _v_4 ->
              _menhir_run_265 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState266
          | _ ->
              _eRR ())
      | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_124 _1 in
          _menhir_goto_in_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_267 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_127 _1 _3 in
      _menhir_goto_in_subfield_lbra _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_in_subfield_lbra : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState263 ->
          _menhir_run_268 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState266 ->
          _menhir_run_267 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_278 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_app_list_elem -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_app_list_elem (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_020 _1 _3 in
      _menhir_goto_app_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_app_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState026 ->
          _menhir_run_457 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState224 ->
          _menhir_run_279 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState277 ->
          _menhir_run_278 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_457 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_VARLPAR (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_089 _1 _2 _endpos__1_ _endpos__3_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_279 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT _menhir_cell0_VARLPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_VARLPAR (_menhir_stack, _3, _, _endpos__3_) = _menhir_stack in
      let MenhirCell1_DOT (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_4, _endpos__5_) = (_v, _endpos) in
      let _v = _menhir_action_088 _1 _3 _4 _endpos__3_ _endpos__5_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_258 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR, ttv_result) _menhir_cell1_VARLBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARLBRA (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _4) = (_endpos_0, _v) in
          let _v = _menhir_action_025 _3 _4 _endpos__6_ _startpos__1_ in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_257 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_041 _1 _3 in
      _menhir_goto_args_of_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_256 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_GET _menhir_cell0_VAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell0_VAR (_menhir_stack, _2, _, _) = _menhir_stack in
      let MenhirCell1_GET (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      let _4 = _v in
      let _v = _menhir_action_042 _2 _4 in
      _menhir_goto_args_of_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_343 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_varlpar as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_arglist (_menhir_stack, _menhir_s, _v) in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_120 () in
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState344 _tok
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v = _menhir_action_119 () in
          _menhir_run_345 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState344 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_345 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_varlpar, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_g (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState345
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState345
      | VAR _v_2 ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState345
      | UNDERSCORE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState345 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | TIME _v_4 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_4) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_6 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_6) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState345 _tok
      | REGEXP _v_8 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_8) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState345 _tok
      | OPEN ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | LETLBRA _v_10 ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState345
      | LET _v_11 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos, _v_11) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState345 _tok
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | INTERVAL _v_13 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_13) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_15 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_15) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState345 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | FLOAT _v_17 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_17) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState345 _tok
      | ENCODER _v_19 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_19 MenhirState345
      | DEF _v_20 ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_20 MenhirState345
      | BOOL _v_21 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_21) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState345 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState345
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_345 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_varlpar, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState345 _tok
  
  and _menhir_run_077 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_222 _1 _3 in
      _menhir_goto_varlpar _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_varlpar : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState071 ->
          _menhir_run_320 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState074 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState076 ->
          _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_075 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              let _tok = _menhir_lexer _menhir_lexbuf in
              let _1 = _v_0 in
              let _v = _menhir_action_221 _1 in
              _menhir_run_077 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | VAR _v_4 ->
              _menhir_run_075 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState076
          | _ ->
              _eRR ())
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | GETS | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _1 = _v in
          let _v = _menhir_action_124 _1 in
          _menhir_goto_in_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_079 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState079
      | RCUR ->
          let _v = _menhir_action_150 () in
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_080 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState081
          | UNDERSCORE ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
          | LPAR ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
          | LCUR ->
              _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
          | LBRA ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState081
          | _ ->
              _eRR ())
      | COMMA | RCUR ->
          let _1 = _v in
          let _v = _menhir_action_148 _1 in
          _menhir_goto_meth_pattern_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_082 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_VAR (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LCUR ->
              _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState083
          | _ ->
              _eRR ())
      | COLON | COMMA | RBRA | RCUR | RPAR ->
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_157 _1 in
          _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_085 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_UNDERSCORE (_menhir_stack, _menhir_s, _startpos, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LCUR ->
              _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState086
          | _ ->
              _eRR ())
      | BEGIN | BOOL _ | COLON | COMMA | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | GETS | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_158 () in
          _menhir_goto_optvar _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_088 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState088
      | UNDERSCORE ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState088
      | LPAR ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState088
      | LCUR ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState088
      | LBRA ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState088
      | COMMA | RPAR ->
          let _v = _menhir_action_163 () in
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState088 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_089 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState089
      | UNDERSCORE ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
      | LPAR ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
      | LCUR ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
      | LBRA ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
      | DOTDOTDOT ->
          _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState089
      | COMMA | RBRA ->
          let _v = _menhir_action_163 () in
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState089 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_090 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _1 = _v in
          let _v = _menhir_action_157 _1 in
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | UNDERSCORE ->
          let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_158 () in
          _menhir_run_091 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | COMMA | RBRA ->
          let _v = _menhir_action_182 () in
          _menhir_goto_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_091 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_DOTDOTDOT -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_183 _2 in
      _menhir_goto_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_spread : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState111 ->
          _menhir_run_112 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState089 ->
          _menhir_run_096 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_112 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_pattern_list as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_spread (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState113
          | UNDERSCORE ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | LPAR ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | LCUR ->
              _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | LBRA ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState113
          | COMMA | RBRA ->
              let _v = _menhir_action_163 () in
              _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState113 _tok
          | _ ->
              _eRR ())
      | RBRA ->
          let MenhirCell1_pattern_list (_menhir_stack, _, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_169 _1 _3 in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_114 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_pattern_list, ttv_result) _menhir_cell1_spread as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RBRA ->
          let MenhirCell1_spread (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_pattern_list (_menhir_stack, _, _1) = _menhir_stack in
          let _5 = _v in
          let _v = _menhir_action_170 _1 _3 _5 in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_100 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_pattern_list -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VAR _v ->
          _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState100
      | UNDERSCORE ->
          _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | LPAR ->
          _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | LCUR ->
          _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | LBRA ->
          _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState100
      | _ ->
          _eRR ()
  
  and _menhir_goto_pattern_list_with_spread : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRA (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_142 _2 in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _menhir_stack = MenhirCell1_list_pattern (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LCUR ->
              _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState105
          | _ ->
              _eRR ())
      | BEGIN | BOOL _ | COLON | COMMA | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | GETS | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _1 = _v in
          let _v = _menhir_action_161 _1 in
          _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_pattern : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState071 ->
          _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState302 ->
          _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState307 ->
          _menhir_run_308 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState081 ->
          _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState088 ->
          _menhir_run_107_spec_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState089 ->
          _menhir_run_107_spec_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState113 ->
          _menhir_run_107_spec_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState097 ->
          _menhir_run_107_spec_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState111 ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState100 ->
          _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_355 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DEF as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_pattern (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let _v = _menhir_action_120 () in
          _menhir_run_356 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState355 _tok
      | BEGIN | BOOL _ | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let _v = _menhir_action_119 () in
          _menhir_run_356 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState355 _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_356 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_pattern as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_g (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | VARLPAR _v_0 ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState356
      | VARLBRA _v_1 ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState356
      | VAR _v_2 ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState356
      | UNDERSCORE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState356 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | TIME _v_4 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_4) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_356 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v_6 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_6) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState356 _tok
      | REGEXP _v_8 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_8) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState356 _tok
      | OPEN ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | LETLBRA _v_10 ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState356
      | LET _v_11 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos, _v_11) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState356 _tok
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | INTERVAL _v_13 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_13) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_356 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v_15 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_15) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState356 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | FLOAT _v_17 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_17) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState356 _tok
      | ENCODER _v_19 ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_19 MenhirState356
      | DEF _v_20 ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_20 MenhirState356
      | BOOL _v_21 ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_21) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState356 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState356
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_356 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState356 _tok
  
  and _menhir_run_317 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1__let as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_pattern (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState318
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState318
          | VAR _v_2 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_2) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState318 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
          | TIME _v_4 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_4) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_318 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_6 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_6) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState318 _tok
          | REGEXP _v_8 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_8) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState318 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
          | INTERVAL _v_10 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_10) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_318 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_12 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_12) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState318 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
          | FLOAT _v_14 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_14) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState318 _tok
          | ENCODER _v_16 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState318
          | BOOL _v_17 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_17) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState318 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState318
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_319 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_pattern as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState319
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState319
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState319
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState319
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState319
      | BEGIN | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_pattern (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1__let (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_endpos__4_, _4) = (_endpos, _v) in
          let _v = _menhir_action_050 _1 _2 _4 in
          _menhir_goto_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_318 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_pattern -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState318 _tok
  
  and _menhir_run_308 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_stack = MenhirCell1_pattern (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState309
          | VAR _v_1 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_1) in
              let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState309 _tok
          | UNDERSCORE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
              _menhir_run_310 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState309 _tok
          | LPAR ->
              _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState309
          | LCUR ->
              _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState309
          | LBRA ->
              _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState309
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_164 _1 in
          _menhir_goto_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_pattern_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState307 ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState124 ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState088 ->
          _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState113 ->
          _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState089 ->
          _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState097 ->
          _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_115 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_188 _2 in
          (match (_tok : MenhirBasics.token) with
          | DOT ->
              let _menhir_stack = MenhirCell1_tuple_pattern (_menhir_stack, _menhir_s, _v) in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LCUR ->
                  _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState094
              | _ ->
                  _eRR ())
          | BEGIN | BOOL _ | COLON | COMMA | DEF _ | ENCODER _ | FLOAT _ | FOR | FUN | GET | GETS | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | STRING _ | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
              let _1 = _v in
              let _v = _menhir_action_160 _1 in
              _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              _eRR ())
      | COMMA ->
          let _menhir_stack = MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _eRR ()
  
  and _menhir_run_110 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState111
          | UNDERSCORE ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | LPAR ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | LCUR ->
              _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | LBRA ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | DOTDOTDOT ->
              _menhir_run_090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState111
          | _ ->
              _eRR ())
      | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_167 _1 in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_099 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_spread as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _v) in
          _menhir_run_100 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RBRA ->
          let MenhirCell1_spread (_menhir_stack, _, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_168 _1 _3 in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_125 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COLON ->
          let _menhir_stack = MenhirCell1_pattern (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VARLPAR _v_0 ->
              _menhir_run_127 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState126
          | VAR _v_1 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_1) in
              let _v = _menhir_action_190 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState126 _tok
          | UNDERSCORE ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
              let _v = _menhir_action_189 _endpos__1_ _startpos__1_ in
              _menhir_run_210 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState126 _tok
          | LPAR ->
              _menhir_run_161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState126
          | LCUR ->
              _menhir_run_164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState126
          | LBRA ->
              _menhir_run_167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState126
          | _ ->
              _eRR ())
      | COMMA | RPAR ->
          let _1 = _v in
          let _v = _menhir_action_164 _1 in
          _menhir_goto_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_117 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_149 _1 _3 in
      _menhir_goto_meth_pattern_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_meth_pattern_el : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_meth_pattern_el (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_080 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState121
          | RCUR ->
              let _v = _menhir_action_150 () in
              _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v
          | _ ->
              _eRR ())
      | RCUR ->
          let _1 = _v in
          let _v = _menhir_action_151 _1 in
          _menhir_goto_meth_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_122 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_meth_pattern_el -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_meth_pattern_el (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_152 _1 _3 in
      _menhir_goto_meth_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_meth_pattern_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState121 ->
          _menhir_run_122 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState079 ->
          _menhir_run_118 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_118 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_176 _2 in
      _menhir_goto_record_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_record_pattern : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState105 ->
          _menhir_run_106 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState071 ->
          _menhir_run_098_spec_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState302 ->
          _menhir_run_098_spec_302 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState307 ->
          _menhir_run_098_spec_307 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState124 ->
          _menhir_run_098_spec_124 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState081 ->
          _menhir_run_098_spec_081 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState088 ->
          _menhir_run_098_spec_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState111 ->
          _menhir_run_098_spec_111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState113 ->
          _menhir_run_098_spec_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState089 ->
          _menhir_run_098_spec_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState100 ->
          _menhir_run_098_spec_100 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState097 ->
          _menhir_run_098_spec_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState094 ->
          _menhir_run_095 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState086 ->
          _menhir_run_087 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState304 ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState074 ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState083 ->
          _menhir_run_084 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_106 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_list_pattern -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_list_pattern (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_147 _1 _3 in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_meth_pattern : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_162 _1 in
      _menhir_goto_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_098_spec_071 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_DEF -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_143 _1
      in
      let _1 = _v in
      let _v = _menhir_action_162 _1 in
      _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState071 _tok
  
  and _menhir_run_098_spec_302 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1__let -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_143 _1
      in
      let _1 = _v in
      let _v = _menhir_action_162 _1 in
      _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState302 _tok
  
  and _menhir_run_098_spec_307 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_143 _1
      in
      let _1 = _v in
      let _v = _menhir_action_162 _1 in
      _menhir_run_308 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState307 _tok
  
  and _menhir_run_098_spec_124 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_143 _1
      in
      let _1 = _v in
      let _v = _menhir_action_162 _1 in
      _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState124 _tok
  
  and _menhir_run_098_spec_081 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_143 _1
      in
      let _1 = _v in
      let _v = _menhir_action_162 _1 in
      _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_098_spec_088 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_143 _1
      in
      let _1 = _v in
      let _v = _menhir_action_162 _1 in
      _menhir_run_107_spec_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_107_spec_088 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_164 _1 in
      _menhir_run_115 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState088 _tok
  
  and _menhir_run_098_spec_111 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_pattern_list -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_143 _1
      in
      let _1 = _v in
      let _v = _menhir_action_162 _1 in
      _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_101 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_pattern_list -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_pattern_list (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_165 _1 _3 in
      _menhir_goto_pattern_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_098_spec_113 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_pattern_list, ttv_result) _menhir_cell1_spread -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_143 _1
      in
      let _1 = _v in
      let _v = _menhir_action_162 _1 in
      _menhir_run_107_spec_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_107_spec_113 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_pattern_list, ttv_result) _menhir_cell1_spread -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_164 _1 in
      _menhir_run_114 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState113 _tok
  
  and _menhir_run_098_spec_089 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRA -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_143 _1
      in
      let _1 = _v in
      let _v = _menhir_action_162 _1 in
      _menhir_run_107_spec_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_107_spec_089 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRA -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_164 _1 in
      _menhir_run_110 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState089 _tok
  
  and _menhir_run_098_spec_100 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_pattern_list -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_143 _1
      in
      let _1 = _v in
      let _v = _menhir_action_162 _1 in
      _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_098_spec_097 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_spread -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_143 _1
      in
      let _1 = _v in
      let _v = _menhir_action_162 _1 in
      _menhir_run_107_spec_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_107_spec_097 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_spread -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_164 _1 in
      _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState097 _tok
  
  and _menhir_run_095 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_tuple_pattern -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_tuple_pattern (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_146 _1 _3 in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_087 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNDERSCORE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_UNDERSCORE (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_145 _3 in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_084 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_144 _1 _3 in
      _menhir_goto_meth_pattern _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_096 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_spread (_menhir_stack, _menhir_s, _v) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VAR _v ->
              _menhir_run_082 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState097
          | UNDERSCORE ->
              _menhir_run_085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState097
          | LPAR ->
              _menhir_run_088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState097
          | LCUR ->
              _menhir_run_079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState097
          | LBRA ->
              _menhir_run_089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState097
          | COMMA | RBRA ->
              let _v = _menhir_action_163 () in
              _menhir_run_099 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState097 _tok
          | _ ->
              _eRR ())
      | RBRA ->
          let _1 = _v in
          let _v = _menhir_action_166 _1 in
          _menhir_goto_pattern_list_with_spread _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _eRR ()
  
  and _menhir_run_102_spec_071 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_DEF -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_219 _1
      in
      let _1 = _v in
      let _v = _menhir_action_159 _1 in
      _menhir_run_355 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState071 _tok
  
  and _menhir_run_365 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_ENCODER (_menhir_stack, _menhir_s, _v, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          _menhir_run_065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState365
      | COMMA | RPAR ->
          let _v = _menhir_action_057 () in
          _menhir_run_366 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_366 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ENCODER -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_ENCODER (_menhir_stack, _menhir_s, _1, _) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_063 _1 _2 in
      _menhir_goto_encoder_param _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_371 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_encoder_param -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_encoder_param (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_066 _1 _3 in
      _menhir_goto_encoder_params _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_encoder_params : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState370 ->
          _menhir_run_371 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState065 ->
          _menhir_run_367 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_367 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ENCODER, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_058 _2 in
      _menhir_goto_encoder_opt _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
  
  and _menhir_goto_encoder_opt : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ENCODER as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState064 ->
          _menhir_run_372 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState365 ->
          _menhir_run_366 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_372 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ENCODER -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      let MenhirCell1_ENCODER (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_081 _1 _2 _endpos__2_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_215_spec_067 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState067 _tok
  
  and _menhir_run_215_spec_062 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_optvar -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState062 _tok
  
  and _menhir_run_379 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell0_VAR (_menhir_stack, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell1_TILD (_menhir_stack, _menhir_s) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_027 _2 _3 _endpos__2_ _startpos__2_ in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_350 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_arg -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_arg (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_038 _1 _3 in
      _menhir_goto_arglist _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_arglist : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState053 ->
          _menhir_run_386 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState349 ->
          _menhir_run_350 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState320 ->
          _menhir_run_343 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_386 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FUN _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_arglist (_menhir_stack, _menhir_s, _v) in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | YIELDS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState388
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState388
          | VAR _v_2 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_3, _startpos, _v_2) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_389 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState388 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
          | TIME _v_5 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_6, _startpos, _v_5) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_388 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_8 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos, _v_8) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_389 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState388 _tok
          | REGEXP _v_11 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos, _v_11) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_389 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState388 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
          | INTERVAL _v_14 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_15 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_15, _startpos, _v_14) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_388 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_17 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_18 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_18, _startpos, _v_17) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_389 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState388 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
          | FLOAT _v_20 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_21, _startpos, _v_20) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_389 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState388 _tok
          | ENCODER _v_23 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_23 MenhirState388
          | BOOL _v_24 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_25 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_25, _startpos, _v_24) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_389 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState388 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState388
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_389 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_FUN _menhir_cell0_LPAR, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState389
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState389
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState389
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState389
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState389
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState389
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState389
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState389
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState389
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState389
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState389
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState389
      | BEGIN | BOOL _ | CATCH | COLON | COMMA | DEF _ | DO | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | RBRA | RCUR | REGEXP _ | RPAR | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_arglist (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_FUN (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__6_, _6) = (_endpos, _v) in
          let _v = _menhir_action_094 _3 _6 _endpos__6_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_388 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FUN _menhir_cell0_LPAR, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_389 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState388 _tok
  
  and _menhir_run_342 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_optvar -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_optvar (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_030 _1 _2 _endpos__1_ _startpos__1_ in
      _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_215_spec_059 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_GETS -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState059 _tok
  
  and _menhir_run_339 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_3, _endpos__4_) = (_v, _endpos) in
          let _v = _menhir_action_033 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_314 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1__let as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_subfield (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | GETS ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState315
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState315
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState315
          | VAR _v_2 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_2) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState315 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState315
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState315
          | TIME _v_4 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_4) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_315 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_6 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_6) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState315 _tok
          | REGEXP _v_8 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_8) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState315 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState315
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState315
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState315
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState315
          | INTERVAL _v_10 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_10) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_315 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_12 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_12) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState315 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState315
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState315
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState315
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState315
          | FLOAT _v_14 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_14) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState315 _tok
          | ENCODER _v_16 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState315
          | BOOL _v_17 ->
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v_17) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState315 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState315
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_316 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_subfield as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState316
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState316
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState316
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState316
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState316
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState316
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState316
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState316
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState316
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState316
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState316
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState316
      | BEGIN | BOOL _ | CATCH | DEF _ | ELSE | ELSIF | ENCODER _ | END | EOF | FLOAT _ | FOR | FUN | GET | IF | INT _ | INTERVAL _ | LBRA | LCUR | LET _ | LETLBRA _ | LPAR | NOT | OPEN | REGEXP _ | SEQ | SEQSEQ | STRING _ | THEN | TIME _ | TRY | UMINUS | UNDERSCORE | VAR _ | VARLBRA _ | VARLPAR _ | WHILE ->
          let MenhirCell1_subfield (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1__let (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
          let (_endpos__4_, _4) = (_endpos, _v) in
          let _v = _menhir_action_052 _1 _2 _4 in
          _menhir_goto_binding _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_315 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_subfield -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState315 _tok
  
  and _menhir_run_273 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ARGS_OF _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ARGS_OF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_3, _endpos__4_) = (_v, _endpos) in
          let _v = _menhir_action_024 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_app_list_elem _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_078 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VAR, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_VAR (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_125 _1 _3 in
      _menhir_goto_in_subfield _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_102_spec_302 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1__let -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_219 _1
      in
      let _1 = _v in
      let _v = _menhir_action_159 _1 in
      _menhir_run_317 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState302 _tok
  
  and _menhir_run_394 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_let_opt_el -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_let_opt_el (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_139 _1 _3 in
      _menhir_goto_let_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_215_spec_050 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState050 _tok
  
  and _menhir_run_409 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState409
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState409
      | VAR _v ->
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_0, _v) in
          let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState409 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | TIME _v ->
          let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_1, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_409 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_2, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState409 _tok
      | REGEXP _v ->
          let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_3, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState409 _tok
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | INTERVAL _v ->
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_4, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_409 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_5, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState409 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | FLOAT _v ->
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_6, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState409 _tok
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState409
      | BOOL _v ->
          let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos_7, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState409 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState409
      | _ ->
          _eRR ()
  
  and _menhir_run_410 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DOTDOTDOT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState410
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState410
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState410
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState410
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState410
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState410
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState410
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState410
      | BINB _v_0 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState410
      | BIN3 _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState410
      | BIN2 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState410
      | BIN1 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState410
      | COMMA | RBRA ->
          let MenhirCell1_DOTDOTDOT (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_131 _2 in
          _menhir_goto_inner_list_item _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_409 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_DOTDOTDOT -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState409 _tok
  
  and _menhir_run_413 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_inner_list_item -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v ->
      let MenhirCell1_inner_list_item (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_128 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_inner_list _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s
  
  and _menhir_goto_inner_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s ->
      match _menhir_s with
      | MenhirState044 ->
          _menhir_run_415 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState412 ->
          _menhir_run_413 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_415 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRA (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos_0) in
      let _v = _menhir_action_220 _2 in
      _menhir_goto_varlist _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_varlist : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState446 ->
          _menhir_run_447 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState467 ->
          _menhir_run_214_spec_467 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState023 ->
          _menhir_run_214_spec_023 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState460 ->
          _menhir_run_214_spec_460 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState025 ->
          _menhir_run_214_spec_025 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState026 ->
          _menhir_run_214_spec_026 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState027 ->
          _menhir_run_214_spec_027 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState030 ->
          _menhir_run_214_spec_030 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState448 ->
          _menhir_run_214_spec_448 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState443 ->
          _menhir_run_214_spec_443 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState031 ->
          _menhir_run_214_spec_031 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState438 ->
          _menhir_run_214_spec_438 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState037 ->
          _menhir_run_214_spec_037 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState038 ->
          _menhir_run_214_spec_038 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState430 ->
          _menhir_run_214_spec_430 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState039 ->
          _menhir_run_214_spec_039 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState424 ->
          _menhir_run_214_spec_424 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState041 ->
          _menhir_run_214_spec_041 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState043 ->
          _menhir_run_214_spec_043 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState412 ->
          _menhir_run_214_spec_412 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState044 ->
          _menhir_run_214_spec_044 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState409 ->
          _menhir_run_214_spec_409 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState404 ->
          _menhir_run_214_spec_404 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState402 ->
          _menhir_run_214_spec_402 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState400 ->
          _menhir_run_214_spec_400 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState398 ->
          _menhir_run_214_spec_398 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState047 ->
          _menhir_run_214_spec_047 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState050 ->
          _menhir_run_214_spec_050 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState051 ->
          _menhir_run_214_spec_051 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState388 ->
          _menhir_run_214_spec_388 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState057 ->
          _menhir_run_214_spec_057 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState059 ->
          _menhir_run_214_spec_059 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState374 ->
          _menhir_run_214_spec_374 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState062 ->
          _menhir_run_214_spec_062 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState363 ->
          _menhir_run_214_spec_363 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState067 ->
          _menhir_run_214_spec_067 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState069 ->
          _menhir_run_214_spec_069 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState356 ->
          _menhir_run_214_spec_356 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState352 ->
          _menhir_run_214_spec_352 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState345 ->
          _menhir_run_214_spec_345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState318 ->
          _menhir_run_214_spec_318 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState315 ->
          _menhir_run_214_spec_315 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState312 ->
          _menhir_run_214_spec_312 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState300 ->
          _menhir_run_214_spec_300 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState297 ->
          _menhir_run_214_spec_297 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState291 ->
          _menhir_run_214_spec_291 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState281 ->
          _menhir_run_214_spec_281 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState277 ->
          _menhir_run_214_spec_277 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState224 ->
          _menhir_run_214_spec_224 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState246 ->
          _menhir_run_214_spec_246 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState244 ->
          _menhir_run_214_spec_244 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState242 ->
          _menhir_run_214_spec_242 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState240 ->
          _menhir_run_214_spec_240 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState238 ->
          _menhir_run_214_spec_238 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState236 ->
          _menhir_run_214_spec_236 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState234 ->
          _menhir_run_214_spec_234 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState232 ->
          _menhir_run_214_spec_232 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState230 ->
          _menhir_run_214_spec_230 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState228 ->
          _menhir_run_214_spec_228 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState226 ->
          _menhir_run_214_spec_226 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState221 ->
          _menhir_run_214_spec_221 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState219 ->
          _menhir_run_214_spec_219 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState217 ->
          _menhir_run_214_spec_217 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState213 ->
          _menhir_run_214_spec_213 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_447 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_varlist (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | DO ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | VARLPAR _v_0 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState448
          | VARLBRA _v_1 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState448
          | VAR _v_2 ->
              _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState448
          | UNDERSCORE ->
              let _startpos_3 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_) = (_endpos_4, _startpos_3) in
              let _v = _menhir_action_158 () in
              _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState448 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | TIME _v_6 ->
              let _startpos_7 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_8 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_8, _startpos_7, _v_6) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_448 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_10 ->
              let _startpos_11 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_12 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_12, _startpos_11, _v_10) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState448 _tok
          | REGEXP _v_14 ->
              let _startpos_15 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_16 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_16, _startpos_15, _v_14) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState448 _tok
          | OPEN ->
              _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | LETLBRA _v_18 ->
              _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_18 MenhirState448
          | LET _v_19 ->
              let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_startpos__1_, _1) = (_startpos_20, _v_19) in
              let _v = _menhir_action_005 _1 in
              _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState448 _tok
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | INTERVAL _v_22 ->
              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_24, _startpos_23, _v_22) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_448 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_26 ->
              let _startpos_27 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_28 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_28, _startpos_27, _v_26) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState448 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | FLOAT _v_30 ->
              let _startpos_31 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_32 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_32, _startpos_31, _v_30) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState448 _tok
          | ENCODER _v_34 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_34 MenhirState448
          | DEF _v_35 ->
              _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v_35 MenhirState448
          | BOOL _v_36 ->
              let _startpos_37 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_38 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_38, _startpos_37, _v_36) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState448 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState448
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_448 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_varlist -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState448 _tok
  
  and _menhir_run_214_spec_467 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> _ -> _menhir_box_program =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState467 _tok
  
  and _menhir_run_214_spec_023 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> _ -> _menhir_box_interactive =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState023 _tok
  
  and _menhir_run_214_spec_460 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_WHILE, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DO -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState460 _tok
  
  and _menhir_run_214_spec_025 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_WHILE -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_459 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState025 _tok
  
  and _menhir_run_214_spec_026 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VARLPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState026 _tok
  
  and _menhir_run_214_spec_027 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VARLBRA -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState027 _tok
  
  and _menhir_run_214_spec_030 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UMINUS _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_451 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState030 _tok
  
  and _menhir_run_214_spec_448 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_varlist -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState448 _tok
  
  and _menhir_run_214_spec_443 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState443 _tok
  
  and _menhir_run_214_spec_031 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_TRY -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState031 _tok
  
  and _menhir_run_214_spec_438 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OPEN, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState438 _tok
  
  and _menhir_run_214_spec_037 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_OPEN -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState037 _tok
  
  and _menhir_run_214_spec_038 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NOT -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_436 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState038 _tok
  
  and _menhir_run_214_spec_430 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COMMA -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState430 _tok
  
  and _menhir_run_214_spec_039 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_428 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState039 _tok
  
  and _menhir_run_214_spec_424 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_SEQ -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState424 _tok
  
  and _menhir_run_423 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | SEQ ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_SEQ (_menhir_stack, MenhirState423, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WHILE ->
              _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
          | VARLPAR _v_1 ->
              _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState424
          | VARLBRA _v_2 ->
              _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState424
          | VAR _v_3 ->
              let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_5, _startpos_4, _v_3) in
              let _v = _menhir_action_077 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState424 _tok
          | UMINUS ->
              _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
          | TRY ->
              _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
          | TIME _v_7 ->
              let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_9, _startpos_8, _v_7) in
              let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_424 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | STRING _v_11 ->
              let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_13, _startpos_12, _v_11) in
              let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState424 _tok
          | REGEXP _v_15 ->
              let _startpos_16 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_17, _startpos_16, _v_15) in
              let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState424 _tok
          | NOT ->
              _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
          | LPAR ->
              _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
          | LCUR ->
              _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
          | LBRA ->
              _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
          | INTERVAL _v_19 ->
              let _startpos_20 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_21 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_21, _startpos_20, _v_19) in
              let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_215_spec_424 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
          | INT _v_23 ->
              let _startpos_24 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_25 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_25, _startpos_24, _v_23) in
              let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState424 _tok
          | IF ->
              _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
          | GET ->
              _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
          | FUN ->
              _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
          | FOR ->
              _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
          | FLOAT _v_27 ->
              let _startpos_28 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_29 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_29, _startpos_28, _v_27) in
              let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState424 _tok
          | ENCODER _v_31 ->
              _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v_31 MenhirState424
          | BOOL _v_32 ->
              let _startpos_33 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_34 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let (_endpos__1_, _startpos__1_, _1) = (_endpos_34, _startpos_33, _v_32) in
              let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
              _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState424 _tok
          | BEGIN ->
              _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState424
          | _ ->
              _eRR ())
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState423
      | BINB _v_36 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_36 MenhirState423
      | BIN3 _v_37 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_37 MenhirState423
      | BIN2 _v_38 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_38 MenhirState423
      | BIN1 _v_39 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_39 MenhirState423
      | RCUR ->
          let (_endpos__1_, _1) = (_endpos, _v) in
          let _v = _menhir_action_117 _1 in
          _menhir_goto_exprss _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_215_spec_424 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_SEQ -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState424 _tok
  
  and _menhir_goto_exprss : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s ->
      match _menhir_s with
      | MenhirState424 ->
          _menhir_run_425 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v
      | MenhirState041 ->
          _menhir_run_421 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_425 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_SEQ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v ->
      let MenhirCell1_SEQ (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_118 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_exprss _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s
  
  and _menhir_run_421 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LCUR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos_0) in
      let _v = _menhir_action_095 _2 _endpos__3_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_214_spec_041 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState041 _tok
  
  and _menhir_run_214_spec_043 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState043 _tok
  
  and _menhir_run_214_spec_412 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_inner_list_item -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState412 _tok
  
  and _menhir_run_214_spec_044 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRA -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState044 _tok
  
  and _menhir_run_214_spec_409 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_DOTDOTDOT -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_410 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState409 _tok
  
  and _menhir_run_214_spec_404 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSE -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState404 _tok
  
  and _menhir_run_214_spec_402 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState402 _tok
  
  and _menhir_run_214_spec_400 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_ELSIF -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState400 _tok
  
  and _menhir_run_214_spec_398 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_IF, ttv_result) _menhir_cell1_exprs _menhir_cell0_THEN -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState398 _tok
  
  and _menhir_run_214_spec_047 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_IF -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState047 _tok
  
  and _menhir_run_214_spec_050 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_391 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState050 _tok
  
  and _menhir_run_214_spec_051 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_GET -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_390 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState051 _tok
  
  and _menhir_run_214_spec_388 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FUN _menhir_cell0_LPAR, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_389 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState388 _tok
  
  and _menhir_run_214_spec_057 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TILD _menhir_cell0_VAR, ttv_result) _menhir_cell1_GETS -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState057 _tok
  
  and _menhir_run_214_spec_059 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_GETS -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_377 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState059 _tok
  
  and _menhir_run_214_spec_374 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_optvar, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DO -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState374 _tok
  
  and _menhir_run_214_spec_062 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_optvar -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_373 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState062 _tok
  
  and _menhir_run_214_spec_363 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_STRING -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_364 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState363 _tok
  
  and _menhir_run_214_spec_067 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_361 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState067 _tok
  
  and _menhir_run_214_spec_069 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_BEGIN -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState069 _tok
  
  and _menhir_run_214_spec_356 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState356 _tok
  
  and _menhir_run_214_spec_352 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_subfield, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState352 _tok
  
  and _menhir_run_214_spec_345 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_varlpar, ttv_result) _menhir_cell1_arglist _menhir_cell0_RPAR, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState345 _tok
  
  and _menhir_run_214_spec_318 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_pattern -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_319 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState318 _tok
  
  and _menhir_run_214_spec_315 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_subfield -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_316 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState315 _tok
  
  and _menhir_run_214_spec_312 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_313 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState312 _tok
  
  and _menhir_run_214_spec_300 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_binding, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState300 _tok
  
  and _menhir_run_214_spec_297 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_s -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState297 _tok
  
  and _menhir_run_214_spec_291 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_record _menhir_cell0_VAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_292 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState291 _tok
  
  and _menhir_run_214_spec_281 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT _menhir_cell0_VARLBRA -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState281 _tok
  
  and _menhir_run_282 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT _menhir_cell0_VARLBRA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | TO ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState282
      | TIMES ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState282
      | SET ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState282
      | RBRA ->
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_VARLBRA (_menhir_stack, _3, _, _endpos__3_) = _menhir_stack in
          let MenhirCell1_DOT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_092 _1 _3 _4 _endpos__3_ _endpos__5_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState282
      | MINUS ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState282
      | DOT ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState282
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState282
      | COALESCE ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState282
      | BINB _v_1 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_242 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState282
      | BIN3 _v_2 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_236 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState282
      | BIN2 _v_3 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_244 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState282
      | BIN1 _v_4 ->
          let _menhir_stack = MenhirCell1_expr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          _menhir_run_246 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState282
      | _ ->
          _eRR ()
  
  and _menhir_run_214_spec_277 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_app_list_elem -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState277 _tok
  
  and _menhir_run_214_spec_224 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT _menhir_cell0_VARLPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState224 _tok
  
  and _menhir_run_214_spec_246 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN1 -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_247 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState246 _tok
  
  and _menhir_run_214_spec_244 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN2 -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState244 _tok
  
  and _menhir_run_214_spec_242 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BINB -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState242 _tok
  
  and _menhir_run_214_spec_240 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COALESCE -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState240 _tok
  
  and _menhir_run_214_spec_238 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_QUESTION, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLON -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
  
  and _menhir_run_239 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_QUESTION, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLON -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let MenhirCell1_COLON (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _, _3, _startpos__3_, _endpos__3_) = _menhir_stack in
      let MenhirCell1_QUESTION (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      let (_5, _endpos__5_, _startpos__5_) = (_v, _endpos, _startpos) in
      let _v = _menhir_action_104 _1 _3 _5 _endpos__1_ _endpos__3_ _endpos__5_ _startpos__1_ _startpos__3_ _startpos__5_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_214_spec_236 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN3 -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState236 _tok
  
  and _menhir_run_214_spec_234 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLONCOLON -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState234 _tok
  
  and _menhir_run_214_spec_232 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_MINUS -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState232 _tok
  
  and _menhir_run_214_spec_230 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_QUESTION -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState230 _tok
  
  and _menhir_run_214_spec_228 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_SET -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState228 _tok
  
  and _menhir_run_214_spec_226 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState226 _tok
  
  and _menhir_run_214_spec_221 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_TIMES -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState221 _tok
  
  and _menhir_run_214_spec_219 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_TO -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState219 _tok
  
  and _menhir_run_214_spec_217 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_optvar -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState217 _tok
  
  and _menhir_run_214_spec_213 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_pattern, ttv_result) _menhir_cell1_ty _menhir_cell0_RPAR, ttv_result) _menhir_cell1_g -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_078 _1 _endpos__1_ _startpos__1_ in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState213 _tok
  
  and _menhir_run_215_spec_044 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRA -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_414 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState044 _tok
  
  and _menhir_run_287 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT _menhir_cell0_LCUR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | RCUR ->
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LCUR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_DOT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          let (_4, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_084 _1 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | COMMA ->
          let _menhir_stack = MenhirCell1_record (_menhir_stack, _menhir_s, _v) in
          _menhir_run_289 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_215_spec_043 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_417 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState043 _tok
  
  and _menhir_run_215_spec_041 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LCUR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_423 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState041 _tok
  
  and _menhir_goto_inner_tuple : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState430 ->
          _menhir_run_431 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState039 ->
          _menhir_run_426 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_431 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COMMA -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_expr (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_134 _1 _3 in
      _menhir_goto_inner_tuple _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_426 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_083 _2 _endpos__3_ _startpos__1_ in
      _menhir_goto_expr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_215_spec_430 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COMMA -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_432 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState430 _tok
  
  and _menhir_run_215_spec_039 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_428 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState039 _tok
  
  and _menhir_run_215_spec_037 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_OPEN -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_437 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState037 _tok
  
  and _menhir_run_215_spec_244 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN2 -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_245 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState244 _tok
  
  and _menhir_run_215_spec_030 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UMINUS _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_451 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState030 _tok
  
  and _menhir_run_215_spec_236 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BIN3 -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_237 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState236 _tok
  
  and _menhir_run_215_spec_242 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_BINB -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_243 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState242 _tok
  
  and _menhir_run_215_spec_240 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COALESCE -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_241 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState240 _tok
  
  and _menhir_run_215_spec_217 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_optvar -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_218 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState217 _tok
  
  and _menhir_run_215_spec_443 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TRY, ttv_result) _menhir_cell1_exprs, ttv_result) _menhir_cell1_optvar -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState443 _tok
  
  and _menhir_run_102_spec_124 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DEF, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_219 _1
      in
      let _1 = _v in
      let _v = _menhir_action_159 _1 in
      _menhir_run_125 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState124 _tok
  
  and _menhir_run_102_spec_307 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1__let, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_219 _1
      in
      let _1 = _v in
      let _v = _menhir_action_159 _1 in
      _menhir_run_308 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState307 _tok
  
  and _menhir_run_102_spec_081 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_219 _1
      in
      let _1 = _v in
      let _v = _menhir_action_159 _1 in
      _menhir_run_117 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_102_spec_088 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_219 _1
      in
      let _1 = _v in
      let _v = _menhir_action_159 _1 in
      _menhir_run_107_spec_088 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_102_spec_089 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRA -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_219 _1
      in
      let _1 = _v in
      let _v = _menhir_action_159 _1 in
      _menhir_run_107_spec_089 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_102_spec_111 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_pattern_list -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_219 _1
      in
      let _1 = _v in
      let _v = _menhir_action_159 _1 in
      _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_102_spec_113 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_pattern_list, ttv_result) _menhir_cell1_spread -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_219 _1
      in
      let _1 = _v in
      let _v = _menhir_action_159 _1 in
      _menhir_run_107_spec_113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_102_spec_097 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRA, ttv_result) _menhir_cell1_spread -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_219 _1
      in
      let _1 = _v in
      let _v = _menhir_action_159 _1 in
      _menhir_run_107_spec_097 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_102_spec_100 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_pattern_list -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _v =
        let _1 = _v in
        _menhir_action_219 _1
      in
      let _1 = _v in
      let _v = _menhir_action_159 _1 in
      _menhir_run_101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_215_spec_460 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_WHILE, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DO -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState460 _tok
  
  and _menhir_run_215_spec_234 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLONCOLON -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_235 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState234 _tok
  
  and _menhir_run_215_spec_232 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_MINUS -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_233 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState232 _tok
  
  and _menhir_run_215_spec_238 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_QUESTION, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_COLON -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_239 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
  
  and _menhir_run_215_spec_230 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_QUESTION -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_231 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState230 _tok
  
  and _menhir_run_215_spec_228 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_SET -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_229 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState228 _tok
  
  and _menhir_run_215_spec_226 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_227 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState226 _tok
  
  and _menhir_run_215_spec_224 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT _menhir_cell0_VARLPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState224 _tok
  
  and _menhir_run_215_spec_281 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_DOT _menhir_cell0_VARLBRA -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_282 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState281 _tok
  
  and _menhir_run_215_spec_221 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_TIMES -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_222 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState221 _tok
  
  and _menhir_run_215_spec_219 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_expr, ttv_result) _menhir_cell1_TO -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_220 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState219 _tok
  
  and _menhir_run_215_spec_027 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VARLBRA -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_455 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState027 _tok
  
  and _menhir_run_215_spec_026 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_VARLPAR -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_275 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState026 _tok
  
  and _menhir_run_215_spec_025 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_WHILE -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_459 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState025 _tok
  
  let rec _menhir_run_215_spec_023 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> _ -> _menhir_box_interactive =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState023 _tok
  
  let rec _menhir_run_023 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_interactive =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | VAR _v ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | UNDERSCORE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState023 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | TIME _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_023 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState023 _tok
      | REGEXP _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState023 _tok
      | OPEN ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | LETLBRA _v ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | LET _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos, _v) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState023 _tok
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | INTERVAL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_023 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState023 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | FLOAT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState023 _tok
      | EOF ->
          let _v = _menhir_action_137 () in
          MenhirBox_interactive _v
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | DEF _v ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState023
      | BOOL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState023 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState023
      | _ ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_135 _endpos__1_ _startpos__1_ in
          MenhirBox_interactive _v
  
  let rec _menhir_run_215_spec_467 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> _ -> _menhir_box_program =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_111 _1 in
      _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState467 _tok
  
  let rec _menhir_run_467 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_program =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WHILE ->
          _menhir_run_025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | VARLPAR _v ->
          _menhir_run_026 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState467
      | VARLBRA _v ->
          _menhir_run_027 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState467
      | VAR _v ->
          _menhir_run_032 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState467
      | UNDERSCORE ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_158 () in
          _menhir_run_216 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState467 _tok
      | UMINUS ->
          _menhir_run_029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | TRY ->
          _menhir_run_031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | TIME _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_467 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | STRING _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_076 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState467 _tok
      | REGEXP _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_103 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState467 _tok
      | OPEN ->
          _menhir_run_037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | NOT ->
          _menhir_run_038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | LPAR ->
          _menhir_run_039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | LETLBRA _v ->
          _menhir_run_048 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState467
      | LET _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_startpos__1_, _1) = (_startpos, _v) in
          let _v = _menhir_action_005 _1 in
          _menhir_run_302 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v MenhirState467 _tok
      | LCUR ->
          _menhir_run_041 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | LBRA ->
          _menhir_run_044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | INTERVAL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_215_spec_467 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | INT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_072 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState467 _tok
      | IF ->
          _menhir_run_047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | GET ->
          _menhir_run_051 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | FUN ->
          _menhir_run_052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | FOR ->
          _menhir_run_060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | FLOAT _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_075 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState467 _tok
      | EOF ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _v =
            let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
            _menhir_action_172 _endpos__1_ _startpos__1_
          in
          MenhirBox_program _v
      | ENCODER _v ->
          _menhir_run_064 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState467
      | DEF _v ->
          _menhir_run_071 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState467
      | BOOL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_074 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_295 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v MenhirState467 _tok
      | BEGIN ->
          _menhir_run_069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState467
      | _ ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_171 _endpos__1_ _startpos__1_ in
          MenhirBox_program _v
  
  let rec _menhir_run_476_spec_473 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_time_predicate =
    fun _menhir_stack _v ->
      MenhirBox_time_predicate _v
  
  let rec _menhir_run_473 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_time_predicate =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | TIME _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_187 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_476_spec_473 _menhir_stack _v
      | INTERVAL _v ->
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_186 _1 _endpos__1_ _startpos__1_ in
          _menhir_run_476_spec_473 _menhir_stack _v
      | _ ->
          _eRR ()
  
end

let time_predicate =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_time_predicate v = _menhir_run_473 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let program =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_program v = _menhir_run_467 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let interactive =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_interactive v = _menhir_run_023 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let annotate_metadata_entry =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_annotate_metadata_entry v = _menhir_run_017 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let annotate =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_annotate v = _menhir_run_000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
